/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* AArch64PreLegalizerCombinerImpl Combiner Match Table                       *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GICOMBINER_DEPS
#include "llvm/ADT/SparseBitVector.h"
namespace llvm {
extern cl::OptionCategory GICombinerOptionCategory;
} // end namespace llvm
#endif // ifdef GET_GICOMBINER_DEPS

#ifdef GET_GICOMBINER_TYPES
struct AArch64PreLegalizerCombinerImplRuleConfig {
  SparseBitVector<> DisabledRules;

  bool isRuleEnabled(unsigned RuleID) const;
  bool parseCommandLineOption();
  bool setRuleEnabled(StringRef RuleIdentifier);
  bool setRuleDisabled(StringRef RuleIdentifier);
};

static std::optional<uint64_t> getRuleIdxForIdentifier(StringRef RuleIdentifier) {
  uint64_t I;
  // getAtInteger(...) returns false on success
  bool Parsed = !RuleIdentifier.getAsInteger(0, I);
  if (Parsed)
    return I;

#ifndef NDEBUG
  switch (RuleIdentifier.size()) {
  default: break;
  case 9:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "opy_prop", 8) != 0)
        break;
      return 13;	 // "copy_prop"
    case 'm':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_ors", 7) != 0)
          break;
        return 194;	 // "match_ors"
      case 'u':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "lo_by_", 6) != 0)
          break;
        switch (RuleIdentifier[8]) {
        default: break;
        case '0':	 // 1 string to match.
          return 144;	 // "mulo_by_0"
        case '2':	 // 1 string to match.
          return 143;	 // "mulo_by_2"
        }
        break;
      }
      break;
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "neg_zext", 8) != 0)
        break;
      return 199;	 // "nneg_zext"
    }
    break;
  case 10:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2p_to_p2i", 9) != 0)
        break;
      return 89;	 // "i2p_to_p2i"
    case 'm':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_ands", 8) != 0)
          break;
        return 193;	 // "match_ands"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_to_shl", 8) != 0)
          break;
        return 14;	 // "mul_to_shl"
      }
      break;
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2i_to_i2p", 9) != 0)
        break;
      return 88;	 // "p2i_to_i2p"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "xt_trunc", 8) != 0)
          break;
        return 197;	 // "sext_trunc"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "b_to_add", 8) != 0)
          break;
        return 15;	 // "sub_to_add"
      }
      break;
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_trunc", 9) != 0)
        break;
      return 198;	 // "zext_trunc"
    }
    break;
  case 11:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dd_sub_reg", 10) != 0)
        break;
      return 94;	 // "add_sub_reg"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_addos", 10) != 0)
        break;
      return 213;	 // "match_addos"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ub_add_reg", 10) != 0)
        break;
      return 188;	 // "sub_add_reg"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_shift", 10) != 0)
        break;
      return 131;	 // "trunc_shift"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_cst", 10) != 0)
        break;
      return 207;	 // "unmerge_cst"
    }
    break;
  case 12:	 // 11 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "PlusBMinusB", 11) != 0)
        break;
      return 2;	 // "APlusBMinusB"
    case 'B':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "MinusAPlusA", 11) != 0)
        break;
      return 3;	 // "BMinusAPlusA"
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dde_to_addo", 11) != 0)
        break;
      return 145;	 // "adde_to_addo"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "sub_to_fneg", 11) != 0)
        break;
      return 190;	 // "fsub_to_fneg"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ulh_to_lshr", 11) != 0)
        break;
      return 171;	 // "mulh_to_lshr"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ot_cmp_fold", 11) != 0)
        break;
      return 132;	 // "not_cmp_fold"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_or", 11) != 0)
        break;
      return 127;	 // "redundant_or"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_pow2", 10) != 0)
          break;
        return 185;	 // "sdiv_by_pow2"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "xt_of_sext", 10) != 0)
          break;
        return 48;	 // "sext_of_sext"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "div_by_pow2", 11) != 0)
        break;
      return 184;	 // "udiv_by_pow2"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_zext", 11) != 0)
        break;
      return 46;	 // "zext_of_zext"
    }
    break;
  case 13:	 // 14 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dd_of_vscale", 12) != 0)
        break;
      return 37;	 // "add_of_vscale"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_shift", 12) != 0)
        break;
      return 161;	 // "commute_shift"
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_and_mask", 12) != 0)
        break;
      return 69;	 // "load_and_mask"
    case 'm':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_selects", 11) != 0)
          break;
        return 124;	 // "match_selects"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "rge_unmerge", 11) != 0)
          break;
        return 206;	 // "merge_unmerge"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_of_vscale", 11) != 0)
          break;
        return 38;	 // "mul_of_vscale"
      }
      break;
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_and", 12) != 0)
        break;
      return 125;	 // "redundant_and"
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_const", 11) != 0)
          break;
        return 187;	 // "sdiv_by_const"
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_of_vscale", 11) != 0)
          break;
        return 39;	 // "shl_of_vscale"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "b_of_vscale", 11) != 0)
          break;
        return 40;	 // "sub_of_vscale"
      }
      break;
    case 'u':	 // 4 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_const", 11) != 0)
          break;
        return 186;	 // "udiv_by_const"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "merge_", 6) != 0)
          break;
        switch (RuleIdentifier[8]) {
        default: break;
        case 'm':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+9, "erge", 4) != 0)
            break;
          return 205;	 // "unmerge_merge"
        case 'u':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+9, "ndef", 4) != 0)
            break;
          return 208;	 // "unmerge_undef"
        }
        break;
      case 'r':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "em_by_const", 11) != 0)
          break;
        return 183;	 // "urem_by_const"
      }
      break;
    }
    break;
  case 14:	 // 15 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'M':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "inusC1PlusC2", 12) != 0)
          break;
        return 12;	 // "AMinusC1PlusC2"
      case 'P':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lusC1MinusC2", 12) != 0)
          break;
        return 8;	 // "APlusC1MinusC2"
      }
      break;
    case 'C':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2MinusAPlusC1", 13) != 0)
        break;
      return 9;	 // "C2MinusAPlusC1"
    case 'a':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_of_", 9) != 0)
        break;
      switch (RuleIdentifier[10]) {
      default: break;
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+11, "ext", 3) != 0)
          break;
        return 52;	 // "anyext_of_sext"
      case 'z':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+11, "ext", 3) != 0)
          break;
        return 51;	 // "anyext_of_zext"
      }
      break;
    case 'b':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'i')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "op_same_val", 11) != 0)
          break;
        return 85;	 // "binop_same_val"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "reverse_shl", 11) != 0)
          break;
        return 159;	 // "bitreverse_shl"
      }
      break;
    case 'f':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "bs_fneg_fold", 12) != 0)
          break;
        return 170;	 // "fabs_fneg_fold"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "eg_fneg_fold", 12) != 0)
          break;
        return 91;	 // "fneg_fneg_fold"
      }
      break;
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ul_by_neg_one", 13) != 0)
        break;
      return 17;	 // "mul_by_neg_one"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eassoc_ptradd", 13) != 0)
        break;
      return 106;	 // "reassoc_ptradd"
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 2 strings to match.
        switch (RuleIdentifier[2]) {
        default: break;
        case 'l':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "ect_of_zext", 11) != 0)
            break;
          return 54;	 // "select_of_zext"
        case 'x':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "t_of_anyext", 11) != 0)
            break;
          return 49;	 // "sext_of_anyext"
        }
        break;
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ifts_too_big", 12) != 0)
          break;
        return 105;	 // "shifts_too_big"
      }
      break;
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_anyext", 13) != 0)
        break;
      return 47;	 // "zext_of_anyext"
    }
    break;
  case 15:	 // 12 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'M':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "inusC1MinusC2", 13) != 0)
          break;
        return 10;	 // "AMinusC1MinusC2"
      case 'P':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lusZeroMinusB", 13) != 0)
          break;
        return 1;	 // "APlusZeroMinusB"
      }
      break;
    case 'C':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "1Minus2MinusC2", 14) != 0)
        break;
      return 11;	 // "C1Minus2MinusC2"
    case 'Z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eroMinusAPlusB", 14) != 0)
        break;
      return 0;	 // "ZeroMinusAPlusB"
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itreverse_lshr", 14) != 0)
        break;
      return 160;	 // "bitreverse_lshr"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtending_loads", 14) != 0)
        break;
      return 68;	 // "extending_loads"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dempotent_prop", 14) != 0)
        break;
      return 18;	 // "idempotent_prop"
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_or_combine", 14) != 0)
        break;
      return 152;	 // "load_or_combine"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_or", 14) != 0)
        break;
      return 62;	 // "narrow_binop_or"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "verlapping_and", 14) != 0)
        break;
      return 142;	 // "overlapping_and"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_same_val", 14) != 0)
        break;
      return 83;	 // "select_same_val"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_trunc_fold", 14) != 0)
        break;
      return 129;	 // "zext_trunc_fold"
    }
    break;
  case 16:	 // 12 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_of_anyext", 15) != 0)
        break;
      return 50;	 // "anyext_of_anyext"
    case 'n':	 // 5 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_", 12) != 0)
        break;
      switch (RuleIdentifier[13]) {
      default: break;
      case 'a':	 // 2 strings to match.
        switch (RuleIdentifier[14]) {
        default: break;
        case 'd':	 // 1 string to match.
          if (RuleIdentifier[15] != 'd')
            break;
          return 58;	 // "narrow_binop_add"
        case 'n':	 // 1 string to match.
          if (RuleIdentifier[15] != 'd')
            break;
          return 61;	 // "narrow_binop_and"
        }
        break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "ul", 2) != 0)
          break;
        return 60;	 // "narrow_binop_mul"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "ub", 2) != 0)
          break;
        return 59;	 // "narrow_binop_sub"
      case 'x':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "or", 2) != 0)
          break;
        return 63;	 // "narrow_binop_xor"
      }
      break;
    case 's':	 // 3 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_", 6) != 0)
        break;
      switch (RuleIdentifier[7]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "f_anyext", 8) != 0)
          break;
        return 55;	 // "select_of_anyext"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "o_minmax", 8) != 0)
          break;
        return 189;	 // "select_to_minmax"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "ndef_cmp", 8) != 0)
          break;
        return 121;	 // "select_undef_cmp"
      }
      break;
    case 't':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "runcate_of_", 11) != 0)
        break;
      switch (RuleIdentifier[12]) {
      default: break;
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+13, "ext", 3) != 0)
          break;
        return 44;	 // "truncate_of_sext"
      case 'z':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+13, "ext", 3) != 0)
          break;
        return 43;	 // "truncate_of_zext"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ndef_to_fp_zero", 15) != 0)
        break;
      return 71;	 // "undef_to_fp_zero"
    }
    break;
  case 17:	 // 14 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "PlusBMinus", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'A':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "plusC", 5) != 0)
          break;
        return 6;	 // "APlusBMinusAplusC"
      case 'C':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "PlusA", 5) != 0)
          break;
        return 7;	 // "APlusBMinusCPlusA"
      }
      break;
    case 'a':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "d_p2i_to_ptradd", 15) != 0)
          break;
        return 16;	 // "add_p2i_to_ptradd"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "yext_trunc_fold", 15) != 0)
          break;
        return 90;	 // "anyext_trunc_fold"
      }
      break;
    case 'c':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "nonicalize_", 11) != 0)
          break;
        switch (RuleIdentifier[13]) {
        default: break;
        case 'f':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "cmp", 3) != 0)
            break;
          return 110;	 // "canonicalize_fcmp"
        case 'i':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "cmp", 3) != 0)
            break;
          return 109;	 // "canonicalize_icmp"
        }
        break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "nstant_fold_fma", 15) != 0)
          break;
        return 168;	 // "constant_fold_fma"
      }
      break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "iv_rem_to_divrem", 16) != 0)
        break;
      return 153;	 // "div_rem_to_divrem"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "rase_undef_store", 16) != 0)
        break;
      return 81;	 // "erase_undef_store"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "tr_add_with_zero", 16) != 0)
        break;
      return 149;	 // "ptr_add_with_zero"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lect_to_iminmax", 15) != 0)
          break;
        return 123;	 // "select_to_iminmax"
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ift_immed_chain", 15) != 0)
          break;
        return 150;	 // "shift_immed_chain"
      }
      break;
    case 'u':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "def_to_int_zero", 15) != 0)
          break;
        return 72;	 // "undef_to_int_zero"
      case 'r':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "em_pow2_to_mask", 15) != 0)
          break;
        return 128;	 // "urem_pow2_to_mask"
      }
      break;
    }
    break;
  case 18:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "MinusBPlus", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'B':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "MinusC", 6) != 0)
          break;
        return 5;	 // "AMinusBPlusBMinusC"
      case 'C':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "MinusA", 6) != 0)
          break;
        return 4;	 // "AMinusBPlusCMinusA"
      }
      break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_to_zero", 17) != 0)
        break;
      return 86;	 // "binop_left_to_zero"
    case 'c':	 // 3 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_minmax_nan", 15) != 0)
          break;
        return 146;	 // "combine_minmax_nan"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_f", 12) != 0)
          break;
        switch (RuleIdentifier[15]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+16, "bs", 2) != 0)
            break;
          return 135;	 // "constant_fold_fabs"
        case 'n':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+16, "eg", 2) != 0)
            break;
          return 134;	 // "constant_fold_fneg"
        }
        break;
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xpand_const_fpowi", 17) != 0)
        break;
      return 147;	 // "expand_const_fpowi"
    case 'f':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ld_global_offset", 16) != 0)
          break;
        return 217;	 // "fold_global_offset"
      case 'p':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "trunc_fpext_fold", 16) != 0)
          break;
        return 99;	 // "fptrunc_fpext_fold"
      }
      break;
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 2 strings to match.
        switch (RuleIdentifier[2]) {
        default: break;
        case 'l':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "ect_of_truncate", 15) != 0)
            break;
          return 56;	 // "select_of_truncate"
        case 'x':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "t_inreg_of_load", 15) != 0)
            break;
          return 118;	 // "sext_inreg_of_load"
        }
        break;
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "uffle_to_extract", 16) != 0)
          break;
        return 218;	 // "shuffle_to_extract"
      }
      break;
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runcate_of_anyext", 17) != 0)
        break;
      return 45;	 // "truncate_of_anyext"
    }
    break;
  case 19:	 // 16 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_to_zero", 18) != 0)
        break;
      return 87;	 // "binop_right_to_zero"
    case 'c':	 // 4 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "onst", 4) != 0)
        break;
      switch (RuleIdentifier[5]) {
      default: break;
      case '_':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+6, "ptradd_to_i2p", 13) != 0)
          break;
        return 141;	 // "const_ptradd_to_i2p"
      case 'a':	 // 3 strings to match.
        if (memcmp(RuleIdentifier.data()+6, "nt_fold_", 8) != 0)
          break;
        switch (RuleIdentifier[14]) {
        default: break;
        case 'b':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "inop", 4) != 0)
            break;
          return 166;	 // "constant_fold_binop"
        case 'f':	 // 2 strings to match.
          switch (RuleIdentifier[15]) {
          default: break;
          case 'l':	 // 1 string to match.
            if (memcmp(RuleIdentifier.data()+16, "og2", 3) != 0)
              break;
            return 137;	 // "constant_fold_flog2"
          case 's':	 // 1 string to match.
            if (memcmp(RuleIdentifier.data()+16, "qrt", 3) != 0)
              break;
            return 136;	 // "constant_fold_fsqrt"
          }
          break;
        }
        break;
      }
      break;
    case 'e':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "xt", 2) != 0)
        break;
      switch (RuleIdentifier[3]) {
      default: break;
      case '_':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "uaddv_to_uaddlv", 15) != 0)
          break;
        return 220;	 // "ext_uaddv_to_uaddlv"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "nd_through_phis", 15) != 0)
          break;
        return 102;	 // "extend_through_phis"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nteger_of_truncate", 18) != 0)
        break;
      return 64;	 // "integer_of_truncate"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_of_x_and_zero", 18) != 0)
        break;
      return 212;	 // "merge_of_x_and_zero"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "tr_add_immed_chain", 18) != 0)
        break;
      return 108;	 // "ptr_add_immed_chain"
    case 'r':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "assoc_comm_binops", 17) != 0)
          break;
        return 107;	 // "reassoc_comm_binops"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ght_identity_zero", 17) != 0)
          break;
        return 84;	 // "right_identity_zero"
      }
      break;
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lect_constant_cmp", 17) != 0)
          break;
        return 122;	 // "select_constant_cmp"
      case 'i':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "mplify_", 7) != 0)
          break;
        switch (RuleIdentifier[9]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+10, "dd_to_sub", 9) != 0)
            break;
          return 103;	 // "simplify_add_to_sub"
        case 'n':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+10, "eg_minmax", 9) != 0)
            break;
          return 195;	 // "simplify_neg_minmax"
        }
        break;
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nary_undef_to_zero", 18) != 0)
        break;
      return 76;	 // "unary_undef_to_zero"
    }
    break;
  case 20:	 // 8 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nd_or_disjoint_mask", 19) != 0)
        break;
      return 173;	 // "and_or_disjoint_mask"
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itcast_bitcast_fold", 19) != 0)
        break;
      return 98;	 // "bitcast_bitcast_fold"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_redundant_trunc", 19) != 0)
        break;
      return 216;	 // "icmp_redundant_trunc"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_of_x_and_undef", 19) != 0)
        break;
      return 211;	 // "merge_of_x_and_undef"
    case 'r':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "edu", 3) != 0)
        break;
      switch (RuleIdentifier[4]) {
      default: break;
      case 'c':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+5, "e_shl_of_extend", 15) != 0)
          break;
        return 119;	 // "reduce_shl_of_extend"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+5, "dant_sext_inreg", 15) != 0)
          break;
        return 126;	 // "redundant_sext_inreg"
      }
      break;
    case 'u':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'n')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ry_undef_to_undef", 17) != 0)
          break;
        return 77;	 // "unary_undef_to_undef"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "erge_zext_to_zext", 17) != 0)
          break;
        return 210;	 // "unmerge_zext_to_zext"
      }
      break;
    }
    break;
  case 21:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 3 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_concat_vector", 18) != 0)
          break;
        return 196;	 // "combine_concat_vector"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_", 11) != 0)
          break;
        switch (RuleIdentifier[14]) {
        default: break;
        case 'c':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "ast_op", 6) != 0)
            break;
          return 169;	 // "constant_fold_cast_op"
        case 'f':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "ptrunc", 6) != 0)
            break;
          return 138;	 // "constant_fold_fptrunc"
        }
        break;
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xt_addv_to_udot_addv", 20) != 0)
        break;
      return 219;	 // "ext_addv_to_udot_addv"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "constant_to_constant", 20) != 0)
        break;
      return 215;	 // "fconstant_to_constant"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nsert_vector_elt_oob", 20) != 0)
        break;
      return 24;	 // "insert_vector_elt_oob"
    case 'p':	 // 4 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ush_", 4) != 0)
        break;
      switch (RuleIdentifier[5]) {
      default: break;
      case 'a':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+6, "dd_through_", 11) != 0)
          break;
        switch (RuleIdentifier[17]) {
        default: break;
        case 's':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+18, "ext", 3) != 0)
            break;
          return 224;	 // "push_add_through_sext"
        case 'z':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+18, "ext", 3) != 0)
            break;
          return 222;	 // "push_add_through_zext"
        }
        break;
      case 's':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+6, "ub_through_", 11) != 0)
          break;
        switch (RuleIdentifier[17]) {
        default: break;
        case 's':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+18, "ext", 3) != 0)
            break;
          return 223;	 // "push_sub_through_sext"
        case 'z':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+18, "ext", 3) != 0)
            break;
          return 221;	 // "push_sub_through_zext"
        }
        break;
      }
      break;
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_one_fp", 20) != 0)
        break;
      return 93;	 // "right_identity_one_fp"
    case 'u':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'n')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ef_to_negative_one", 18) != 0)
          break;
        return 73;	 // "undef_to_negative_one"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "erge_dead_to_trunc", 18) != 0)
          break;
        return 209;	 // "unmerge_dead_to_trunc"
      }
      break;
    }
    break;
  case 22:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_shuffle_concat", 19) != 0)
          break;
        return 200;	 // "combine_shuffle_concat"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_fp_binop", 19) != 0)
          break;
        return 167;	 // "constant_fold_fp_binop"
      }
      break;
    case 'f':	 // 4 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ld_binop_into_select", 20) != 0)
          break;
        return 182;	 // "fold_binop_into_select"
      case 'u':	 // 3 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "nnel_shift_", 11) != 0)
          break;
        switch (RuleIdentifier[13]) {
        default: break;
        case 'l':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "eft_zero", 8) != 0)
            break;
          return 157;	 // "funnel_shift_left_zero"
        case 'o':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "vershift", 8) != 0)
            break;
          return 158;	 // "funnel_shift_overshift"
        case 't':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "o_rotate", 8) != 0)
            break;
          return 155;	 // "funnel_shift_to_rotate"
        }
        break;
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_to_lhs_known_bits", 21) != 0)
        break;
      return 112;	 // "icmp_to_lhs_known_bits"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_subo_no_overflow", 21) != 0)
        break;
      return 214;	 // "match_subo_no_overflow"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_any_op", 21) != 0)
        break;
      return 78;	 // "propagate_undef_any_op"
    case 'r':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "dundant_neg_operands", 20) != 0)
          break;
        return 172;	 // "redundant_neg_operands"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ght_identity_one_int", 20) != 0)
          break;
        return 92;	 // "right_identity_one_int"
      }
      break;
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "hl_ashr_to_sext_inreg", 21) != 0)
        break;
      return 116;	 // "shl_ashr_to_sext_inreg"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_buildvector_fold", 21) != 0)
        break;
      return 96;	 // "trunc_buildvector_fold"
    }
    break;
  case 23:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "uildvector_of_truncate", 22) != 0)
        break;
      return 57;	 // "buildvector_of_truncate"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "unnel_shift_right_zero", 22) != 0)
        break;
      return 156;	 // "funnel_shift_right_zero"
    case 'i':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "tof_const_zero_fold_", 20) != 0)
        break;
      switch (RuleIdentifier[21]) {
      default: break;
      case 's':	 // 1 string to match.
        if (RuleIdentifier[22] != 'i')
          break;
        return 139;	 // "itof_const_zero_fold_si"
      case 'u':	 // 1 string to match.
        if (RuleIdentifier[22] != 'i')
          break;
        return 140;	 // "itof_const_zero_fold_ui"
      }
      break;
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_all_ops", 22) != 0)
        break;
      return 79;	 // "propagate_undef_all_ops"
    }
    break;
  case 24:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_undef_to_zero", 23) != 0)
        break;
      return 74;	 // "binop_left_undef_to_zero"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element", 23) != 0)
        break;
      return 23;	 // "match_extract_of_element"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_feeding_and", 23) != 0)
        break;
      return 120;	 // "narrow_binop_feeding_and"
    case 's':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_inreg_", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "f_sext_inreg", 12) != 0)
          break;
        return 53;	 // "sext_inreg_of_sext_inreg"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "o_zext_inreg", 12) != 0)
          break;
        return 130;	 // "sext_inreg_to_zext_inreg"
      }
      break;
    case 'x':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "or_of_and_with_same_reg", 23) != 0)
        break;
      return 148;	 // "xor_of_and_with_same_reg"
    }
    break;
  case 25:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'i':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "tfield_extract_from_", 20) != 0)
          break;
        switch (RuleIdentifier[22]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+23, "nd", 2) != 0)
            break;
          return 163;	 // "bitfield_extract_from_and"
        case 's':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+23, "hr", 2) != 0)
            break;
          return 164;	 // "bitfield_extract_from_shr"
        }
        break;
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ildvector_identity_fold", 23) != 0)
          break;
        return 95;	 // "buildvector_identity_fold"
      }
      break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_shuffle_undef_rhs", 24) != 0)
        break;
      return 201;	 // "combine_shuffle_undef_rhs"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vec_elt_build_vec", 24) != 0)
        break;
      return 66;	 // "extract_vec_elt_build_vec"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eg_and_one_to_sext_inreg", 24) != 0)
        break;
      return 117;	 // "neg_and_one_to_sext_inreg"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_one_fp", 24) != 0)
        break;
      return 101;	 // "right_identity_neg_one_fp"
    }
    break;
  case 26:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_undef_to_undef", 25) != 0)
        break;
      return 75;	 // "binop_right_undef_to_undef"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_fp_constant_to_rhs", 25) != 0)
        break;
      return 192;	 // "commute_fp_constant_to_rhs"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "unnel_shift_from_or_shift", 25) != 0)
        break;
      return 154;	 // "funnel_shift_from_or_shift"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_zero_fp", 25) != 0)
        break;
      return 100;	 // "right_identity_neg_zero_fp"
    }
    break;
  case 27:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "om", 2) != 0)
        break;
      switch (RuleIdentifier[3]) {
      default: break;
      case 'b':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ine_use_vector_truncate", 23) != 0)
          break;
        return 203;	 // "combine_use_vector_truncate"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ute_int_constant_to_rhs", 23) != 0)
          break;
        return 191;	 // "commute_int_constant_to_rhs"
      }
      break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ouble_icmp_zero_or_combine", 26) != 0)
        break;
      return 114;	 // "double_icmp_zero_or_combine"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_binop_in_equality", 26) != 0)
        break;
      return 115;	 // "redundant_binop_in_equality"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_lshr_buildvector_fold", 26) != 0)
        break;
      return 97;	 // "trunc_lshr_buildvector_fold"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_anyext_build_vector", 26) != 0)
        break;
      return 204;	 // "unmerge_anyext_build_vector"
    }
    break;
  case 28:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ouble_icmp_zero_and_combine", 27) != 0)
        break;
      return 113;	 // "double_icmp_zero_and_combine"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "pt_brcond_by_inverting_cond", 27) != 0)
        break;
      return 133;	 // "opt_brcond_by_inverting_cond"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_shuffle_mask", 27) != 0)
        break;
      return 80;	 // "propagate_undef_shuffle_mask"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "hift_of_shifted_logic_chain", 27) != 0)
        break;
      return 151;	 // "shift_of_shifted_logic_chain"
    }
    break;
  case 29:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itfield_extract_from_shr_and", 28) != 0)
        break;
      return 165;	 // "bitfield_extract_from_shr_and"
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_", 7) != 0)
        break;
      switch (RuleIdentifier[8]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "xtracted_vector_load", 20) != 0)
          break;
        return 70;	 // "combine_extracted_vector_load"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "huffle_disjoint_mask", 20) != 0)
          break;
        return 202;	 // "combine_shuffle_disjoint_mask"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_to_true_false_known_bits", 28) != 0)
        break;
      return 111;	 // "icmp_to_true_false_known_bits"
    }
    break;
  case 30:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "freeze_of_non_undef_non_poison", 30) != 0)
      break;
    return 41;	 // "freeze_of_non_undef_non_poison"
  case 31:	 // 2 strings to match.
    if (memcmp(RuleIdentifier.data()+0, "insert_vector_element_", 22) != 0)
      break;
    switch (RuleIdentifier[22]) {
    default: break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+23, "lt_undef", 8) != 0)
        break;
      return 22;	 // "insert_vector_element_elt_undef"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+23, "dx_undef", 8) != 0)
        break;
      return 21;	 // "insert_vector_element_idx_undef"
    }
    break;
  case 32:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itfield_extract_from_sext_inreg", 31) != 0)
        break;
      return 162;	 // "bitfield_extract_from_sext_inreg"
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_f", 8) != 0)
        break;
      switch (RuleIdentifier[9]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+10, "dd_fmul_to_fmad_or_fma", 22) != 0)
          break;
        return 174;	 // "combine_fadd_fmul_to_fmad_or_fma"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+10, "ub_fmul_to_fmad_or_fma", 22) != 0)
          break;
        return 178;	 // "combine_fsub_fmul_to_fmad_or_fma"
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_not_const", 31) != 0)
        break;
      return 25;	 // "extract_vector_element_not_const"
    }
    break;
  case 34:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_all_elts_from_build_vector", 34) != 0)
      break;
    return 67;	 // "extract_all_elts_from_build_vector"
  case 35:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_vector_element_build_vector", 35) != 0)
      break;
    return 27;	 // "extract_vector_element_build_vector"
  case 36:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_", 7) != 0)
        break;
      switch (RuleIdentifier[8]) {
      default: break;
      case 'f':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "add_fma_fmul_to_fmad_or_fma", 27) != 0)
          break;
        return 176;	 // "combine_fadd_fma_fmul_to_fmad_or_fma"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "nsert_vec_elts_build_vector", 27) != 0)
          break;
        return 65;	 // "combine_insert_vec_elts_build_vector"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nsert_extract_vec_elt_out_of_bounds", 35) != 0)
        break;
      return 82;	 // "insert_extract_vec_elt_out_of_bounds"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element_undef_index", 35) != 0)
        break;
      return 20;	 // "match_extract_of_element_undef_index"
    }
    break;
  case 37:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_fsub_fneg_fmul_to_fmad_or_fma", 36) != 0)
        break;
      return 179;	 // "combine_fsub_fneg_fmul_to_fmad_or_fma"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_shuffle_vector", 36) != 0)
        break;
      return 35;	 // "extract_vector_element_shuffle_vector"
    case 'h':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oist_logic_op_with_same_opcode_hands", 36) != 0)
        break;
      return 104;	 // "hoist_logic_op_with_same_opcode_hands"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element_undef_vector", 36) != 0)
        break;
      return 19;	 // "match_extract_of_element_undef_vector"
    }
    break;
  case 38:	 // 2 strings to match.
    if (memcmp(RuleIdentifier.data()+0, "combine_f", 9) != 0)
      break;
    switch (RuleIdentifier[9]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+10, "dd_fpext_fmul_to_fmad_or_fma", 28) != 0)
        break;
      return 175;	 // "combine_fadd_fpext_fmul_to_fmad_or_fma"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+10, "ub_fpext_fmul_to_fmad_or_fma", 28) != 0)
        break;
      return 180;	 // "combine_fsub_fpext_fmul_to_fmad_or_fma"
    }
    break;
  case 40:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_vector_element_different_indices", 40) != 0)
      break;
    return 26;	 // "extract_vector_element_different_indices"
  case 42:	 // 8 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_fadd_fpext_fma_fmul_to_fmad_or_fma", 41) != 0)
        break;
      return 177;	 // "combine_fadd_fpext_fma_fmul_to_fmad_or_fma"
    case 'e':	 // 7 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_build_vector_trunc", 40) != 0)
        break;
      switch (RuleIdentifier[41]) {
      default: break;
      case '2':	 // 1 string to match.
        return 28;	 // "extract_vector_element_build_vector_trunc2"
      case '3':	 // 1 string to match.
        return 29;	 // "extract_vector_element_build_vector_trunc3"
      case '4':	 // 1 string to match.
        return 30;	 // "extract_vector_element_build_vector_trunc4"
      case '5':	 // 1 string to match.
        return 31;	 // "extract_vector_element_build_vector_trunc5"
      case '6':	 // 1 string to match.
        return 32;	 // "extract_vector_element_build_vector_trunc6"
      case '7':	 // 1 string to match.
        return 33;	 // "extract_vector_element_build_vector_trunc7"
      case '8':	 // 1 string to match.
        return 34;	 // "extract_vector_element_build_vector_trunc8"
      }
      break;
    }
    break;
  case 43:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "combine_fsub_fpext_fneg_fmul_to_fmad_or_fma", 43) != 0)
      break;
    return 181;	 // "combine_fsub_fpext_fneg_fmul_to_fmad_or_fma"
  case 44:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "insert_vector_element_extract_vector_element", 44) != 0)
      break;
    return 36;	 // "insert_vector_element_extract_vector_element"
  case 46:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "push_freeze_to_prevent_poison_from_propagating", 46) != 0)
      break;
    return 42;	 // "push_freeze_to_prevent_poison_from_propagating"
  }
#endif // ifndef NDEBUG

  return std::nullopt;
}
static std::optional<std::pair<uint64_t, uint64_t>> getRuleRangeForIdentifier(StringRef RuleIdentifier) {
  std::pair<StringRef, StringRef> RangePair = RuleIdentifier.split('-');
  if (!RangePair.second.empty()) {
    const auto First = getRuleIdxForIdentifier(RangePair.first);
    const auto Last = getRuleIdxForIdentifier(RangePair.second);
    if (!First || !Last)
      return std::nullopt;
    if (First >= Last)
      report_fatal_error("Beginning of range should be before end of range");
    return {{*First, *Last + 1}};
  }
  if (RangePair.first == "*") {
    return {{0, 225}};
  }
  const auto I = getRuleIdxForIdentifier(RangePair.first);
  if (!I)
    return std::nullopt;
  return {{*I, *I + 1}};
}

bool AArch64PreLegalizerCombinerImplRuleConfig::setRuleEnabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.reset(I);
  return true;
}

bool AArch64PreLegalizerCombinerImplRuleConfig::setRuleDisabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.set(I);
  return true;
}

static std::vector<std::string> AArch64PreLegalizerCombinerOption;
static cl::list<std::string> AArch64PreLegalizerCombinerDisableOption(
    "aarch64prelegalizercombiner-disable-rule",
    cl::desc("Disable one or more combiner rules temporarily in the AArch64PreLegalizerCombiner pass"),
    cl::CommaSeparated,
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &Str) {
      AArch64PreLegalizerCombinerOption.push_back(Str);
    }));
static cl::list<std::string> AArch64PreLegalizerCombinerOnlyEnableOption(
    "aarch64prelegalizercombiner-only-enable-rule",
    cl::desc("Disable all rules in the AArch64PreLegalizerCombiner pass then re-enable the specified ones"),
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &CommaSeparatedArg) {
      StringRef Str = CommaSeparatedArg;
      AArch64PreLegalizerCombinerOption.push_back("*");
      do {
        auto X = Str.split(",");
        AArch64PreLegalizerCombinerOption.push_back(("!" + X.first).str());
        Str = X.second;
      } while (!Str.empty());
    }));


bool AArch64PreLegalizerCombinerImplRuleConfig::isRuleEnabled(unsigned RuleID) const {
    return  !DisabledRules.test(RuleID);
}
bool AArch64PreLegalizerCombinerImplRuleConfig::parseCommandLineOption() {
  for (StringRef Identifier : AArch64PreLegalizerCombinerOption) {
    bool Enabled = Identifier.consume_front("!");
    if (Enabled && !setRuleEnabled(Identifier))
      return false;
    if (!Enabled && !setRuleDisabled(Identifier))
      return false;
  }
  return true;
}

#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_TYPES
const unsigned MAX_SUBTARGET_PREDICATES = 1;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_CLASS_MEMBERS
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS
#ifdef GET_GICOMBINER_CLASS_MEMBERS
  mutable MatcherState State;
  typedef ComplexRendererFns(AArch64PreLegalizerCombinerImpl::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AArch64PreLegalizerCombinerImpl::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AArch64PreLegalizerCombinerImpl::ComplexMatcherMemFn ComplexPredicateFns[];
  static AArch64PreLegalizerCombinerImpl::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testMOPredicate_MO(unsigned PredicateID, const MachineOperand &MO, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS

#ifdef GET_GICOMBINER_IMPL
// LLT Objects.
enum {
  GILLT_s1,
};
const static size_t NumTypeObjects = 1;
const static LLT TypeObjects[] = {
  LLT::scalar(1),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasDotProdBit = 0,
};

PredicateBitset AArch64PreLegalizerCombinerImpl::
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  return Features;
}

void AArch64PreLegalizerCombinerImpl::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AArch64Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AArch64PreLegalizerCombinerImpl::
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasDotProd,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasDotProdBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

AArch64PreLegalizerCombinerImpl::ComplexMatcherMemFn
AArch64PreLegalizerCombinerImpl::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

enum {
  GICXXPred_MI_Predicate_GICombiner0 = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_GICombiner1,
  GICXXPred_MI_Predicate_GICombiner2,
  GICXXPred_MI_Predicate_GICombiner3,
  GICXXPred_MI_Predicate_GICombiner4,
  GICXXPred_MI_Predicate_GICombiner5,
  GICXXPred_MI_Predicate_GICombiner6,
  GICXXPred_MI_Predicate_GICombiner7,
  GICXXPred_MI_Predicate_GICombiner8,
  GICXXPred_MI_Predicate_GICombiner9,
};
bool AArch64PreLegalizerCombinerImpl::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_GICombiner0: {
    return isGuaranteedNotToBePoison(State.MIs[0]->getOperand(1).getReg(), MRI);
  }
  case GICXXPred_MI_Predicate_GICombiner1: {
    return isGuaranteedNotToBeUndefOrPoison(State.MIs[0]->getOperand(1).getReg(), MRI);
  }
  case GICXXPred_MI_Predicate_GICombiner2: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), 1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner3: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -0.0);
  }
  case GICXXPred_MI_Predicate_GICombiner4: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner5: {
    return State.MIs[1]->getOperand(1).getPredicate() == CmpInst::ICMP_EQ &&
                               !MRI.getType(State.MIs[1]->getOperand(2).getReg()).getScalarType().isPointer() &&
                               (MRI.getType(State.MIs[1]->getOperand(2).getReg()) ==
                                   MRI.getType(State.MIs[2]->getOperand(2).getReg()));
  }
  case GICXXPred_MI_Predicate_GICombiner6: {
    return State.MIs[1]->getOperand(1).getPredicate() == CmpInst::ICMP_NE &&
                               !MRI.getType(State.MIs[1]->getOperand(2).getReg()).getScalarType().isPointer() &&
                               (MRI.getType(State.MIs[1]->getOperand(2).getReg()) ==
                                   MRI.getType(State.MIs[2]->getOperand(2).getReg()));
  }
  case GICXXPred_MI_Predicate_GICombiner7: {
    return MRI.hasOneNonDBGUse(State.MIs[0]->getOperand(2).getReg()) &&
                    Helper.isLegalOrBeforeLegalizer(
                      {TargetOpcode::G_SEXT_INREG, {MRI.getType(State.MIs[1]->getOperand(1).getReg())}});
  }
  case GICXXPred_MI_Predicate_GICombiner8: {
    return Helper.isLegalOrBeforeLegalizer({TargetOpcode::G_LSHR,
                                                           {MRI.getType(State.MIs[2]->getOperand(1).getReg()),
                                                            MRI.getType(State.MIs[1]->getOperand(2).getReg())}});
  }
  case GICXXPred_MI_Predicate_GICombiner9: {
    return Helper.isLegalOrBeforeLegalizer({TargetOpcode::G_SHL,
                                                           {MRI.getType(State.MIs[2]->getOperand(1).getReg()),
                                                            MRI.getType(State.MIs[1]->getOperand(2).getReg())}});
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64PreLegalizerCombinerImpl::testMOPredicate_MO(unsigned PredicateID, const MachineOperand & MO, const MatcherState &State) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64PreLegalizerCombinerImpl::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64PreLegalizerCombinerImpl::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64PreLegalizerCombinerImpl::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
enum {
  GICXXPred_Simple_IsRule0Enabled = GICXXPred_Invalid + 1,
  GICXXPred_Simple_IsRule1Enabled,
  GICXXPred_Simple_IsRule2Enabled,
  GICXXPred_Simple_IsRule3Enabled,
  GICXXPred_Simple_IsRule4Enabled,
  GICXXPred_Simple_IsRule5Enabled,
  GICXXPred_Simple_IsRule6Enabled,
  GICXXPred_Simple_IsRule7Enabled,
  GICXXPred_Simple_IsRule8Enabled,
  GICXXPred_Simple_IsRule9Enabled,
  GICXXPred_Simple_IsRule10Enabled,
  GICXXPred_Simple_IsRule11Enabled,
  GICXXPred_Simple_IsRule12Enabled,
  GICXXPred_Simple_IsRule13Enabled,
  GICXXPred_Simple_IsRule14Enabled,
  GICXXPred_Simple_IsRule15Enabled,
  GICXXPred_Simple_IsRule16Enabled,
  GICXXPred_Simple_IsRule17Enabled,
  GICXXPred_Simple_IsRule18Enabled,
  GICXXPred_Simple_IsRule19Enabled,
  GICXXPred_Simple_IsRule20Enabled,
  GICXXPred_Simple_IsRule21Enabled,
  GICXXPred_Simple_IsRule22Enabled,
  GICXXPred_Simple_IsRule23Enabled,
  GICXXPred_Simple_IsRule24Enabled,
  GICXXPred_Simple_IsRule25Enabled,
  GICXXPred_Simple_IsRule26Enabled,
  GICXXPred_Simple_IsRule27Enabled,
  GICXXPred_Simple_IsRule28Enabled,
  GICXXPred_Simple_IsRule29Enabled,
  GICXXPred_Simple_IsRule30Enabled,
  GICXXPred_Simple_IsRule31Enabled,
  GICXXPred_Simple_IsRule32Enabled,
  GICXXPred_Simple_IsRule33Enabled,
  GICXXPred_Simple_IsRule34Enabled,
  GICXXPred_Simple_IsRule35Enabled,
  GICXXPred_Simple_IsRule36Enabled,
  GICXXPred_Simple_IsRule37Enabled,
  GICXXPred_Simple_IsRule38Enabled,
  GICXXPred_Simple_IsRule39Enabled,
  GICXXPred_Simple_IsRule40Enabled,
  GICXXPred_Simple_IsRule41Enabled,
  GICXXPred_Simple_IsRule42Enabled,
  GICXXPred_Simple_IsRule43Enabled,
  GICXXPred_Simple_IsRule44Enabled,
  GICXXPred_Simple_IsRule45Enabled,
  GICXXPred_Simple_IsRule46Enabled,
  GICXXPred_Simple_IsRule47Enabled,
  GICXXPred_Simple_IsRule48Enabled,
  GICXXPred_Simple_IsRule49Enabled,
  GICXXPred_Simple_IsRule50Enabled,
  GICXXPred_Simple_IsRule51Enabled,
  GICXXPred_Simple_IsRule52Enabled,
  GICXXPred_Simple_IsRule53Enabled,
  GICXXPred_Simple_IsRule54Enabled,
  GICXXPred_Simple_IsRule55Enabled,
  GICXXPred_Simple_IsRule56Enabled,
  GICXXPred_Simple_IsRule57Enabled,
  GICXXPred_Simple_IsRule58Enabled,
  GICXXPred_Simple_IsRule59Enabled,
  GICXXPred_Simple_IsRule60Enabled,
  GICXXPred_Simple_IsRule61Enabled,
  GICXXPred_Simple_IsRule62Enabled,
  GICXXPred_Simple_IsRule63Enabled,
  GICXXPred_Simple_IsRule64Enabled,
  GICXXPred_Simple_IsRule65Enabled,
  GICXXPred_Simple_IsRule66Enabled,
  GICXXPred_Simple_IsRule67Enabled,
  GICXXPred_Simple_IsRule68Enabled,
  GICXXPred_Simple_IsRule69Enabled,
  GICXXPred_Simple_IsRule70Enabled,
  GICXXPred_Simple_IsRule71Enabled,
  GICXXPred_Simple_IsRule72Enabled,
  GICXXPred_Simple_IsRule73Enabled,
  GICXXPred_Simple_IsRule74Enabled,
  GICXXPred_Simple_IsRule75Enabled,
  GICXXPred_Simple_IsRule76Enabled,
  GICXXPred_Simple_IsRule77Enabled,
  GICXXPred_Simple_IsRule78Enabled,
  GICXXPred_Simple_IsRule79Enabled,
  GICXXPred_Simple_IsRule80Enabled,
  GICXXPred_Simple_IsRule81Enabled,
  GICXXPred_Simple_IsRule82Enabled,
  GICXXPred_Simple_IsRule83Enabled,
  GICXXPred_Simple_IsRule84Enabled,
  GICXXPred_Simple_IsRule85Enabled,
  GICXXPred_Simple_IsRule86Enabled,
  GICXXPred_Simple_IsRule87Enabled,
  GICXXPred_Simple_IsRule88Enabled,
  GICXXPred_Simple_IsRule89Enabled,
  GICXXPred_Simple_IsRule90Enabled,
  GICXXPred_Simple_IsRule91Enabled,
  GICXXPred_Simple_IsRule92Enabled,
  GICXXPred_Simple_IsRule93Enabled,
  GICXXPred_Simple_IsRule94Enabled,
  GICXXPred_Simple_IsRule95Enabled,
  GICXXPred_Simple_IsRule96Enabled,
  GICXXPred_Simple_IsRule97Enabled,
  GICXXPred_Simple_IsRule98Enabled,
  GICXXPred_Simple_IsRule99Enabled,
  GICXXPred_Simple_IsRule100Enabled,
  GICXXPred_Simple_IsRule101Enabled,
  GICXXPred_Simple_IsRule102Enabled,
  GICXXPred_Simple_IsRule103Enabled,
  GICXXPred_Simple_IsRule104Enabled,
  GICXXPred_Simple_IsRule105Enabled,
  GICXXPred_Simple_IsRule106Enabled,
  GICXXPred_Simple_IsRule107Enabled,
  GICXXPred_Simple_IsRule108Enabled,
  GICXXPred_Simple_IsRule109Enabled,
  GICXXPred_Simple_IsRule110Enabled,
  GICXXPred_Simple_IsRule111Enabled,
  GICXXPred_Simple_IsRule112Enabled,
  GICXXPred_Simple_IsRule113Enabled,
  GICXXPred_Simple_IsRule114Enabled,
  GICXXPred_Simple_IsRule115Enabled,
  GICXXPred_Simple_IsRule116Enabled,
  GICXXPred_Simple_IsRule117Enabled,
  GICXXPred_Simple_IsRule118Enabled,
  GICXXPred_Simple_IsRule119Enabled,
  GICXXPred_Simple_IsRule120Enabled,
  GICXXPred_Simple_IsRule121Enabled,
  GICXXPred_Simple_IsRule122Enabled,
  GICXXPred_Simple_IsRule123Enabled,
  GICXXPred_Simple_IsRule124Enabled,
  GICXXPred_Simple_IsRule125Enabled,
  GICXXPred_Simple_IsRule126Enabled,
  GICXXPred_Simple_IsRule127Enabled,
  GICXXPred_Simple_IsRule128Enabled,
  GICXXPred_Simple_IsRule129Enabled,
  GICXXPred_Simple_IsRule130Enabled,
  GICXXPred_Simple_IsRule131Enabled,
  GICXXPred_Simple_IsRule132Enabled,
  GICXXPred_Simple_IsRule133Enabled,
  GICXXPred_Simple_IsRule134Enabled,
  GICXXPred_Simple_IsRule135Enabled,
  GICXXPred_Simple_IsRule136Enabled,
  GICXXPred_Simple_IsRule137Enabled,
  GICXXPred_Simple_IsRule138Enabled,
  GICXXPred_Simple_IsRule139Enabled,
  GICXXPred_Simple_IsRule140Enabled,
  GICXXPred_Simple_IsRule141Enabled,
  GICXXPred_Simple_IsRule142Enabled,
  GICXXPred_Simple_IsRule143Enabled,
  GICXXPred_Simple_IsRule144Enabled,
  GICXXPred_Simple_IsRule145Enabled,
  GICXXPred_Simple_IsRule146Enabled,
  GICXXPred_Simple_IsRule147Enabled,
  GICXXPred_Simple_IsRule148Enabled,
  GICXXPred_Simple_IsRule149Enabled,
  GICXXPred_Simple_IsRule150Enabled,
  GICXXPred_Simple_IsRule151Enabled,
  GICXXPred_Simple_IsRule152Enabled,
  GICXXPred_Simple_IsRule153Enabled,
  GICXXPred_Simple_IsRule154Enabled,
  GICXXPred_Simple_IsRule155Enabled,
  GICXXPred_Simple_IsRule156Enabled,
  GICXXPred_Simple_IsRule157Enabled,
  GICXXPred_Simple_IsRule158Enabled,
  GICXXPred_Simple_IsRule159Enabled,
  GICXXPred_Simple_IsRule160Enabled,
  GICXXPred_Simple_IsRule161Enabled,
  GICXXPred_Simple_IsRule162Enabled,
  GICXXPred_Simple_IsRule163Enabled,
  GICXXPred_Simple_IsRule164Enabled,
  GICXXPred_Simple_IsRule165Enabled,
  GICXXPred_Simple_IsRule166Enabled,
  GICXXPred_Simple_IsRule167Enabled,
  GICXXPred_Simple_IsRule168Enabled,
  GICXXPred_Simple_IsRule169Enabled,
  GICXXPred_Simple_IsRule170Enabled,
  GICXXPred_Simple_IsRule171Enabled,
  GICXXPred_Simple_IsRule172Enabled,
  GICXXPred_Simple_IsRule173Enabled,
  GICXXPred_Simple_IsRule174Enabled,
  GICXXPred_Simple_IsRule175Enabled,
  GICXXPred_Simple_IsRule176Enabled,
  GICXXPred_Simple_IsRule177Enabled,
  GICXXPred_Simple_IsRule178Enabled,
  GICXXPred_Simple_IsRule179Enabled,
  GICXXPred_Simple_IsRule180Enabled,
  GICXXPred_Simple_IsRule181Enabled,
  GICXXPred_Simple_IsRule182Enabled,
  GICXXPred_Simple_IsRule183Enabled,
  GICXXPred_Simple_IsRule184Enabled,
  GICXXPred_Simple_IsRule185Enabled,
  GICXXPred_Simple_IsRule186Enabled,
  GICXXPred_Simple_IsRule187Enabled,
  GICXXPred_Simple_IsRule188Enabled,
  GICXXPred_Simple_IsRule189Enabled,
  GICXXPred_Simple_IsRule190Enabled,
  GICXXPred_Simple_IsRule191Enabled,
  GICXXPred_Simple_IsRule192Enabled,
  GICXXPred_Simple_IsRule193Enabled,
  GICXXPred_Simple_IsRule194Enabled,
  GICXXPred_Simple_IsRule195Enabled,
  GICXXPred_Simple_IsRule196Enabled,
  GICXXPred_Simple_IsRule197Enabled,
  GICXXPred_Simple_IsRule198Enabled,
  GICXXPred_Simple_IsRule199Enabled,
  GICXXPred_Simple_IsRule200Enabled,
  GICXXPred_Simple_IsRule201Enabled,
  GICXXPred_Simple_IsRule202Enabled,
  GICXXPred_Simple_IsRule203Enabled,
  GICXXPred_Simple_IsRule204Enabled,
  GICXXPred_Simple_IsRule205Enabled,
  GICXXPred_Simple_IsRule206Enabled,
  GICXXPred_Simple_IsRule207Enabled,
  GICXXPred_Simple_IsRule208Enabled,
  GICXXPred_Simple_IsRule209Enabled,
  GICXXPred_Simple_IsRule210Enabled,
  GICXXPred_Simple_IsRule211Enabled,
  GICXXPred_Simple_IsRule212Enabled,
  GICXXPred_Simple_IsRule213Enabled,
  GICXXPred_Simple_IsRule214Enabled,
  GICXXPred_Simple_IsRule215Enabled,
  GICXXPred_Simple_IsRule216Enabled,
  GICXXPred_Simple_IsRule217Enabled,
  GICXXPred_Simple_IsRule218Enabled,
  GICXXPred_Simple_IsRule219Enabled,
  GICXXPred_Simple_IsRule220Enabled,
  GICXXPred_Simple_IsRule221Enabled,
  GICXXPred_Simple_IsRule222Enabled,
  GICXXPred_Simple_IsRule223Enabled,
  GICXXPred_Simple_IsRule224Enabled,
};

bool AArch64PreLegalizerCombinerImpl::testSimplePredicate(unsigned Predicate) const {
    return RuleConfig.isRuleEnabled(Predicate - GICXXPred_Invalid - 1);
}
// Custom renderers.
enum {
  GICR_Invalid,
};
AArch64PreLegalizerCombinerImpl::CustomRendererFn
AArch64PreLegalizerCombinerImpl::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool AArch64PreLegalizerCombinerImpl::tryCombineAllImpl(MachineInstr &I) const {
  const TargetSubtargetInfo &ST = MF.getSubtarget();
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  B.setInstrAndDebugLoc(I);
  State.MIs.clear();
  State.MIs.push_back(&I);
  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), *ST.getInstrInfo(), MRI, *MRI.getTargetRegisterInfo(), *ST.getRegBankInfo(), AvailableFeatures, /*CoverageInfo*/ nullptr)) {
    return true;
  }

  return false;
}

enum {
  GICXXCustomAction_GICombiner0 = GICXXCustomAction_Invalid + 1,
  GICXXCustomAction_GICombiner1,
  GICXXCustomAction_GICombiner2,
  GICXXCustomAction_GICombiner3,
  GICXXCustomAction_GICombiner4,
  GICXXCustomAction_GICombiner5,
  GICXXCustomAction_GICombiner6,
  GICXXCustomAction_GICombiner7,
  GICXXCustomAction_GICombiner8,
  GICXXCustomAction_GICombiner9,
  GICXXCustomAction_GICombiner10,
  GICXXCustomAction_GICombiner11,
  GICXXCustomAction_GICombiner12,
  GICXXCustomAction_GICombiner13,
  GICXXCustomAction_GICombiner14,
  GICXXCustomAction_GICombiner15,
  GICXXCustomAction_GICombiner16,
  GICXXCustomAction_GICombiner17,
  GICXXCustomAction_GICombiner18,
  GICXXCustomAction_GICombiner19,
  GICXXCustomAction_GICombiner20,
  GICXXCustomAction_GICombiner21,
  GICXXCustomAction_GICombiner22,
  GICXXCustomAction_GICombiner23,
  GICXXCustomAction_GICombiner24,
  GICXXCustomAction_GICombiner25,
  GICXXCustomAction_GICombiner26,
  GICXXCustomAction_GICombiner27,
  GICXXCustomAction_GICombiner28,
  GICXXCustomAction_GICombiner29,
  GICXXCustomAction_GICombiner30,
  GICXXCustomAction_GICombiner31,
  GICXXCustomAction_GICombiner32,
  GICXXCustomAction_GICombiner33,
  GICXXCustomAction_GICombiner34,
  GICXXCustomAction_GICombiner35,
  GICXXCustomAction_GICombiner36,
  GICXXCustomAction_GICombiner37,
  GICXXCustomAction_GICombiner38,
  GICXXCustomAction_GICombiner39,
  GICXXCustomAction_GICombiner40,
  GICXXCustomAction_GICombiner41,
  GICXXCustomAction_GICombiner42,
  GICXXCustomAction_GICombiner43,
  GICXXCustomAction_GICombiner44,
  GICXXCustomAction_GICombiner45,
  GICXXCustomAction_GICombiner46,
  GICXXCustomAction_GICombiner47,
  GICXXCustomAction_GICombiner48,
  GICXXCustomAction_GICombiner49,
  GICXXCustomAction_GICombiner50,
  GICXXCustomAction_GICombiner51,
  GICXXCustomAction_GICombiner52,
  GICXXCustomAction_GICombiner53,
  GICXXCustomAction_GICombiner54,
  GICXXCustomAction_GICombiner55,
  GICXXCustomAction_GICombiner56,
  GICXXCustomAction_GICombiner57,
  GICXXCustomAction_GICombiner58,
  GICXXCustomAction_GICombiner59,
  GICXXCustomAction_GICombiner60,
  GICXXCustomAction_GICombiner61,
  GICXXCustomAction_GICombiner62,
  GICXXCustomAction_GICombiner63,
  GICXXCustomAction_GICombiner64,
  GICXXCustomAction_GICombiner65,
  GICXXCustomAction_GICombiner66,
  GICXXCustomAction_GICombiner67,
  GICXXCustomAction_GICombiner68,
  GICXXCustomAction_GICombiner69,
  GICXXCustomAction_GICombiner70,
  GICXXCustomAction_GICombiner71,
  GICXXCustomAction_GICombiner72,
  GICXXCustomAction_GICombiner73,
  GICXXCustomAction_GICombiner74,
  GICXXCustomAction_GICombiner75,
  GICXXCustomAction_GICombiner76,
  GICXXCustomAction_GICombiner77,
  GICXXCustomAction_GICombiner78,
  GICXXCustomAction_GICombiner79,
  GICXXCustomAction_GICombiner80,
  GICXXCustomAction_GICombiner81,
  GICXXCustomAction_GICombiner82,
  GICXXCustomAction_GICombiner83,
  GICXXCustomAction_GICombiner84,
  GICXXCustomAction_GICombiner85,
  GICXXCustomAction_GICombiner86,
  GICXXCustomAction_GICombiner87,
  GICXXCustomAction_GICombiner88,
  GICXXCustomAction_GICombiner89,
  GICXXCustomAction_GICombiner90,
  GICXXCustomAction_GICombiner91,
  GICXXCustomAction_GICombiner92,
  GICXXCustomAction_GICombiner93,
  GICXXCustomAction_GICombiner94,
  GICXXCustomAction_GICombiner95,
  GICXXCustomAction_GICombiner96,
  GICXXCustomAction_GICombiner97,
  GICXXCustomAction_GICombiner98,
  GICXXCustomAction_GICombiner99,
  GICXXCustomAction_GICombiner100,
  GICXXCustomAction_GICombiner101,
  GICXXCustomAction_GICombiner102,
  GICXXCustomAction_GICombiner103,
  GICXXCustomAction_GICombiner104,
  GICXXCustomAction_GICombiner105,
  GICXXCustomAction_GICombiner106,
  GICXXCustomAction_GICombiner107,
  GICXXCustomAction_GICombiner108,
  GICXXCustomAction_GICombiner109,
  GICXXCustomAction_GICombiner110,
  GICXXCustomAction_GICombiner111,
  GICXXCustomAction_GICombiner112,
  GICXXCustomAction_GICombiner113,
  GICXXCustomAction_GICombiner114,
  GICXXCustomAction_GICombiner115,
  GICXXCustomAction_GICombiner116,
  GICXXCustomAction_GICombiner117,
  GICXXCustomAction_GICombiner118,
  GICXXCustomAction_GICombiner119,
  GICXXCustomAction_GICombiner120,
  GICXXCustomAction_GICombiner121,
  GICXXCustomAction_GICombiner122,
  GICXXCustomAction_GICombiner123,
  GICXXCustomAction_GICombiner124,
  GICXXCustomAction_GICombiner125,
  GICXXCustomAction_GICombiner126,
  GICXXCustomAction_GICombiner127,
  GICXXCustomAction_GICombiner128,
  GICXXCustomAction_GICombiner129,
  GICXXCustomAction_GICombiner130,
  GICXXCustomAction_GICombiner131,
  GICXXCustomAction_GICombiner132,
  GICXXCustomAction_GICombiner133,
  GICXXCustomAction_GICombiner134,
  GICXXCustomAction_GICombiner135,
  GICXXCustomAction_GICombiner136,
  GICXXCustomAction_GICombiner137,
  GICXXCustomAction_GICombiner138,
  GICXXCustomAction_GICombiner139,
  GICXXCustomAction_GICombiner140,
  GICXXCustomAction_GICombiner141,
  GICXXCustomAction_GICombiner142,
  GICXXCustomAction_GICombiner143,
  GICXXCustomAction_GICombiner144,
  GICXXCustomAction_GICombiner145,
  GICXXCustomAction_GICombiner146,
  GICXXCustomAction_GICombiner147,
  GICXXCustomAction_GICombiner148,
  GICXXCustomAction_GICombiner149,
  GICXXCustomAction_GICombiner150,
  GICXXCustomAction_GICombiner151,
  GICXXCustomAction_GICombiner152,
  GICXXCustomAction_GICombiner153,
  GICXXCustomAction_GICombiner154,
  GICXXCustomAction_GICombiner155,
  GICXXCustomAction_GICombiner156,
  GICXXCustomAction_GICombiner157,
};
bool AArch64PreLegalizerCombinerImpl::runCustomAction(unsigned ApplyID, const MatcherState &State, NewMIVector &OutMIs) const {
  Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
  switch(ApplyID) {
  case GICXXCustomAction_GICombiner0:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAPlusC1MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner1:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldC2MinusAPlusC1(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner2:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAMinusC1MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner3:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldC1Minus2MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner4:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAMinusC1PlusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner5:{
    // Match Patterns
    if(![&](){return Helper.matchCombineCopy(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineCopy(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner6:{
    unsigned GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineMulToShl(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineMulToShl(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner7:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineSubToAdd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner8:{
    std::pair<Register, bool> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineAddP2IToPtrAdd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineAddP2IToPtrAdd(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner9:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElement(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner10:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchInsertVectorElementOOB(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner11:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithDifferentIndices(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner12:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithBuildVector(*State.MIs[0], *State.MIs[1],
              GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner13:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithBuildVectorTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner14:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithShuffleVector(*State.MIs[0], *State.MIs[1],
              GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner15:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner16:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner17:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShlOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner18:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSubOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner19:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return !isGuaranteedNotToBePoison(State.MIs[0]->getOperand(1).getReg(), MRI) && Helper.matchFreezeOfSingleMaybePoisonOperand(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner20:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncateOfExt(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner21:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtOfExt(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner22:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantSextInReg(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner23:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfSelect(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner24:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfBuildVector(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner25:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNarrowBinop(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner26:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfInteger(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner27:{
    SmallVector<Register> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineInsertVecElts(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineInsertVecElts(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner28:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVecEltBuildVec(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtractVecEltBuildVec(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner29:{
    SmallVector<std::pair<Register, MachineInstr*>> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractAllEltsFromBuildVector(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtractAllEltsFromBuildVector(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner30:{
    PreferredTuple GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner31:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineLoadWithAndMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner32:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtractedVectorLoad(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner33:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], 0.0);
    return true;
  }
  case GICXXCustomAction_GICombiner34:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return true;
  }
  case GICXXCustomAction_GICombiner35:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], -1);
    return true;
  }
  case GICXXCustomAction_GICombiner36:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsUndef(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return true;
  }
  case GICXXCustomAction_GICombiner37:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsUndef(*State.MIs[0], 2);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner38:{
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]->getOperand(0).getParent());
    return true;
  }
  case GICXXCustomAction_GICombiner39:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner40:{
    // Match Patterns
    if(![&](){return Helper.matchAllExplicitUsesAreUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner41:{
    // Match Patterns
    if(![&](){return Helper.matchUndefShuffleVectorMask(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner42:{
    // Match Patterns
    if(![&](){return Helper.matchUndefStore(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.eraseInst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner43:{
    // Match Patterns
    if(![&](){return Helper.matchInsertExtractVecEltOutOfBounds(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner44:{
    // Match Patterns
    if(![&](){return Helper.matchSelectSameVal(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 2);
    return true;
  }
  case GICXXCustomAction_GICombiner45:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsZero(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner46:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineI2PToP2I(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineI2PToP2I(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner47:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){GIMatchData_info = State.MIs[1]->getOperand(1).getReg(); return true;}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineP2IToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner48:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineAnyExtTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner49:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchBuildVectorIdentityFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner50:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner51:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncLshrBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner52:{
    // Match Patterns
    if(![&](){return MRI.getType(State.MIs[1]->getOperand(1).getReg()) == MRI.getType(State.MIs[0]->getOperand(0).getReg());}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], State.MIs[1]->getOperand(1).getReg());
    return true;
  }
  case GICXXCustomAction_GICombiner53:{
    MachineInstr* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtendThroughPhis(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtendThroughPhis(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner54:{
    std::tuple<Register, Register> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSimplifyAddToSub(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySimplifyAddToSub(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner55:{
    InstructionStepsMatchInfo GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchHoistLogicOpWithSameOpcodeHands(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildInstructionSteps(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner56:{
    std::optional<int64_t> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftsTooBig(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    if (GIMatchData_matchinfo) {
              Helper.replaceInstWithConstant(*State.MIs[0], *GIMatchData_matchinfo);
            } else {
              Helper.replaceInstWithUndef(*State.MIs[0]);
            }
    return true;
  }
  case GICXXCustomAction_GICombiner57:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchReassocPtrAdd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner58:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchReassocCommBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner59:{
    PtrAddChain GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchPtrAddImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyPtrAddImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner60:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCanonicalizeICmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner61:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCanonicalizeFCmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner62:{
    int64_t GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchICmpToTrueFalseKnownBits(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner63:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchICmpToLHSKnownBits(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner64:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchRedundantBinOpInEquality(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner65:{
    std::tuple<Register, int64_t> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchAshrShlToSextInreg(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyAshShlToSextInreg(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner66:{
    std::tuple<Register, unsigned> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSextInRegOfLoad(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySextInRegOfLoad(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner67:{
    RegisterImmPair GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineShlOfExtend(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineShlOfExtend(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner68:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNarrowBinopFeedingAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner69:{
    unsigned GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantSelectCmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner70:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSelectIMinMax(State.MIs[0]->getOperand(0), GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner71:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSelect(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner72:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner73:{
    // Match Patterns
    if(![&](){return Helper.matchRedundantSExtInReg(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner74:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantOr(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner75:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsKnownToBeAPowerOfTwo(*State.MIs[0], 2);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySimplifyURemByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner76:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineZextTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner77:{
    // Match Patterns
    if(![&](){unsigned BitWidth = MRI.getType(State.MIs[0]->getOperand(1).getReg()).getScalarSizeInBits();
                return Helper.getValueTracking()->maskedValueIsZero(State.MIs[0]->getOperand(1).getReg(),
                         APInt::getOneBitSet(BitWidth, State.MIs[0]->getOperand(2).getImm() - 1));}()) {
      return false;
    }
    // Apply Patterns
    Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
              Helper.getBuilder().buildZExtInReg(State.MIs[0]->getOperand(0), State.MIs[0]->getOperand(1), State.MIs[0]->getOperand(2).getImm());
              State.MIs[0]->eraseFromParent();
    return true;
  }
  case GICXXCustomAction_GICombiner78:{
    std::pair<MachineInstr*, LLT> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineTruncOfShift(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineTruncOfShift(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner79:{
    SmallVector<Register> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchNotCmp(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyNotCmp(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner80:{
    MachineInstr * GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchOptBrCondByInvertingCond(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyOptBrCondByInvertingCond(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner81:{
    // Apply Patterns
    Helper.applyCombineConstantFoldFpUnary(*State.MIs[0], State.MIs[1]->getOperand(1).getFPImm());
    return true;
  }
  case GICXXCustomAction_GICombiner82:{
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0]->getOperand(0).getParent(), 0.0);
    return true;
  }
  case GICXXCustomAction_GICombiner83:{
    APInt GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineConstPtrAddToI2P(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineConstPtrAddToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner84:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchOverlappingAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner85:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOBy2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner86:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOBy0(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner87:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddEToAddO(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner88:{
    unsigned GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFMinMaxNaN(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner89:{
    // Match Patterns
    if(![&](){return Helper.matchFPowIExpansion(*State.MIs[0], State.MIs[1]->getOperand(1).getCImm()->getSExtValue());}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExpandFPowI(*State.MIs[0], State.MIs[1]->getOperand(1).getCImm()->getSExtValue());
    return true;
  }
  case GICXXCustomAction_GICombiner90:{
    std::pair<Register, Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchXorOfAndWithSameReg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyXorOfAndWithSameReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner91:{
    // Match Patterns
    if(![&](){return Helper.matchPtrAddZero(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyPtrAddZero(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner92:{
    RegisterImmPair GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner93:{
    ShiftOfShiftedLogic GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftOfShiftedLogic(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShiftOfShiftedLogic(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner94:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchLoadOrCombine(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner95:{
    MachineInstr * GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineDivRem(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineDivRem(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner96:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchOrShiftToFunnelShift(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner97:{
    // Match Patterns
    if(![&](){return Helper.matchFunnelShiftToRotate(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFunnelShiftToRotate(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner98:{
    // Match Patterns
    if(![&](){return Helper.matchConstantLargerBitWidth(*State.MIs[0], 3);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFunnelShiftConstantModulo(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner99:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCommuteShift(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner100:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromSExtInReg(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner101:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner102:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromShr(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner103:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromShrAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner104:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner105:{
    ConstantFP* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldFPBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner106:{
    ConstantFP* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldFMA(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner107:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldCastOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner108:{
    // Match Patterns
    if(![&](){return Helper.matchUMulHToLShr(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUMulHToLShr(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner109:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantNegOperands(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner110:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchAndOrDisjointMask(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner111:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFMulToFMadOrFMA(*State.MIs[0],
                                                                  GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner112:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFpExtFMulToFMadOrFMA(*State.MIs[0],
                                                                       GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner113:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFMAFMulToFMadOrFMA(*State.MIs[0],
                                                                     GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner114:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFpExtFMulToFMadOrFMAAggressive(
                                                          *State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner115:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFMulToFMadOrFMA(*State.MIs[0],
                                                                  GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner116:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFNegFMulToFMadOrFMA(*State.MIs[0],
                                                                      GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner117:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFpExtFMulToFMadOrFMA(*State.MIs[0],
                                                                       GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner118:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFpExtFNegFMulToFMadOrFMA(
                                                    *State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner119:{
    unsigned GIMatchData_select_op_no;
    // Match Patterns
    if(![&](){return Helper.matchFoldBinOpIntoSelect(*State.MIs[0], GIMatchData_select_op_no);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFoldBinOpIntoSelect(*State.MIs[0], GIMatchData_select_op_no);
    return true;
  }
  case GICXXCustomAction_GICombiner120:{
    // Match Patterns
    if(![&](){return Helper.matchUDivorURemByConst(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUDivorURemByConst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner121:{
    // Match Patterns
    if(![&](){return Helper.matchDivByPow2(*State.MIs[0], /*IsSigned=*/false);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUDivByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner122:{
    // Match Patterns
    if(![&](){return Helper.matchDivByPow2(*State.MIs[0], /*IsSigned=*/true);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySDivByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner123:{
    // Match Patterns
    if(![&](){return Helper.matchSDivByConst(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySDivByConst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner124:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSubAddSameReg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner125:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSimplifySelectToMinMax(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner126:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFsubToFneg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFsubToFneg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner127:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner128:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteFPConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner129:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner130:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchOr(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner131:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSimplifyNegMinMax(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner132:{
    SmallVector<Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineConcatVectors(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineConcatVectors(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner133:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSextOfTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner134:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchZextOfTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner135:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNonNegZext(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner136:{
    SmallVector<Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineShuffleConcat(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineShuffleConcat(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner137:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShuffleUndefRHS(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner138:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShuffleDisjointMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner139:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchUseVectorTruncate(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUseVectorTruncate(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner140:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchUnmergeValuesAnyExtBuildVector(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner141:{
    SmallVector<Register> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeMergeToPlainValues(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeMergeToPlainValues(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner142:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineMergeUnmerge(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner143:{
    SmallVector<APInt, 8> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeConstant(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeConstant(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner144:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeUndef(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner145:{
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeWithDeadLanesToTrunc(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeWithDeadLanesToTrunc(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner146:{
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeZExtToZExt(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeZExtToZExt(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner147:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMergeXAndUndef(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner148:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMergeXAndZero(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner149:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddOverflow(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner150:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSuboCarryOut(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner151:{
    // Match Patterns
    if(![&](){return matchFConstantToConstant(*State.MIs[0], MRI);}()) {
      return false;
    }
    // Apply Patterns
    applyFConstantToConstant(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner152:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchICmpRedundantTrunc(*State.MIs[0], MRI, Helper.getValueTracking(), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyICmpRedundantTrunc(*State.MIs[0], MRI, B, Observer, GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner153:{
    std::pair<uint64_t, uint64_t> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchFoldGlobalOffset(*State.MIs[0], MRI, GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyFoldGlobalOffset(*State.MIs[0], MRI, B, Observer, GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner154:{
    // Match Patterns
    if(![&](){return Helper.matchShuffleToExtract(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShuffleToExtract(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner155:{
    std::tuple<Register, Register, bool> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchExtAddvToUdotAddv(*State.MIs[0], MRI, STI, GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyExtAddvToUdotAddv(*State.MIs[0], MRI, B, Observer, STI, GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner156:{
    std::pair<Register, bool> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchExtUaddvToUaddlv(*State.MIs[0], MRI, GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyExtUaddvToUaddlv(*State.MIs[0], MRI, B, Observer, GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner157:{
    // Match Patterns
    if(![&](){return matchPushAddSubExt(*State.MIs[0], MRI, State.MIs[0]->getOperand(0).getReg(), State.MIs[1]->getOperand(1).getReg(), State.MIs[2]->getOperand(1).getReg());}()) {
      return false;
    }
    // Apply Patterns
    applyPushAddSubExt(*State.MIs[0], MRI, B, State.MIs[1]->getOpcode() == TargetOpcode::G_SEXT, State.MIs[0]->getOperand(0).getReg(), State.MIs[1]->getOperand(1).getReg(), State.MIs[2]->getOperand(1).getReg());
    return true;
  }
  }
  llvm_unreachable("Unknown Apply Action");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AArch64PreLegalizerCombinerImpl::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*    0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(20), GIMT_Encode2(304), /*)*//*default:*//*Label 98*/ GIMT_Encode4(7378),
     /*   10 */ /*TargetOpcode::COPY*//*Label 0*/ GIMT_Encode4(1146), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  142 */ /*TargetOpcode::G_ADD*//*Label 1*/ GIMT_Encode4(1158),
     /*  146 */ /*TargetOpcode::G_SUB*//*Label 2*/ GIMT_Encode4(1773),
     /*  150 */ /*TargetOpcode::G_MUL*//*Label 3*/ GIMT_Encode4(2149),
     /*  154 */ /*TargetOpcode::G_SDIV*//*Label 4*/ GIMT_Encode4(2315),
     /*  158 */ /*TargetOpcode::G_UDIV*//*Label 5*/ GIMT_Encode4(2388),
     /*  162 */ /*TargetOpcode::G_SREM*//*Label 6*/ GIMT_Encode4(2472),
     /*  166 */ /*TargetOpcode::G_UREM*//*Label 7*/ GIMT_Encode4(2517), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  178 */ /*TargetOpcode::G_AND*//*Label 8*/ GIMT_Encode4(2595),
     /*  182 */ /*TargetOpcode::G_OR*//*Label 9*/ GIMT_Encode4(2876),
     /*  186 */ /*TargetOpcode::G_XOR*//*Label 10*/ GIMT_Encode4(3121), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  202 */ /*TargetOpcode::G_PHI*//*Label 11*/ GIMT_Encode4(3222), GIMT_Encode4(0),
     /*  210 */ /*TargetOpcode::G_GLOBAL_VALUE*//*Label 12*/ GIMT_Encode4(3234), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  226 */ /*TargetOpcode::G_UNMERGE_VALUES*//*Label 13*/ GIMT_Encode4(3246), GIMT_Encode4(0),
     /*  234 */ /*TargetOpcode::G_MERGE_VALUES*//*Label 14*/ GIMT_Encode4(3313),
     /*  238 */ /*TargetOpcode::G_BUILD_VECTOR*//*Label 15*/ GIMT_Encode4(3387),
     /*  242 */ /*TargetOpcode::G_BUILD_VECTOR_TRUNC*//*Label 16*/ GIMT_Encode4(3435),
     /*  246 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 17*/ GIMT_Encode4(3447),
     /*  250 */ /*TargetOpcode::G_PTRTOINT*//*Label 18*/ GIMT_Encode4(3459),
     /*  254 */ /*TargetOpcode::G_INTTOPTR*//*Label 19*/ GIMT_Encode4(3502),
     /*  258 */ /*TargetOpcode::G_BITCAST*//*Label 20*/ GIMT_Encode4(3535),
     /*  262 */ /*TargetOpcode::G_FREEZE*//*Label 21*/ GIMT_Encode4(3578), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  302 */ /*TargetOpcode::G_LOAD*//*Label 22*/ GIMT_Encode4(3642),
     /*  306 */ /*TargetOpcode::G_SEXTLOAD*//*Label 23*/ GIMT_Encode4(3654),
     /*  310 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 24*/ GIMT_Encode4(3666), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  326 */ /*TargetOpcode::G_STORE*//*Label 25*/ GIMT_Encode4(3678), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  462 */ /*TargetOpcode::G_ANYEXT*//*Label 26*/ GIMT_Encode4(3690),
     /*  466 */ /*TargetOpcode::G_TRUNC*//*Label 27*/ GIMT_Encode4(3818), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  486 */ /*TargetOpcode::G_FCONSTANT*//*Label 28*/ GIMT_Encode4(4176), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  498 */ /*TargetOpcode::G_SEXT*//*Label 29*/ GIMT_Encode4(4188),
     /*  502 */ /*TargetOpcode::G_SEXT_INREG*//*Label 30*/ GIMT_Encode4(4263),
     /*  506 */ /*TargetOpcode::G_ZEXT*//*Label 31*/ GIMT_Encode4(4329),
     /*  510 */ /*TargetOpcode::G_SHL*//*Label 32*/ GIMT_Encode4(4459),
     /*  514 */ /*TargetOpcode::G_LSHR*//*Label 33*/ GIMT_Encode4(4628),
     /*  518 */ /*TargetOpcode::G_ASHR*//*Label 34*/ GIMT_Encode4(4751),
     /*  522 */ /*TargetOpcode::G_FSHL*//*Label 35*/ GIMT_Encode4(4885),
     /*  526 */ /*TargetOpcode::G_FSHR*//*Label 36*/ GIMT_Encode4(4928),
     /*  530 */ /*TargetOpcode::G_ROTR*//*Label 37*/ GIMT_Encode4(4971),
     /*  534 */ /*TargetOpcode::G_ROTL*//*Label 38*/ GIMT_Encode4(4995),
     /*  538 */ /*TargetOpcode::G_ICMP*//*Label 39*/ GIMT_Encode4(5019),
     /*  542 */ /*TargetOpcode::G_FCMP*//*Label 40*/ GIMT_Encode4(5075), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  554 */ /*TargetOpcode::G_SELECT*//*Label 41*/ GIMT_Encode4(5087),
     /*  558 */ /*TargetOpcode::G_UADDO*//*Label 42*/ GIMT_Encode4(5182),
     /*  562 */ /*TargetOpcode::G_UADDE*//*Label 43*/ GIMT_Encode4(5205),
     /*  566 */ /*TargetOpcode::G_USUBO*//*Label 44*/ GIMT_Encode4(5217),
     /*  570 */ /*TargetOpcode::G_USUBE*//*Label 45*/ GIMT_Encode4(5229),
     /*  574 */ /*TargetOpcode::G_SADDO*//*Label 46*/ GIMT_Encode4(5241),
     /*  578 */ /*TargetOpcode::G_SADDE*//*Label 47*/ GIMT_Encode4(5264),
     /*  582 */ /*TargetOpcode::G_SSUBO*//*Label 48*/ GIMT_Encode4(5276),
     /*  586 */ /*TargetOpcode::G_SSUBE*//*Label 49*/ GIMT_Encode4(5288),
     /*  590 */ /*TargetOpcode::G_UMULO*//*Label 50*/ GIMT_Encode4(5300),
     /*  594 */ /*TargetOpcode::G_SMULO*//*Label 51*/ GIMT_Encode4(5334),
     /*  598 */ /*TargetOpcode::G_UMULH*//*Label 52*/ GIMT_Encode4(5368),
     /*  602 */ /*TargetOpcode::G_SMULH*//*Label 53*/ GIMT_Encode4(5391),
     /*  606 */ /*TargetOpcode::G_UADDSAT*//*Label 54*/ GIMT_Encode4(5403),
     /*  610 */ /*TargetOpcode::G_SADDSAT*//*Label 55*/ GIMT_Encode4(5415), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  622 */ /*TargetOpcode::G_USHLSAT*//*Label 56*/ GIMT_Encode4(5427),
     /*  626 */ /*TargetOpcode::G_SSHLSAT*//*Label 57*/ GIMT_Encode4(5450),
     /*  630 */ /*TargetOpcode::G_SMULFIX*//*Label 58*/ GIMT_Encode4(5473),
     /*  634 */ /*TargetOpcode::G_UMULFIX*//*Label 59*/ GIMT_Encode4(5485),
     /*  638 */ /*TargetOpcode::G_SMULFIXSAT*//*Label 60*/ GIMT_Encode4(5497),
     /*  642 */ /*TargetOpcode::G_UMULFIXSAT*//*Label 61*/ GIMT_Encode4(5509), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  662 */ /*TargetOpcode::G_FADD*//*Label 62*/ GIMT_Encode4(5521),
     /*  666 */ /*TargetOpcode::G_FSUB*//*Label 63*/ GIMT_Encode4(5633),
     /*  670 */ /*TargetOpcode::G_FMUL*//*Label 64*/ GIMT_Encode4(5722),
     /*  674 */ /*TargetOpcode::G_FMA*//*Label 65*/ GIMT_Encode4(5810),
     /*  678 */ /*TargetOpcode::G_FMAD*//*Label 66*/ GIMT_Encode4(5833),
     /*  682 */ /*TargetOpcode::G_FDIV*//*Label 67*/ GIMT_Encode4(5856),
     /*  686 */ /*TargetOpcode::G_FREM*//*Label 68*/ GIMT_Encode4(5890), GIMT_Encode4(0),
     /*  694 */ /*TargetOpcode::G_FPOWI*//*Label 69*/ GIMT_Encode4(5902), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  714 */ /*TargetOpcode::G_FLOG2*//*Label 70*/ GIMT_Encode4(5924), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  730 */ /*TargetOpcode::G_FNEG*//*Label 71*/ GIMT_Encode4(5946), GIMT_Encode4(0),
     /*  738 */ /*TargetOpcode::G_FPTRUNC*//*Label 72*/ GIMT_Encode4(5997),
     /*  742 */ /*TargetOpcode::G_FPTOSI*//*Label 73*/ GIMT_Encode4(6040),
     /*  746 */ /*TargetOpcode::G_FPTOUI*//*Label 74*/ GIMT_Encode4(6062),
     /*  750 */ /*TargetOpcode::G_SITOFP*//*Label 75*/ GIMT_Encode4(6084),
     /*  754 */ /*TargetOpcode::G_UITOFP*//*Label 76*/ GIMT_Encode4(6111), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  766 */ /*TargetOpcode::G_FABS*//*Label 77*/ GIMT_Encode4(6138), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  778 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 78*/ GIMT_Encode4(6217),
     /*  782 */ /*TargetOpcode::G_FMINNUM*//*Label 79*/ GIMT_Encode4(6247),
     /*  786 */ /*TargetOpcode::G_FMAXNUM*//*Label 80*/ GIMT_Encode4(6281),
     /*  790 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 81*/ GIMT_Encode4(6315),
     /*  794 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 82*/ GIMT_Encode4(6327),
     /*  798 */ /*TargetOpcode::G_FMINIMUM*//*Label 83*/ GIMT_Encode4(6339),
     /*  802 */ /*TargetOpcode::G_FMAXIMUM*//*Label 84*/ GIMT_Encode4(6373), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  842 */ /*TargetOpcode::G_PTR_ADD*//*Label 85*/ GIMT_Encode4(6407), GIMT_Encode4(0),
     /*  850 */ /*TargetOpcode::G_SMIN*//*Label 86*/ GIMT_Encode4(6497),
     /*  854 */ /*TargetOpcode::G_SMAX*//*Label 87*/ GIMT_Encode4(6531),
     /*  858 */ /*TargetOpcode::G_UMIN*//*Label 88*/ GIMT_Encode4(6565),
     /*  862 */ /*TargetOpcode::G_UMAX*//*Label 89*/ GIMT_Encode4(6599),
     /*  866 */ /*TargetOpcode::G_ABS*//*Label 90*/ GIMT_Encode4(6633), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  878 */ /*TargetOpcode::G_BR*//*Label 91*/ GIMT_Encode4(6645), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  898 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 92*/ GIMT_Encode4(6657),
     /*  902 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 93*/ GIMT_Encode4(6787),
     /*  906 */ /*TargetOpcode::G_SHUFFLE_VECTOR*//*Label 94*/ GIMT_Encode4(7164), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  946 */ /*TargetOpcode::G_BITREVERSE*//*Label 95*/ GIMT_Encode4(7241), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  998 */ /*TargetOpcode::G_FSQRT*//*Label 96*/ GIMT_Encode4(7330), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 1142 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 97*/ GIMT_Encode4(7352),
     /* 1146 */ // Label 0: @1146
     /* 1146 */ GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1157), // Rule ID 13 //
     /* 1151 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule13Enabled),
     /* 1154 */   // MIs[0] d
     /* 1154 */   // No operand predicates
     /* 1154 */   // MIs[0] s
     /* 1154 */   // No operand predicates
     /* 1154 */   // Combiner Rule #13: copy_prop
     /* 1154 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /* 1157 */ // Label 99: @1157
     /* 1157 */ GIM_Reject,
     /* 1158 */ // Label 1: @1158
     /* 1158 */ GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1169), // Rule ID 16 //
     /* 1163 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule16Enabled),
     /* 1166 */   // Combiner Rule #16: add_p2i_to_ptradd; wip_match_opcode 'G_ADD'
     /* 1166 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner8),
     /* 1169 */ // Label 100: @1169
     /* 1169 */ GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(1180), // Rule ID 94 //
     /* 1174 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 1177 */   // Combiner Rule #78: propagate_undef_any_op; wip_match_opcode 'G_ADD'
     /* 1177 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1180 */ // Label 101: @1180
     /* 1180 */ GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(1191), // Rule ID 141 //
     /* 1185 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule103Enabled),
     /* 1188 */   // Combiner Rule #103: simplify_add_to_sub; wip_match_opcode 'G_ADD'
     /* 1188 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner54),
     /* 1191 */ // Label 102: @1191
     /* 1191 */ GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(1202), // Rule ID 231 //
     /* 1196 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 1199 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_ADD'
     /* 1199 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 1202 */ // Label 103: @1202
     /* 1202 */ GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(1213), // Rule ID 275 //
     /* 1207 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 1210 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_ADD'
     /* 1210 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 1213 */ // Label 104: @1213
     /* 1213 */ GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(1224), // Rule ID 309 //
     /* 1218 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 1221 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_ADD'
     /* 1221 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 1224 */ // Label 105: @1224
     /* 1224 */ GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(1258), // Rule ID 0 //
     /* 1229 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule0Enabled),
     /* 1232 */   // MIs[0] root
     /* 1232 */   // No operand predicates
     /* 1232 */   // MIs[0] sub
     /* 1232 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1236 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1240 */   // MIs[1] Operand 1
     /* 1240 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 1244 */   // MIs[1] A
     /* 1244 */   // No operand predicates
     /* 1244 */   // MIs[0] B
     /* 1244 */   // No operand predicates
     /* 1244 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1246 */   // Combiner Rule #0: ZeroMinusAPlusB
     /* 1246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1249 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1251 */   GIR_RootToRootCopy, /*OpIdx*/2, // B
     /* 1253 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // A
     /* 1257 */   GIR_EraseRootFromParent_Done,
     /* 1258 */ // Label 106: @1258
     /* 1258 */ GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(1295), // Rule ID 12 //
     /* 1263 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule12Enabled),
     /* 1266 */   // MIs[0] root
     /* 1266 */   // No operand predicates
     /* 1266 */   // MIs[0] sub
     /* 1266 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1270 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1274 */   // MIs[1] A
     /* 1274 */   // No operand predicates
     /* 1274 */   // MIs[1] c1
     /* 1274 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1278 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1282 */   // MIs[2] imm1
     /* 1282 */   // No operand predicates
     /* 1282 */   // MIs[0] c2
     /* 1282 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1286 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1290 */   // MIs[3] imm2
     /* 1290 */   // No operand predicates
     /* 1290 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1292 */   // Combiner Rule #12: AMinusC1PlusC2
     /* 1292 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner4),
     /* 1295 */ // Label 107: @1295
     /* 1295 */ GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(1329), // Rule ID 3 //
     /* 1300 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule3Enabled),
     /* 1303 */   // MIs[0] root
     /* 1303 */   // No operand predicates
     /* 1303 */   // MIs[0] sub
     /* 1303 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1307 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1311 */   // MIs[1] B
     /* 1311 */   // No operand predicates
     /* 1311 */   // MIs[1] A
     /* 1311 */   // No operand predicates
     /* 1311 */   // MIs[0] A
     /* 1311 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 1316 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1321 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1323 */   // Combiner Rule #3: BMinusAPlusA
     /* 1323 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1328 */   GIR_EraseRootFromParent_Done,
     /* 1329 */ // Label 108: @1329
     /* 1329 */ GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(1363), // Rule ID 131 //
     /* 1334 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule94Enabled),
     /* 1337 */   // MIs[0] dst
     /* 1337 */   // No operand predicates
     /* 1337 */   // MIs[0] __add_sub_reg_match_0.tmp
     /* 1337 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1341 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1345 */   // MIs[1] src
     /* 1345 */   // No operand predicates
     /* 1345 */   // MIs[1] __add_sub_reg_match_0.x
     /* 1345 */   // No operand predicates
     /* 1345 */   // MIs[0] __add_sub_reg_match_0.x
     /* 1345 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 1350 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1355 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1357 */   // Combiner Rule #94: add_sub_reg @ [__add_sub_reg_match_0[1]]
     /* 1357 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1362 */   GIR_EraseRootFromParent_Done,
     /* 1363 */ // Label 109: @1363
     /* 1363 */ GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(1408), // Rule ID 5 //
     /* 1368 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1371 */   // MIs[0] root
     /* 1371 */   // No operand predicates
     /* 1371 */   // MIs[0] sub1
     /* 1371 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1375 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1379 */   // MIs[1] A
     /* 1379 */   // No operand predicates
     /* 1379 */   // MIs[1] B
     /* 1379 */   // No operand predicates
     /* 1379 */   // MIs[0] sub2
     /* 1379 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1383 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1387 */   // MIs[2] B
     /* 1387 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 1392 */   // MIs[2] C
     /* 1392 */   // No operand predicates
     /* 1392 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1394 */   // Combiner Rule #5: AMinusBPlusBMinusC
     /* 1394 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1397 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1399 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 1403 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // C
     /* 1407 */   GIR_EraseRootFromParent_Done,
     /* 1408 */ // Label 110: @1408
     /* 1408 */ GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(1453), // Rule ID 4 //
     /* 1413 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule4Enabled),
     /* 1416 */   // MIs[0] root
     /* 1416 */   // No operand predicates
     /* 1416 */   // MIs[0] sub1
     /* 1416 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1420 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1424 */   // MIs[1] A
     /* 1424 */   // No operand predicates
     /* 1424 */   // MIs[1] B
     /* 1424 */   // No operand predicates
     /* 1424 */   // MIs[0] sub2
     /* 1424 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1428 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1432 */   // MIs[2] C
     /* 1432 */   // No operand predicates
     /* 1432 */   // MIs[2] A
     /* 1432 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 1437 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1439 */   // Combiner Rule #4: AMinusBPlusCMinusA
     /* 1439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1442 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1444 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /* 1448 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /* 1452 */   GIR_EraseRootFromParent_Done,
     /* 1453 */ // Label 111: @1453
     /* 1453 */ GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(1482), // Rule ID 371 //
     /* 1458 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule224Enabled),
     /* 1461 */   // MIs[0] dst
     /* 1461 */   // No operand predicates
     /* 1461 */   // MIs[0] ext1
     /* 1461 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1465 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 1469 */   // MIs[1] src1
     /* 1469 */   // No operand predicates
     /* 1469 */   // MIs[0] ext2
     /* 1469 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1473 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 1477 */   // MIs[2] src2
     /* 1477 */   // No operand predicates
     /* 1477 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1479 */   // Combiner Rule #224: push_add_through_sext
     /* 1479 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner157),
     /* 1482 */ // Label 112: @1482
     /* 1482 */ GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(1517), // Rule ID 39 //
     /* 1487 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule37Enabled),
     /* 1490 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 1496 */   // MIs[0] root
     /* 1496 */   // No operand predicates
     /* 1496 */   // MIs[0] left
     /* 1496 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1500 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 1504 */   // MIs[1] imm1
     /* 1504 */   // No operand predicates
     /* 1504 */   // MIs[0] right
     /* 1504 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1508 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 1512 */   // MIs[2] imm2
     /* 1512 */   // No operand predicates
     /* 1512 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1514 */   // Combiner Rule #37: add_of_vscale
     /* 1514 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1517 */ // Label 113: @1517
     /* 1517 */ GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(1546), // Rule ID 369 //
     /* 1522 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule222Enabled),
     /* 1525 */   // MIs[0] dst
     /* 1525 */   // No operand predicates
     /* 1525 */   // MIs[0] ext1
     /* 1525 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1529 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 1533 */   // MIs[1] src1
     /* 1533 */   // No operand predicates
     /* 1533 */   // MIs[0] ext2
     /* 1533 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1537 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 1541 */   // MIs[2] src2
     /* 1541 */   // No operand predicates
     /* 1541 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1543 */   // Combiner Rule #222: push_add_through_zext
     /* 1543 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner157),
     /* 1546 */ // Label 114: @1546
     /* 1546 */ GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(1580), // Rule ID 1 //
     /* 1551 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule1Enabled),
     /* 1554 */   // MIs[0] root
     /* 1554 */   // No operand predicates
     /* 1554 */   // MIs[0] A
     /* 1554 */   // No operand predicates
     /* 1554 */   // MIs[0] sub
     /* 1554 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1558 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1562 */   // MIs[1] Operand 1
     /* 1562 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 1566 */   // MIs[1] B
     /* 1566 */   // No operand predicates
     /* 1566 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1568 */   // Combiner Rule #1: APlusZeroMinusB
     /* 1568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1571 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1573 */   GIR_RootToRootCopy, /*OpIdx*/1, // A
     /* 1575 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /* 1579 */   GIR_EraseRootFromParent_Done,
     /* 1580 */ // Label 115: @1580
     /* 1580 */ GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(1614), // Rule ID 2 //
     /* 1585 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule2Enabled),
     /* 1588 */   // MIs[0] root
     /* 1588 */   // No operand predicates
     /* 1588 */   // MIs[0] A
     /* 1588 */   // No operand predicates
     /* 1588 */   // MIs[0] sub
     /* 1588 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1592 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1596 */   // MIs[1] B
     /* 1596 */   // No operand predicates
     /* 1596 */   // MIs[1] A
     /* 1596 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1601 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1606 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1608 */   // Combiner Rule #2: APlusBMinusB
     /* 1608 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1613 */   GIR_EraseRootFromParent_Done,
     /* 1614 */ // Label 116: @1614
     /* 1614 */ GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(1648), // Rule ID 130 //
     /* 1619 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule94Enabled),
     /* 1622 */   // MIs[0] dst
     /* 1622 */   // No operand predicates
     /* 1622 */   // MIs[0] __add_sub_reg_match_0.x
     /* 1622 */   // No operand predicates
     /* 1622 */   // MIs[0] __add_sub_reg_match_0.tmp
     /* 1622 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1626 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1630 */   // MIs[1] src
     /* 1630 */   // No operand predicates
     /* 1630 */   // MIs[1] __add_sub_reg_match_0.x
     /* 1630 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1635 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1640 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1642 */   // Combiner Rule #94: add_sub_reg @ [__add_sub_reg_match_0[0]]
     /* 1642 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1647 */   GIR_EraseRootFromParent_Done,
     /* 1648 */ // Label 117: @1648
     /* 1648 */ GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(1693), // Rule ID 6 //
     /* 1653 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule6Enabled),
     /* 1656 */   // MIs[0] root
     /* 1656 */   // No operand predicates
     /* 1656 */   // MIs[0] A
     /* 1656 */   // No operand predicates
     /* 1656 */   // MIs[0] sub1
     /* 1656 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1660 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1664 */   // MIs[1] B
     /* 1664 */   // No operand predicates
     /* 1664 */   // MIs[1] add1
     /* 1664 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1668 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1672 */   // MIs[2] A
     /* 1672 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1677 */   // MIs[2] C
     /* 1677 */   // No operand predicates
     /* 1677 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1679 */   // Combiner Rule #6: APlusBMinusAplusC
     /* 1679 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1682 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1684 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 1688 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // C
     /* 1692 */   GIR_EraseRootFromParent_Done,
     /* 1693 */ // Label 118: @1693
     /* 1693 */ GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(1738), // Rule ID 7 //
     /* 1698 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /* 1701 */   // MIs[0] root
     /* 1701 */   // No operand predicates
     /* 1701 */   // MIs[0] A
     /* 1701 */   // No operand predicates
     /* 1701 */   // MIs[0] sub1
     /* 1701 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1705 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1709 */   // MIs[1] B
     /* 1709 */   // No operand predicates
     /* 1709 */   // MIs[1] add1
     /* 1709 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1713 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1717 */   // MIs[2] C
     /* 1717 */   // No operand predicates
     /* 1717 */   // MIs[2] A
     /* 1717 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1722 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1724 */   // Combiner Rule #7: APlusBMinusCPlusA
     /* 1724 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1727 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1729 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 1733 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /* 1737 */   GIR_EraseRootFromParent_Done,
     /* 1738 */ // Label 119: @1738
     /* 1738 */ GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(1761), // Rule ID 105 //
     /* 1743 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 1746 */   // MIs[0] dst
     /* 1746 */   // No operand predicates
     /* 1746 */   // MIs[0] lhs
     /* 1746 */   // No operand predicates
     /* 1746 */   // MIs[0] Operand 2
     /* 1746 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1750 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1755 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[1]]
     /* 1755 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1760 */   GIR_EraseRootFromParent_Done,
     /* 1761 */ // Label 120: @1761
     /* 1761 */ GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(1772), // Rule ID 149 //
     /* 1766 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule107Enabled),
     /* 1769 */   // MIs[0] root
     /* 1769 */   // No operand predicates
     /* 1769 */   // MIs[0] src1
     /* 1769 */   // No operand predicates
     /* 1769 */   // MIs[0] src2
     /* 1769 */   // No operand predicates
     /* 1769 */   // Combiner Rule #107: reassoc_comm_binops
     /* 1769 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner58),
     /* 1772 */ // Label 121: @1772
     /* 1772 */ GIM_Reject,
     /* 1773 */ // Label 2: @1773
     /* 1773 */ GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(1784), // Rule ID 95 //
     /* 1778 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 1781 */   // Combiner Rule #78: propagate_undef_any_op; wip_match_opcode 'G_SUB'
     /* 1781 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1784 */ // Label 122: @1784
     /* 1784 */ GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(1795), // Rule ID 239 //
     /* 1789 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 1792 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SUB'
     /* 1792 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 1795 */ // Label 123: @1795
     /* 1795 */ GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(1806), // Rule ID 276 //
     /* 1800 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 1803 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_SUB'
     /* 1803 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 1806 */ // Label 124: @1806
     /* 1806 */ GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(1817), // Rule ID 306 //
     /* 1811 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 1814 */   // Combiner Rule #188: sub_add_reg; wip_match_opcode 'G_SUB'
     /* 1814 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner124),
     /* 1817 */ // Label 125: @1817
     /* 1817 */ GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(1828), // Rule ID 340 //
     /* 1822 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule195Enabled),
     /* 1825 */   // Combiner Rule #195: simplify_neg_minmax; wip_match_opcode 'G_SUB'
     /* 1825 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner131),
     /* 1828 */ // Label 126: @1828
     /* 1828 */ GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(1865), // Rule ID 8 //
     /* 1833 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule8Enabled),
     /* 1836 */   // MIs[0] root
     /* 1836 */   // No operand predicates
     /* 1836 */   // MIs[0] add
     /* 1836 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1840 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1844 */   // MIs[1] A
     /* 1844 */   // No operand predicates
     /* 1844 */   // MIs[1] c1
     /* 1844 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1848 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1852 */   // MIs[2] imm1
     /* 1852 */   // No operand predicates
     /* 1852 */   // MIs[0] c2
     /* 1852 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1856 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1860 */   // MIs[3] imm2
     /* 1860 */   // No operand predicates
     /* 1860 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1862 */   // Combiner Rule #8: APlusC1MinusC2
     /* 1862 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner0),
     /* 1865 */ // Label 127: @1865
     /* 1865 */ GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(1902), // Rule ID 11 //
     /* 1870 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule11Enabled),
     /* 1873 */   // MIs[0] root
     /* 1873 */   // No operand predicates
     /* 1873 */   // MIs[0] sub1
     /* 1873 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1877 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1881 */   // MIs[1] c1
     /* 1881 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 1885 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1889 */   // MIs[2] imm1
     /* 1889 */   // No operand predicates
     /* 1889 */   // MIs[1] A
     /* 1889 */   // No operand predicates
     /* 1889 */   // MIs[0] c2
     /* 1889 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1893 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1897 */   // MIs[3] imm2
     /* 1897 */   // No operand predicates
     /* 1897 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1899 */   // Combiner Rule #11: C1Minus2MinusC2
     /* 1899 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner3),
     /* 1902 */ // Label 128: @1902
     /* 1902 */ GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(1939), // Rule ID 10 //
     /* 1907 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule10Enabled),
     /* 1910 */   // MIs[0] root
     /* 1910 */   // No operand predicates
     /* 1910 */   // MIs[0] sub1
     /* 1910 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1914 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1918 */   // MIs[1] A
     /* 1918 */   // No operand predicates
     /* 1918 */   // MIs[1] c1
     /* 1918 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1922 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1926 */   // MIs[2] imm1
     /* 1926 */   // No operand predicates
     /* 1926 */   // MIs[0] c2
     /* 1926 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1930 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1934 */   // MIs[3] imm2
     /* 1934 */   // No operand predicates
     /* 1934 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1936 */   // Combiner Rule #10: AMinusC1MinusC2
     /* 1936 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 1939 */ // Label 129: @1939
     /* 1939 */ GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(1968), // Rule ID 370 //
     /* 1944 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule223Enabled),
     /* 1947 */   // MIs[0] dst
     /* 1947 */   // No operand predicates
     /* 1947 */   // MIs[0] ext1
     /* 1947 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1951 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 1955 */   // MIs[1] src1
     /* 1955 */   // No operand predicates
     /* 1955 */   // MIs[0] ext2
     /* 1955 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1959 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 1963 */   // MIs[2] src2
     /* 1963 */   // No operand predicates
     /* 1963 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1965 */   // Combiner Rule #223: push_sub_through_sext
     /* 1965 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner157),
     /* 1968 */ // Label 130: @1968
     /* 1968 */ GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(1997), // Rule ID 368 //
     /* 1973 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule221Enabled),
     /* 1976 */   // MIs[0] dst
     /* 1976 */   // No operand predicates
     /* 1976 */   // MIs[0] ext1
     /* 1976 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1980 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 1984 */   // MIs[1] src1
     /* 1984 */   // No operand predicates
     /* 1984 */   // MIs[0] ext2
     /* 1984 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1988 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 1992 */   // MIs[2] src2
     /* 1992 */   // No operand predicates
     /* 1992 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1994 */   // Combiner Rule #221: push_sub_through_zext
     /* 1994 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner157),
     /* 1997 */ // Label 131: @1997
     /* 1997 */ GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(2040), // Rule ID 159 //
     /* 2002 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule117Enabled),
     /* 2005 */   // MIs[0] dst
     /* 2005 */   // No operand predicates
     /* 2005 */   // MIs[0] Operand 1
     /* 2005 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 2009 */   // MIs[0] and
     /* 2009 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2013 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2017 */   // MIs[1] x
     /* 2017 */   // No operand predicates
     /* 2017 */   // MIs[1] Operand 2
     /* 2017 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 2021 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner7),
     /* 2025 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027 */   // Combiner Rule #117: neg_and_one_to_sext_inreg
     /* 2027 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 2030 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 2032 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // x
     /* 2036 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2039 */   GIR_EraseRootFromParent_Done,
     /* 2040 */ // Label 132: @2040
     /* 2040 */ GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(2077), // Rule ID 9 //
     /* 2045 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule9Enabled),
     /* 2048 */   // MIs[0] root
     /* 2048 */   // No operand predicates
     /* 2048 */   // MIs[0] c2
     /* 2048 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2052 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2056 */   // MIs[1] imm2
     /* 2056 */   // No operand predicates
     /* 2056 */   // MIs[0] add
     /* 2056 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2060 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 2064 */   // MIs[2] A
     /* 2064 */   // No operand predicates
     /* 2064 */   // MIs[2] c1
     /* 2064 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 2068 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2072 */   // MIs[3] imm1
     /* 2072 */   // No operand predicates
     /* 2072 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2074 */   // Combiner Rule #9: C2MinusAPlusC1
     /* 2074 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner1),
     /* 2077 */ // Label 133: @2077
     /* 2077 */ GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(2104), // Rule ID 42 //
     /* 2082 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule40Enabled),
     /* 2085 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 2091 */   // MIs[0] root
     /* 2091 */   // No operand predicates
     /* 2091 */   // MIs[0] x
     /* 2091 */   // No operand predicates
     /* 2091 */   // MIs[0] right
     /* 2091 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2095 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 2099 */   // MIs[1] imm
     /* 2099 */   // No operand predicates
     /* 2099 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2101 */   // Combiner Rule #40: sub_of_vscale
     /* 2101 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner18),
     /* 2104 */ // Label 134: @2104
     /* 2104 */ GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(2127), // Rule ID 104 //
     /* 2109 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 2112 */   // MIs[0] dst
     /* 2112 */   // No operand predicates
     /* 2112 */   // MIs[0] lhs
     /* 2112 */   // No operand predicates
     /* 2112 */   // MIs[0] Operand 2
     /* 2112 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2116 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2121 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[0]]
     /* 2121 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2126 */   GIR_EraseRootFromParent_Done,
     /* 2127 */ // Label 135: @2127
     /* 2127 */ GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(2148), // Rule ID 15 //
     /* 2132 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule15Enabled),
     /* 2135 */   // MIs[0] d
     /* 2135 */   // No operand predicates
     /* 2135 */   // MIs[0] op1
     /* 2135 */   // No operand predicates
     /* 2135 */   // MIs[0] c
     /* 2135 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2139 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2143 */   // MIs[1] imm
     /* 2143 */   // No operand predicates
     /* 2143 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2145 */   // Combiner Rule #15: sub_to_add
     /* 2145 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner7),
     /* 2148 */ // Label 136: @2148
     /* 2148 */ GIM_Reject,
     /* 2149 */ // Label 3: @2149
     /* 2149 */ GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(2160), // Rule ID 78 //
     /* 2154 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule72Enabled),
     /* 2157 */   // Combiner Rule #72: undef_to_int_zero; wip_match_opcode 'G_MUL'
     /* 2157 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner34),
     /* 2160 */ // Label 137: @2160
     /* 2160 */ GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(2171), // Rule ID 236 //
     /* 2165 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2168 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_MUL'
     /* 2168 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2171 */ // Label 138: @2171
     /* 2171 */ GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(2182), // Rule ID 310 //
     /* 2176 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 2179 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_MUL'
     /* 2179 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 2182 */ // Label 139: @2182
     /* 2182 */ GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(2222), // Rule ID 17 //
     /* 2187 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule17Enabled),
     /* 2190 */   // MIs[0] dst
     /* 2190 */   GIM_RecordRegType, /*MI*/0, /*Op*/0, /*TempTypeIdx*/uint8_t(-1),
     /* 2194 */   // MIs[0] x
     /* 2194 */   // No operand predicates
     /* 2194 */   // MIs[0] Operand 2
     /* 2194 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /* 2198 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 2201 */   GIR_BuildConstant, /*TempRegID*/0, /*Val*/GIMT_Encode8(0),
     /* 2211 */   // Combiner Rule #17: mul_by_neg_one
     /* 2211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 2214 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 2216 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 2221 */   GIR_EraseRootFromParent_Done,
     /* 2222 */ // Label 140: @2222
     /* 2222 */ GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(2257), // Rule ID 40 //
     /* 2227 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule38Enabled),
     /* 2230 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 2236 */   // MIs[0] root
     /* 2236 */   // No operand predicates
     /* 2236 */   // MIs[0] left
     /* 2236 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2240 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 2244 */   // MIs[1] scale
     /* 2244 */   // No operand predicates
     /* 2244 */   // MIs[0] x
     /* 2244 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2248 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2252 */   // MIs[2] imm1
     /* 2252 */   // No operand predicates
     /* 2252 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2254 */   // Combiner Rule #38: mul_of_vscale
     /* 2254 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner16),
     /* 2257 */ // Label 141: @2257
     /* 2257 */ GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(2280), // Rule ID 123 //
     /* 2262 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 2265 */   // MIs[0] dst
     /* 2265 */   // No operand predicates
     /* 2265 */   // MIs[0] lhs
     /* 2265 */   // No operand predicates
     /* 2265 */   // MIs[0] zero
     /* 2265 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2269 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /* 2274 */   // Combiner Rule #87: binop_right_to_zero
     /* 2274 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /* 2279 */   GIR_EraseRootFromParent_Done,
     /* 2280 */ // Label 142: @2280
     /* 2280 */ GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(2303), // Rule ID 128 //
     /* 2285 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule92Enabled),
     /* 2288 */   // MIs[0] dst
     /* 2288 */   // No operand predicates
     /* 2288 */   // MIs[0] x
     /* 2288 */   // No operand predicates
     /* 2288 */   // MIs[0] Operand 2
     /* 2288 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 2292 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2297 */   // Combiner Rule #92: right_identity_one_int
     /* 2297 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2302 */   GIR_EraseRootFromParent_Done,
     /* 2303 */ // Label 143: @2303
     /* 2303 */ GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(2314), // Rule ID 14 //
     /* 2308 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule14Enabled),
     /* 2311 */   // MIs[0] d
     /* 2311 */   // No operand predicates
     /* 2311 */   // MIs[0] op1
     /* 2311 */   // No operand predicates
     /* 2311 */   // MIs[0] op2
     /* 2311 */   // No operand predicates
     /* 2311 */   // Combiner Rule #14: mul_to_shl
     /* 2311 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner6),
     /* 2314 */ // Label 144: @2314
     /* 2314 */ GIM_Reject,
     /* 2315 */ // Label 4: @2315
     /* 2315 */ GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(2326), // Rule ID 119 //
     /* 2320 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 2323 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_SDIV'
     /* 2323 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 2326 */ // Label 145: @2326
     /* 2326 */ GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(2337), // Rule ID 211 //
     /* 2331 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 2334 */   // Combiner Rule #153: div_rem_to_divrem; wip_match_opcode 'G_SDIV'
     /* 2334 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 2337 */ // Label 146: @2337
     /* 2337 */ GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(2348), // Rule ID 242 //
     /* 2342 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2345 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SDIV'
     /* 2345 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2348 */ // Label 147: @2348
     /* 2348 */ GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(2359), // Rule ID 281 //
     /* 2353 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 2356 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_SDIV'
     /* 2356 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 2359 */ // Label 148: @2359
     /* 2359 */ GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(2376), // Rule ID 303 //
     /* 2364 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 2367 */   GIM_MIFlagsNot, /*MI*/0, GIMT_Encode4(MachineInstr::IsExact),
     /* 2373 */   // MIs[0] dst
     /* 2373 */   // No operand predicates
     /* 2373 */   // MIs[0] x
     /* 2373 */   // No operand predicates
     /* 2373 */   // MIs[0] y
     /* 2373 */   // No operand predicates
     /* 2373 */   // Combiner Rule #185: sdiv_by_pow2
     /* 2373 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 2376 */ // Label 149: @2376
     /* 2376 */ GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(2387), // Rule ID 305 //
     /* 2381 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule187Enabled),
     /* 2384 */   // MIs[0] dst
     /* 2384 */   // No operand predicates
     /* 2384 */   // MIs[0] x
     /* 2384 */   // No operand predicates
     /* 2384 */   // MIs[0] y
     /* 2384 */   // No operand predicates
     /* 2384 */   // Combiner Rule #187: sdiv_by_const
     /* 2384 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2387 */ // Label 150: @2387
     /* 2387 */ GIM_Reject,
     /* 2388 */ // Label 5: @2388
     /* 2388 */ GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(2399), // Rule ID 81 //
     /* 2393 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 2396 */   // Combiner Rule #74: binop_left_undef_to_zero; wip_match_opcode 'G_UDIV'
     /* 2396 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 2399 */ // Label 151: @2399
     /* 2399 */ GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(2410), // Rule ID 120 //
     /* 2404 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 2407 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_UDIV'
     /* 2407 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 2410 */ // Label 152: @2410
     /* 2410 */ GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(2421), // Rule ID 212 //
     /* 2415 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 2418 */   // Combiner Rule #153: div_rem_to_divrem; wip_match_opcode 'G_UDIV'
     /* 2418 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 2421 */ // Label 153: @2421
     /* 2421 */ GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(2432), // Rule ID 241 //
     /* 2426 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2429 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_UDIV'
     /* 2429 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2432 */ // Label 154: @2432
     /* 2432 */ GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(2443), // Rule ID 283 //
     /* 2437 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 2440 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_UDIV'
     /* 2440 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 2443 */ // Label 155: @2443
     /* 2443 */ GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(2460), // Rule ID 302 //
     /* 2448 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 2451 */   GIM_MIFlagsNot, /*MI*/0, GIMT_Encode4(MachineInstr::IsExact),
     /* 2457 */   // MIs[0] dst
     /* 2457 */   // No operand predicates
     /* 2457 */   // MIs[0] x
     /* 2457 */   // No operand predicates
     /* 2457 */   // MIs[0] y
     /* 2457 */   // No operand predicates
     /* 2457 */   // Combiner Rule #184: udiv_by_pow2
     /* 2457 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner121),
     /* 2460 */ // Label 156: @2460
     /* 2460 */ GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(2471), // Rule ID 304 //
     /* 2465 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2468 */   // MIs[0] dst
     /* 2468 */   // No operand predicates
     /* 2468 */   // MIs[0] x
     /* 2468 */   // No operand predicates
     /* 2468 */   // MIs[0] y
     /* 2468 */   // No operand predicates
     /* 2468 */   // Combiner Rule #186: udiv_by_const
     /* 2468 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner120),
     /* 2471 */ // Label 157: @2471
     /* 2471 */ GIM_Reject,
     /* 2472 */ // Label 6: @2472
     /* 2472 */ GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(2483), // Rule ID 121 //
     /* 2477 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 2480 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_SREM'
     /* 2480 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 2483 */ // Label 158: @2483
     /* 2483 */ GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(2494), // Rule ID 213 //
     /* 2488 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 2491 */   // Combiner Rule #153: div_rem_to_divrem; wip_match_opcode 'G_SREM'
     /* 2491 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 2494 */ // Label 159: @2494
     /* 2494 */ GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(2505), // Rule ID 244 //
     /* 2499 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2502 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SREM'
     /* 2502 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2505 */ // Label 160: @2505
     /* 2505 */ GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(2516), // Rule ID 282 //
     /* 2510 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 2513 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_SREM'
     /* 2513 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 2516 */ // Label 161: @2516
     /* 2516 */ GIM_Reject,
     /* 2517 */ // Label 7: @2517
     /* 2517 */ GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(2528), // Rule ID 82 //
     /* 2522 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 2525 */   // Combiner Rule #74: binop_left_undef_to_zero; wip_match_opcode 'G_UREM'
     /* 2525 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 2528 */ // Label 162: @2528
     /* 2528 */ GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(2539), // Rule ID 122 //
     /* 2533 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 2536 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_UREM'
     /* 2536 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 2539 */ // Label 163: @2539
     /* 2539 */ GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(2550), // Rule ID 170 //
     /* 2544 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule128Enabled),
     /* 2547 */   // Combiner Rule #128: urem_pow2_to_mask; wip_match_opcode 'G_UREM'
     /* 2547 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner75),
     /* 2550 */ // Label 164: @2550
     /* 2550 */ GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(2561), // Rule ID 214 //
     /* 2555 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 2558 */   // Combiner Rule #153: div_rem_to_divrem; wip_match_opcode 'G_UREM'
     /* 2558 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 2561 */ // Label 165: @2561
     /* 2561 */ GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(2572), // Rule ID 243 //
     /* 2566 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2569 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_UREM'
     /* 2569 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2572 */ // Label 166: @2572
     /* 2572 */ GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(2583), // Rule ID 284 //
     /* 2577 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 2580 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_UREM'
     /* 2580 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 2583 */ // Label 167: @2583
     /* 2583 */ GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(2594), // Rule ID 301 //
     /* 2588 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule183Enabled),
     /* 2591 */   // MIs[0] dst
     /* 2591 */   // No operand predicates
     /* 2591 */   // MIs[0] x
     /* 2591 */   // No operand predicates
     /* 2591 */   // MIs[0] y
     /* 2591 */   // No operand predicates
     /* 2591 */   // Combiner Rule #183: urem_by_const
     /* 2591 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner120),
     /* 2594 */ // Label 168: @2594
     /* 2594 */ GIM_Reject,
     /* 2595 */ // Label 8: @2595
     /* 2595 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(2606), // Rule ID 73 //
     /* 2600 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule69Enabled),
     /* 2603 */   // Combiner Rule #69: load_and_mask; wip_match_opcode 'G_AND'
     /* 2603 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner31),
     /* 2606 */ // Label 169: @2606
     /* 2606 */ GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(2617), // Rule ID 77 //
     /* 2611 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule72Enabled),
     /* 2614 */   // Combiner Rule #72: undef_to_int_zero; wip_match_opcode 'G_AND'
     /* 2614 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner34),
     /* 2617 */ // Label 170: @2617
     /* 2617 */ GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(2628), // Rule ID 142 //
     /* 2622 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 2625 */   // Combiner Rule #104: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_AND'
     /* 2625 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 2628 */ // Label 171: @2628
     /* 2628 */ GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(2639), // Rule ID 162 //
     /* 2633 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule120Enabled),
     /* 2636 */   // Combiner Rule #120: narrow_binop_feeding_and; wip_match_opcode 'G_AND'
     /* 2636 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 2639 */ // Label 172: @2639
     /* 2639 */ GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(2650), // Rule ID 167 //
     /* 2644 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule125Enabled),
     /* 2647 */   // Combiner Rule #125: redundant_and; wip_match_opcode 'G_AND'
     /* 2647 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner72),
     /* 2650 */ // Label 173: @2650
     /* 2650 */ GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(2661), // Rule ID 184 //
     /* 2655 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule142Enabled),
     /* 2658 */   // Combiner Rule #142: overlapping_and; wip_match_opcode 'G_AND'
     /* 2658 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner84),
     /* 2661 */ // Label 174: @2661
     /* 2661 */ GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(2672), // Rule ID 233 //
     /* 2666 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2669 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_AND'
     /* 2669 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2672 */ // Label 175: @2672
     /* 2672 */ GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(2683), // Rule ID 266 //
     /* 2677 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule173Enabled),
     /* 2680 */   // Combiner Rule #173: and_or_disjoint_mask; wip_match_opcode 'G_AND'
     /* 2680 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner110),
     /* 2683 */ // Label 176: @2683
     /* 2683 */ GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(2694), // Rule ID 278 //
     /* 2688 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 2691 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_AND'
     /* 2691 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 2694 */ // Label 177: @2694
     /* 2694 */ GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(2705), // Rule ID 311 //
     /* 2699 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 2702 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_AND'
     /* 2702 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 2705 */ // Label 178: @2705
     /* 2705 */ GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(2716), // Rule ID 338 //
     /* 2710 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule193Enabled),
     /* 2713 */   // Combiner Rule #193: match_ands; wip_match_opcode 'G_AND'
     /* 2713 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner129),
     /* 2716 */ // Label 179: @2716
     /* 2716 */ GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(2814), // Rule ID 155 //
     /* 2721 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule113Enabled),
     /* 2724 */   // MIs[0] root
     /* 2724 */   // No operand predicates
     /* 2724 */   // MIs[0] d1
     /* 2724 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2728 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2732 */   // MIs[1] p
     /* 2732 */   // No operand predicates
     /* 2732 */   // MIs[1] s1
     /* 2732 */   GIM_RecordRegType, /*MI*/1, /*Op*/2, /*TempTypeIdx*/uint8_t(-1),
     /* 2736 */   // MIs[1] Operand 3
     /* 2736 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 2740 */   // MIs[0] d2
     /* 2740 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2744 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2748 */   // MIs[2] p
     /* 2748 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 2753 */   // MIs[2] s2
     /* 2753 */   // No operand predicates
     /* 2753 */   // MIs[2] Operand 3
     /* 2753 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/3, 0,
     /* 2757 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner5),
     /* 2761 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2763 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/uint8_t(-1),
     /* 2766 */   GIR_BuildConstant, /*TempRegID*/1, /*Val*/GIMT_Encode8(0),
     /* 2776 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 2779 */   // Combiner Rule #113: double_icmp_zero_and_combine
     /* 2779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_OR),
     /* 2782 */   GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2787 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 2791 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s2
     /* 2795 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2799 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // root
     /* 2803 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // p
     /* 2807 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/0,
     /* 2810 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 2813 */   GIR_EraseRootFromParent_Done,
     /* 2814 */ // Label 180: @2814
     /* 2814 */ GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(2851), // Rule ID 226 //
     /* 2819 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule163Enabled),
     /* 2822 */   // MIs[0] root
     /* 2822 */   // No operand predicates
     /* 2822 */   // MIs[0] shift
     /* 2822 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2826 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 2830 */   // MIs[1] x
     /* 2830 */   // No operand predicates
     /* 2830 */   // MIs[1] lsb
     /* 2830 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 2834 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2838 */   // MIs[2] imm1
     /* 2838 */   // No operand predicates
     /* 2838 */   // MIs[0] mask
     /* 2838 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2842 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2846 */   // MIs[3] imm2
     /* 2846 */   // No operand predicates
     /* 2846 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2848 */   // Combiner Rule #163: bitfield_extract_from_and
     /* 2848 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner101),
     /* 2851 */ // Label 181: @2851
     /* 2851 */ GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(2875), // Rule ID 114 //
     /* 2856 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 2859 */   // MIs[0] dst
     /* 2859 */   // No operand predicates
     /* 2859 */   // MIs[0] src
     /* 2859 */   // No operand predicates
     /* 2859 */   // MIs[0] src
     /* 2859 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 2864 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2869 */   // Combiner Rule #85: binop_same_val @ [__binop_same_val_match_0[0]]
     /* 2869 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2874 */   GIR_EraseRootFromParent_Done,
     /* 2875 */ // Label 182: @2875
     /* 2875 */ GIM_Reject,
     /* 2876 */ // Label 9: @2876
     /* 2876 */ GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(2887), // Rule ID 79 //
     /* 2881 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule73Enabled),
     /* 2884 */   // Combiner Rule #73: undef_to_negative_one; wip_match_opcode 'G_OR'
     /* 2884 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 2887 */ // Label 183: @2887
     /* 2887 */ GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(2898), // Rule ID 143 //
     /* 2892 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 2895 */   // Combiner Rule #104: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_OR'
     /* 2895 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 2898 */ // Label 184: @2898
     /* 2898 */ GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(2909), // Rule ID 169 //
     /* 2903 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule127Enabled),
     /* 2906 */   // Combiner Rule #127: redundant_or; wip_match_opcode 'G_OR'
     /* 2906 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner74),
     /* 2909 */ // Label 185: @2909
     /* 2909 */ GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(2920), // Rule ID 210 //
     /* 2914 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule152Enabled),
     /* 2917 */   // Combiner Rule #152: load_or_combine; wip_match_opcode 'G_OR'
     /* 2917 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner94),
     /* 2920 */ // Label 186: @2920
     /* 2920 */ GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(2931), // Rule ID 215 //
     /* 2925 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule154Enabled),
     /* 2928 */   // Combiner Rule #154: funnel_shift_from_or_shift; wip_match_opcode 'G_OR'
     /* 2928 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner96),
     /* 2931 */ // Label 187: @2931
     /* 2931 */ GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(2942), // Rule ID 237 //
     /* 2936 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2939 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_OR'
     /* 2939 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2942 */ // Label 188: @2942
     /* 2942 */ GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(2953), // Rule ID 279 //
     /* 2947 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 2950 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_OR'
     /* 2950 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 2953 */ // Label 189: @2953
     /* 2953 */ GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(2964), // Rule ID 312 //
     /* 2958 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 2961 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_OR'
     /* 2961 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 2964 */ // Label 190: @2964
     /* 2964 */ GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(2975), // Rule ID 339 //
     /* 2969 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule194Enabled),
     /* 2972 */   // Combiner Rule #194: match_ors; wip_match_opcode 'G_OR'
     /* 2972 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner130),
     /* 2975 */ // Label 191: @2975
     /* 2975 */ GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(3073), // Rule ID 156 //
     /* 2980 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule114Enabled),
     /* 2983 */   // MIs[0] root
     /* 2983 */   // No operand predicates
     /* 2983 */   // MIs[0] d1
     /* 2983 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2987 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2991 */   // MIs[1] p
     /* 2991 */   // No operand predicates
     /* 2991 */   // MIs[1] s1
     /* 2991 */   GIM_RecordRegType, /*MI*/1, /*Op*/2, /*TempTypeIdx*/uint8_t(-1),
     /* 2995 */   // MIs[1] Operand 3
     /* 2995 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 2999 */   // MIs[0] d2
     /* 2999 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 3003 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 3007 */   // MIs[2] p
     /* 3007 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 3012 */   // MIs[2] s2
     /* 3012 */   // No operand predicates
     /* 3012 */   // MIs[2] Operand 3
     /* 3012 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/3, 0,
     /* 3016 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner6),
     /* 3020 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3022 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/uint8_t(-1),
     /* 3025 */   GIR_BuildConstant, /*TempRegID*/1, /*Val*/GIMT_Encode8(0),
     /* 3035 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 3038 */   // Combiner Rule #114: double_icmp_zero_or_combine
     /* 3038 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_OR),
     /* 3041 */   GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 3046 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 3050 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s2
     /* 3054 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 3058 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // root
     /* 3062 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // p
     /* 3066 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/0,
     /* 3069 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 3072 */   GIR_EraseRootFromParent_Done,
     /* 3073 */ // Label 192: @3073
     /* 3073 */ GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(3097), // Rule ID 115 //
     /* 3078 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 3081 */   // MIs[0] dst
     /* 3081 */   // No operand predicates
     /* 3081 */   // MIs[0] src
     /* 3081 */   // No operand predicates
     /* 3081 */   // MIs[0] src
     /* 3081 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 3086 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3091 */   // Combiner Rule #85: binop_same_val @ [__binop_same_val_match_0[1]]
     /* 3091 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3096 */   GIR_EraseRootFromParent_Done,
     /* 3097 */ // Label 193: @3097
     /* 3097 */ GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(3120), // Rule ID 106 //
     /* 3102 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 3105 */   // MIs[0] dst
     /* 3105 */   // No operand predicates
     /* 3105 */   // MIs[0] lhs
     /* 3105 */   // No operand predicates
     /* 3105 */   // MIs[0] Operand 2
     /* 3105 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 3109 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3114 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[2]]
     /* 3114 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3119 */   GIR_EraseRootFromParent_Done,
     /* 3120 */ // Label 194: @3120
     /* 3120 */ GIM_Reject,
     /* 3121 */ // Label 10: @3121
     /* 3121 */ GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(3132), // Rule ID 96 //
     /* 3126 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 3129 */   // Combiner Rule #78: propagate_undef_any_op; wip_match_opcode 'G_XOR'
     /* 3129 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 3132 */ // Label 195: @3132
     /* 3132 */ GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(3143), // Rule ID 144 //
     /* 3137 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 3140 */   // Combiner Rule #104: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_XOR'
     /* 3140 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 3143 */ // Label 196: @3143
     /* 3143 */ GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(3154), // Rule ID 174 //
     /* 3148 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule132Enabled),
     /* 3151 */   // Combiner Rule #132: not_cmp_fold; wip_match_opcode 'G_XOR'
     /* 3151 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner79),
     /* 3154 */ // Label 197: @3154
     /* 3154 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(3165), // Rule ID 198 //
     /* 3159 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule148Enabled),
     /* 3162 */   // Combiner Rule #148: xor_of_and_with_same_reg; wip_match_opcode 'G_XOR'
     /* 3162 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner90),
     /* 3165 */ // Label 198: @3165
     /* 3165 */ GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(3176), // Rule ID 240 //
     /* 3170 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 3173 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_XOR'
     /* 3173 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 3176 */ // Label 199: @3176
     /* 3176 */ GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(3187), // Rule ID 280 //
     /* 3181 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 3184 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_XOR'
     /* 3184 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 3187 */ // Label 200: @3187
     /* 3187 */ GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(3198), // Rule ID 313 //
     /* 3192 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 3195 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_XOR'
     /* 3195 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 3198 */ // Label 201: @3198
     /* 3198 */ GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(3221), // Rule ID 107 //
     /* 3203 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 3206 */   // MIs[0] dst
     /* 3206 */   // No operand predicates
     /* 3206 */   // MIs[0] lhs
     /* 3206 */   // No operand predicates
     /* 3206 */   // MIs[0] Operand 2
     /* 3206 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 3210 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3215 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[3]]
     /* 3215 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3220 */   GIR_EraseRootFromParent_Done,
     /* 3221 */ // Label 202: @3221
     /* 3221 */ GIM_Reject,
     /* 3222 */ // Label 11: @3222
     /* 3222 */ GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(3233), // Rule ID 140 //
     /* 3227 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule102Enabled),
     /* 3230 */   // Combiner Rule #102: extend_through_phis; wip_match_opcode 'G_PHI'
     /* 3230 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner53),
     /* 3233 */ // Label 203: @3233
     /* 3233 */ GIM_Reject,
     /* 3234 */ // Label 12: @3234
     /* 3234 */ GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(3245), // Rule ID 364 //
     /* 3239 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule217Enabled),
     /* 3242 */   // Combiner Rule #217: fold_global_offset; wip_match_opcode 'G_GLOBAL_VALUE'
     /* 3242 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner153),
     /* 3245 */ // Label 204: @3245
     /* 3245 */ GIM_Reject,
     /* 3246 */ // Label 13: @3246
     /* 3246 */ GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(3257), // Rule ID 349 //
     /* 3251 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule204Enabled),
     /* 3254 */   // Combiner Rule #204: unmerge_anyext_build_vector; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3254 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner140),
     /* 3257 */ // Label 205: @3257
     /* 3257 */ GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(3268), // Rule ID 350 //
     /* 3262 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule205Enabled),
     /* 3265 */   // Combiner Rule #205: unmerge_merge; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3265 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner141),
     /* 3268 */ // Label 206: @3268
     /* 3268 */ GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(3279), // Rule ID 352 //
     /* 3273 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule207Enabled),
     /* 3276 */   // Combiner Rule #207: unmerge_cst; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3276 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner143),
     /* 3279 */ // Label 207: @3279
     /* 3279 */ GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(3290), // Rule ID 353 //
     /* 3284 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule208Enabled),
     /* 3287 */   // Combiner Rule #208: unmerge_undef; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3287 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner144),
     /* 3290 */ // Label 208: @3290
     /* 3290 */ GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(3301), // Rule ID 354 //
     /* 3295 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule209Enabled),
     /* 3298 */   // Combiner Rule #209: unmerge_dead_to_trunc; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3298 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner145),
     /* 3301 */ // Label 209: @3301
     /* 3301 */ GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(3312), // Rule ID 355 //
     /* 3306 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule210Enabled),
     /* 3309 */   // Combiner Rule #210: unmerge_zext_to_zext; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3309 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner146),
     /* 3312 */ // Label 210: @3312
     /* 3312 */ GIM_Reject,
     /* 3313 */ // Label 14: @3313
     /* 3313 */ GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(3324), // Rule ID 351 //
     /* 3318 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule206Enabled),
     /* 3321 */   // Combiner Rule #206: merge_unmerge; wip_match_opcode 'G_MERGE_VALUES'
     /* 3321 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner142),
     /* 3324 */ // Label 211: @3324
     /* 3324 */ GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(3386),
     /* 3329 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 3332 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(3353), // Rule ID 356 //
     /* 3337 */     GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule211Enabled),
     /* 3340 */     // MIs[0] root
     /* 3340 */     // No operand predicates
     /* 3340 */     // MIs[0] x
     /* 3340 */     // No operand predicates
     /* 3340 */     // MIs[0] undef
     /* 3340 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 3344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3350 */     // Combiner Rule #211: merge_of_x_and_undef
     /* 3350 */     GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner147),
     /* 3353 */   // Label 213: @3353
     /* 3353 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(3385), // Rule ID 357 //
     /* 3358 */     GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule212Enabled),
     /* 3361 */     // MIs[0] root
     /* 3361 */     // No operand predicates
     /* 3361 */     // MIs[0] x
     /* 3361 */     // No operand predicates
     /* 3361 */     // MIs[0] zero
     /* 3361 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 3365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3369 */     // MIs[1] Operand 1
     /* 3369 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/1, GIMT_Encode8(0),
     /* 3380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3382 */     // Combiner Rule #212: merge_of_x_and_zero
     /* 3382 */     GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner148),
     /* 3385 */   // Label 214: @3385
     /* 3385 */   GIM_Reject,
     /* 3386 */ // Label 212: @3386
     /* 3386 */ GIM_Reject,
     /* 3387 */ // Label 15: @3387
     /* 3387 */ GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(3398), // Rule ID 69 //
     /* 3392 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule67Enabled),
     /* 3395 */   // Combiner Rule #67: extract_all_elts_from_build_vector; wip_match_opcode 'G_BUILD_VECTOR'
     /* 3395 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner29),
     /* 3398 */ // Label 215: @3398
     /* 3398 */ GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(3409), // Rule ID 98 //
     /* 3403 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule79Enabled),
     /* 3406 */   // Combiner Rule #79: propagate_undef_all_ops; wip_match_opcode 'G_BUILD_VECTOR'
     /* 3406 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner40),
     /* 3409 */ // Label 216: @3409
     /* 3409 */ GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(3420), // Rule ID 133 //
     /* 3414 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule95Enabled),
     /* 3417 */   // Combiner Rule #95: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR'
     /* 3417 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner49),
     /* 3420 */ // Label 217: @3420
     /* 3420 */ GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(3434), // Rule ID 348 //
     /* 3425 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule203Enabled),
     /* 3428 */   GIM_CheckNumOperandsGE, /*MI*/0, /*Expected*/2,
     /* 3431 */   // MIs[0] dst
     /* 3431 */   // No operand predicates
     /* 3431 */   // MIs[0] unused
     /* 3431 */   // No operand predicates
     /* 3431 */   // Combiner Rule #203: combine_use_vector_truncate
     /* 3431 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner139),
     /* 3434 */ // Label 218: @3434
     /* 3434 */ GIM_Reject,
     /* 3435 */ // Label 16: @3435
     /* 3435 */ GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(3446), // Rule ID 132 //
     /* 3440 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule95Enabled),
     /* 3443 */   // Combiner Rule #95: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR_TRUNC'
     /* 3443 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner49),
     /* 3446 */ // Label 219: @3446
     /* 3446 */ GIM_Reject,
     /* 3447 */ // Label 17: @3447
     /* 3447 */ GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(3458), // Rule ID 341 //
     /* 3452 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule196Enabled),
     /* 3455 */   // Combiner Rule #196: combine_concat_vector; wip_match_opcode 'G_CONCAT_VECTORS'
     /* 3455 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner132),
     /* 3458 */ // Label 220: @3458
     /* 3458 */ GIM_Reject,
     /* 3459 */ // Label 18: @3459
     /* 3459 */ GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(3480), // Rule ID 125 //
     /* 3464 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule89Enabled),
     /* 3467 */   // MIs[0] dst
     /* 3467 */   // No operand predicates
     /* 3467 */   // MIs[0] t
     /* 3467 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3471 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTTOPTR),
     /* 3475 */   // MIs[1] ptr
     /* 3475 */   // No operand predicates
     /* 3475 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3477 */   // Combiner Rule #89: i2p_to_p2i
     /* 3477 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner47),
     /* 3480 */ // Label 221: @3480
     /* 3480 */ GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(3501), // Rule ID 90 //
     /* 3485 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 3488 */   // MIs[0] dst
     /* 3488 */   // No operand predicates
     /* 3488 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3488 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3492 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3496 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3498 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[3]]
     /* 3498 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 3501 */ // Label 222: @3501
     /* 3501 */ GIM_Reject,
     /* 3502 */ // Label 19: @3502
     /* 3502 */ GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(3513), // Rule ID 124 //
     /* 3507 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 3510 */   // Combiner Rule #88: p2i_to_i2p; wip_match_opcode 'G_INTTOPTR'
     /* 3510 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner46),
     /* 3513 */ // Label 223: @3513
     /* 3513 */ GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(3534), // Rule ID 91 //
     /* 3518 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 3521 */   // MIs[0] dst
     /* 3521 */   // No operand predicates
     /* 3521 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3521 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3525 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3529 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3531 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[4]]
     /* 3531 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 3534 */ // Label 224: @3534
     /* 3534 */ GIM_Reject,
     /* 3535 */ // Label 20: @3535
     /* 3535 */ GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(3556), // Rule ID 136 //
     /* 3540 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule98Enabled),
     /* 3543 */   // MIs[0] dst
     /* 3543 */   // No operand predicates
     /* 3543 */   // MIs[0] src1
     /* 3543 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3547 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 3551 */   // MIs[1] src0
     /* 3551 */   // No operand predicates
     /* 3551 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3553 */   // Combiner Rule #98: bitcast_bitcast_fold
     /* 3553 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner52),
     /* 3556 */ // Label 225: @3556
     /* 3556 */ GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(3577), // Rule ID 88 //
     /* 3561 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 3564 */   // MIs[0] dst
     /* 3564 */   // No operand predicates
     /* 3564 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3564 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3568 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3572 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3574 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[1]]
     /* 3574 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 3577 */ // Label 226: @3577
     /* 3577 */ GIM_Reject,
     /* 3578 */ // Label 21: @3578
     /* 3578 */ GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(3607), // Rule ID 18 //
     /* 3583 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 3586 */   // MIs[0] dst
     /* 3586 */   // No operand predicates
     /* 3586 */   // MIs[0] src
     /* 3586 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3590 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FREEZE),
     /* 3594 */   // MIs[1] __idempotent_prop_match_0.x
     /* 3594 */   // No operand predicates
     /* 3594 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3599 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3601 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[0]]
     /* 3601 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3606 */   GIR_EraseRootFromParent_Done,
     /* 3607 */ // Label 227: @3607
     /* 3607 */ GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(3630), // Rule ID 43 //
     /* 3612 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule41Enabled),
     /* 3615 */   // MIs[0] root
     /* 3615 */   // No operand predicates
     /* 3615 */   // MIs[0] src
     /* 3615 */   // No operand predicates
     /* 3615 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner1),
     /* 3619 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3624 */   // Combiner Rule #41: freeze_of_non_undef_non_poison
     /* 3624 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3629 */   GIR_EraseRootFromParent_Done,
     /* 3630 */ // Label 228: @3630
     /* 3630 */ GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(3641), // Rule ID 44 //
     /* 3635 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule42Enabled),
     /* 3638 */   // MIs[0] dst
     /* 3638 */   // No operand predicates
     /* 3638 */   // MIs[0] src
     /* 3638 */   // No operand predicates
     /* 3638 */   // Combiner Rule #42: push_freeze_to_prevent_poison_from_propagating
     /* 3638 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner19),
     /* 3641 */ // Label 229: @3641
     /* 3641 */ GIM_Reject,
     /* 3642 */ // Label 22: @3642
     /* 3642 */ GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(3653), // Rule ID 70 //
     /* 3647 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule68Enabled),
     /* 3650 */   // Combiner Rule #68: extending_loads; wip_match_opcode 'G_LOAD'
     /* 3650 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner30),
     /* 3653 */ // Label 230: @3653
     /* 3653 */ GIM_Reject,
     /* 3654 */ // Label 23: @3654
     /* 3654 */ GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(3665), // Rule ID 71 //
     /* 3659 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule68Enabled),
     /* 3662 */   // Combiner Rule #68: extending_loads; wip_match_opcode 'G_SEXTLOAD'
     /* 3662 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner30),
     /* 3665 */ // Label 231: @3665
     /* 3665 */ GIM_Reject,
     /* 3666 */ // Label 24: @3666
     /* 3666 */ GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(3677), // Rule ID 72 //
     /* 3671 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule68Enabled),
     /* 3674 */   // Combiner Rule #68: extending_loads; wip_match_opcode 'G_ZEXTLOAD'
     /* 3674 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner30),
     /* 3677 */ // Label 232: @3677
     /* 3677 */ GIM_Reject,
     /* 3678 */ // Label 25: @3678
     /* 3678 */ GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(3689), // Rule ID 100 //
     /* 3683 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule81Enabled),
     /* 3686 */   // Combiner Rule #81: erase_undef_store; wip_match_opcode 'G_STORE'
     /* 3686 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 3689 */ // Label 233: @3689
     /* 3689 */ GIM_Reject,
     /* 3690 */ // Label 26: @3690
     /* 3690 */ GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(3701), // Rule ID 126 //
     /* 3695 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule90Enabled),
     /* 3698 */   // Combiner Rule #90: anyext_trunc_fold; wip_match_opcode 'G_ANYEXT'
     /* 3698 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner48),
     /* 3701 */ // Label 234: @3701
     /* 3701 */ GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(3712), // Rule ID 257 //
     /* 3706 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule169Enabled),
     /* 3709 */   // Combiner Rule #169: constant_fold_cast_op; wip_match_opcode 'G_ANYEXT'
     /* 3709 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner107),
     /* 3712 */ // Label 235: @3712
     /* 3712 */ GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(3733), // Rule ID 57 //
     /* 3717 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule55Enabled),
     /* 3720 */   // MIs[0] root
     /* 3720 */   // No operand predicates
     /* 3720 */   // MIs[0] select
     /* 3720 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3724 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 3728 */   // MIs[1] cond
     /* 3728 */   // No operand predicates
     /* 3728 */   // MIs[1] true
     /* 3728 */   // No operand predicates
     /* 3728 */   // MIs[1] false
     /* 3728 */   // No operand predicates
     /* 3728 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3730 */   // Combiner Rule #55: select_of_anyext
     /* 3730 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner23),
     /* 3733 */ // Label 236: @3733
     /* 3733 */ GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(3754), // Rule ID 52 //
     /* 3738 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule50Enabled),
     /* 3741 */   // MIs[0] root
     /* 3741 */   // No operand predicates
     /* 3741 */   // MIs[0] second
     /* 3741 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3745 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 3749 */   // MIs[1] src
     /* 3749 */   // No operand predicates
     /* 3749 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3751 */   // Combiner Rule #50: anyext_of_anyext
     /* 3751 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3754 */ // Label 237: @3754
     /* 3754 */ GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(3775), // Rule ID 54 //
     /* 3759 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule52Enabled),
     /* 3762 */   // MIs[0] root
     /* 3762 */   // No operand predicates
     /* 3762 */   // MIs[0] second
     /* 3762 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3766 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 3770 */   // MIs[1] src
     /* 3770 */   // No operand predicates
     /* 3770 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3772 */   // Combiner Rule #52: anyext_of_sext
     /* 3772 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3775 */ // Label 238: @3775
     /* 3775 */ GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(3796), // Rule ID 53 //
     /* 3780 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 3783 */   // MIs[0] root
     /* 3783 */   // No operand predicates
     /* 3783 */   // MIs[0] second
     /* 3783 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3787 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 3791 */   // MIs[1] src
     /* 3791 */   // No operand predicates
     /* 3791 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3793 */   // Combiner Rule #51: anyext_of_zext
     /* 3793 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3796 */ // Label 239: @3796
     /* 3796 */ GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(3817), // Rule ID 89 //
     /* 3801 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 3804 */   // MIs[0] dst
     /* 3804 */   // No operand predicates
     /* 3804 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3804 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3808 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3812 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3814 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[2]]
     /* 3814 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 3817 */ // Label 240: @3817
     /* 3817 */ GIM_Reject,
     /* 3818 */ // Label 27: @3818
     /* 3818 */ GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(3829), // Rule ID 134 //
     /* 3823 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule96Enabled),
     /* 3826 */   // Combiner Rule #96: trunc_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 3826 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner50),
     /* 3829 */ // Label 241: @3829
     /* 3829 */ GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(3840), // Rule ID 135 //
     /* 3834 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule97Enabled),
     /* 3837 */   // Combiner Rule #97: trunc_lshr_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 3837 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner51),
     /* 3840 */ // Label 242: @3840
     /* 3840 */ GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(3851), // Rule ID 173 //
     /* 3845 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule131Enabled),
     /* 3848 */   // Combiner Rule #131: trunc_shift; wip_match_opcode 'G_TRUNC'
     /* 3848 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner78),
     /* 3851 */ // Label 243: @3851
     /* 3851 */ GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(3872), // Rule ID 58 //
     /* 3856 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule56Enabled),
     /* 3859 */   // MIs[0] root
     /* 3859 */   // No operand predicates
     /* 3859 */   // MIs[0] select
     /* 3859 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3863 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 3867 */   // MIs[1] cond
     /* 3867 */   // No operand predicates
     /* 3867 */   // MIs[1] true
     /* 3867 */   // No operand predicates
     /* 3867 */   // MIs[1] false
     /* 3867 */   // No operand predicates
     /* 3867 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3869 */   // Combiner Rule #56: select_of_truncate
     /* 3869 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner23),
     /* 3872 */ // Label 244: @3872
     /* 3872 */ GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(3901), // Rule ID 60 //
     /* 3877 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule58Enabled),
     /* 3880 */   // MIs[0] root
     /* 3880 */   // No operand predicates
     /* 3880 */   // MIs[0] binop
     /* 3880 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3884 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 3888 */   // MIs[1] x
     /* 3888 */   // No operand predicates
     /* 3888 */   // MIs[1] const
     /* 3888 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3892 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3896 */   // MIs[2] imm
     /* 3896 */   // No operand predicates
     /* 3896 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3898 */   // Combiner Rule #58: narrow_binop_add
     /* 3898 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3901 */ // Label 245: @3901
     /* 3901 */ GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(3930), // Rule ID 63 //
     /* 3906 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule61Enabled),
     /* 3909 */   // MIs[0] root
     /* 3909 */   // No operand predicates
     /* 3909 */   // MIs[0] binop
     /* 3909 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3913 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 3917 */   // MIs[1] x
     /* 3917 */   // No operand predicates
     /* 3917 */   // MIs[1] const
     /* 3917 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3921 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3925 */   // MIs[2] imm
     /* 3925 */   // No operand predicates
     /* 3925 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3927 */   // Combiner Rule #61: narrow_binop_and
     /* 3927 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3930 */ // Label 246: @3930
     /* 3930 */ GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(3959), // Rule ID 62 //
     /* 3935 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule60Enabled),
     /* 3938 */   // MIs[0] root
     /* 3938 */   // No operand predicates
     /* 3938 */   // MIs[0] binop
     /* 3938 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3942 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 3946 */   // MIs[1] x
     /* 3946 */   // No operand predicates
     /* 3946 */   // MIs[1] const
     /* 3946 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3950 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3954 */   // MIs[2] imm
     /* 3954 */   // No operand predicates
     /* 3954 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3956 */   // Combiner Rule #60: narrow_binop_mul
     /* 3956 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3959 */ // Label 247: @3959
     /* 3959 */ GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(3988), // Rule ID 64 //
     /* 3964 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule62Enabled),
     /* 3967 */   // MIs[0] root
     /* 3967 */   // No operand predicates
     /* 3967 */   // MIs[0] binop
     /* 3967 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3971 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 3975 */   // MIs[1] x
     /* 3975 */   // No operand predicates
     /* 3975 */   // MIs[1] const
     /* 3975 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3979 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3983 */   // MIs[2] imm
     /* 3983 */   // No operand predicates
     /* 3983 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3985 */   // Combiner Rule #62: narrow_binop_or
     /* 3985 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3988 */ // Label 248: @3988
     /* 3988 */ GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(4017), // Rule ID 61 //
     /* 3993 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule59Enabled),
     /* 3996 */   // MIs[0] root
     /* 3996 */   // No operand predicates
     /* 3996 */   // MIs[0] binop
     /* 3996 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4000 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 4004 */   // MIs[1] x
     /* 4004 */   // No operand predicates
     /* 4004 */   // MIs[1] const
     /* 4004 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 4008 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 4012 */   // MIs[2] imm
     /* 4012 */   // No operand predicates
     /* 4012 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 4014 */   // Combiner Rule #59: narrow_binop_sub
     /* 4014 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 4017 */ // Label 249: @4017
     /* 4017 */ GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(4046), // Rule ID 65 //
     /* 4022 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule63Enabled),
     /* 4025 */   // MIs[0] root
     /* 4025 */   // No operand predicates
     /* 4025 */   // MIs[0] binop
     /* 4025 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4029 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 4033 */   // MIs[1] x
     /* 4033 */   // No operand predicates
     /* 4033 */   // MIs[1] const
     /* 4033 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 4037 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 4041 */   // MIs[2] imm
     /* 4041 */   // No operand predicates
     /* 4041 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 4043 */   // Combiner Rule #63: narrow_binop_xor
     /* 4043 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 4046 */ // Label 250: @4046
     /* 4046 */ GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(4067), // Rule ID 47 //
     /* 4051 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule45Enabled),
     /* 4054 */   // MIs[0] root
     /* 4054 */   // No operand predicates
     /* 4054 */   // MIs[0] ext
     /* 4054 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4058 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 4062 */   // MIs[1] src
     /* 4062 */   // No operand predicates
     /* 4062 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4064 */   // Combiner Rule #45: truncate_of_anyext
     /* 4064 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 4067 */ // Label 251: @4067
     /* 4067 */ GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(4091), // Rule ID 59 //
     /* 4072 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule57Enabled),
     /* 4075 */   // MIs[0] root
     /* 4075 */   // No operand predicates
     /* 4075 */   // MIs[0] bv
     /* 4075 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4079 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 4083 */   GIM_CheckNumOperandsGE, /*MI*/1, /*Expected*/2,
     /* 4086 */   // MIs[1] unused
     /* 4086 */   // No operand predicates
     /* 4086 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4088 */   // Combiner Rule #57: buildvector_of_truncate
     /* 4088 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 4091 */ // Label 252: @4091
     /* 4091 */ GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(4112), // Rule ID 46 //
     /* 4096 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule44Enabled),
     /* 4099 */   // MIs[0] root
     /* 4099 */   // No operand predicates
     /* 4099 */   // MIs[0] ext
     /* 4099 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4103 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 4107 */   // MIs[1] src
     /* 4107 */   // No operand predicates
     /* 4107 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4109 */   // Combiner Rule #44: truncate_of_sext
     /* 4109 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 4112 */ // Label 253: @4112
     /* 4112 */ GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(4133), // Rule ID 45 //
     /* 4117 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule43Enabled),
     /* 4120 */   // MIs[0] root
     /* 4120 */   // No operand predicates
     /* 4120 */   // MIs[0] ext
     /* 4120 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4124 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 4128 */   // MIs[1] src
     /* 4128 */   // No operand predicates
     /* 4128 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4130 */   // Combiner Rule #43: truncate_of_zext
     /* 4130 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 4133 */ // Label 254: @4133
     /* 4133 */ GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(4154), // Rule ID 87 //
     /* 4138 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 4141 */   // MIs[0] dst
     /* 4141 */   // No operand predicates
     /* 4141 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 4141 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4145 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 4149 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4151 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[0]]
     /* 4151 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 4154 */ // Label 255: @4154
     /* 4154 */ GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(4175), // Rule ID 66 //
     /* 4159 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule64Enabled),
     /* 4162 */   // MIs[0] root
     /* 4162 */   // No operand predicates
     /* 4162 */   // MIs[0] int
     /* 4162 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4166 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 4170 */   // MIs[1] imm
     /* 4170 */   // No operand predicates
     /* 4170 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4172 */   // Combiner Rule #64: integer_of_truncate
     /* 4172 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner26),
     /* 4175 */ // Label 256: @4175
     /* 4175 */ GIM_Reject,
     /* 4176 */ // Label 28: @4176
     /* 4176 */ GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(4187), // Rule ID 362 //
     /* 4181 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule215Enabled),
     /* 4184 */   // MIs[0] dst
     /* 4184 */   // No operand predicates
     /* 4184 */   // MIs[0] src
     /* 4184 */   // No operand predicates
     /* 4184 */   // Combiner Rule #215: fconstant_to_constant
     /* 4184 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner151),
     /* 4187 */ // Label 257: @4187
     /* 4187 */ GIM_Reject,
     /* 4188 */ // Label 29: @4188
     /* 4188 */ GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(4199), // Rule ID 256 //
     /* 4193 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule169Enabled),
     /* 4196 */   // Combiner Rule #169: constant_fold_cast_op; wip_match_opcode 'G_SEXT'
     /* 4196 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner107),
     /* 4199 */ // Label 258: @4199
     /* 4199 */ GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(4220), // Rule ID 51 //
     /* 4204 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule49Enabled),
     /* 4207 */   // MIs[0] root
     /* 4207 */   // No operand predicates
     /* 4207 */   // MIs[0] second
     /* 4207 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4211 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 4215 */   // MIs[1] src
     /* 4215 */   // No operand predicates
     /* 4215 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4217 */   // Combiner Rule #49: sext_of_anyext
     /* 4217 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 4220 */ // Label 259: @4220
     /* 4220 */ GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(4241), // Rule ID 50 //
     /* 4225 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 4228 */   // MIs[0] root
     /* 4228 */   // No operand predicates
     /* 4228 */   // MIs[0] second
     /* 4228 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4232 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 4236 */   // MIs[1] src
     /* 4236 */   // No operand predicates
     /* 4236 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4238 */   // Combiner Rule #48: sext_of_sext
     /* 4238 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 4241 */ // Label 260: @4241
     /* 4241 */ GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(4262), // Rule ID 342 //
     /* 4246 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule197Enabled),
     /* 4249 */   // MIs[0] root
     /* 4249 */   // No operand predicates
     /* 4249 */   // MIs[0] src
     /* 4249 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4253 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 4257 */   // MIs[1] x
     /* 4257 */   // No operand predicates
     /* 4257 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4259 */   // Combiner Rule #197: sext_trunc
     /* 4259 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner133),
     /* 4262 */ // Label 261: @4262
     /* 4262 */ GIM_Reject,
     /* 4263 */ // Label 30: @4263
     /* 4263 */ GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(4274), // Rule ID 160 //
     /* 4268 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule118Enabled),
     /* 4271 */   // Combiner Rule #118: sext_inreg_of_load; wip_match_opcode 'G_SEXT_INREG'
     /* 4271 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner66),
     /* 4274 */ // Label 262: @4274
     /* 4274 */ GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(4285), // Rule ID 168 //
     /* 4279 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule126Enabled),
     /* 4282 */   // Combiner Rule #126: redundant_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
     /* 4282 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner73),
     /* 4285 */ // Label 263: @4285
     /* 4285 */ GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(4296), // Rule ID 225 //
     /* 4290 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule162Enabled),
     /* 4293 */   // Combiner Rule #162: bitfield_extract_from_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
     /* 4293 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner100),
     /* 4296 */ // Label 264: @4296
     /* 4296 */ GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(4317), // Rule ID 55 //
     /* 4301 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule53Enabled),
     /* 4304 */   // MIs[0] dst
     /* 4304 */   // No operand predicates
     /* 4304 */   // MIs[0] x
     /* 4304 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4308 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 4312 */   // MIs[1] src
     /* 4312 */   // No operand predicates
     /* 4312 */   // MIs[1] a
     /* 4312 */   // No operand predicates
     /* 4312 */   // MIs[0] b
     /* 4312 */   // No operand predicates
     /* 4312 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4314 */   // Combiner Rule #53: sext_inreg_of_sext_inreg
     /* 4314 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner22),
     /* 4317 */ // Label 265: @4317
     /* 4317 */ GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(4328), // Rule ID 172 //
     /* 4322 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule130Enabled),
     /* 4325 */   // MIs[0] dst
     /* 4325 */   // No operand predicates
     /* 4325 */   // MIs[0] src
     /* 4325 */   // No operand predicates
     /* 4325 */   // MIs[0] imm
     /* 4325 */   // No operand predicates
     /* 4325 */   // Combiner Rule #130: sext_inreg_to_zext_inreg
     /* 4325 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner77),
     /* 4328 */ // Label 266: @4328
     /* 4328 */ GIM_Reject,
     /* 4329 */ // Label 31: @4329
     /* 4329 */ GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(4340), // Rule ID 171 //
     /* 4334 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule129Enabled),
     /* 4337 */   // Combiner Rule #129: zext_trunc_fold; wip_match_opcode 'G_ZEXT'
     /* 4337 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner76),
     /* 4340 */ // Label 267: @4340
     /* 4340 */ GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(4351), // Rule ID 255 //
     /* 4345 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule169Enabled),
     /* 4348 */   // Combiner Rule #169: constant_fold_cast_op; wip_match_opcode 'G_ZEXT'
     /* 4348 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner107),
     /* 4351 */ // Label 268: @4351
     /* 4351 */ GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(4372), // Rule ID 56 //
     /* 4356 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule54Enabled),
     /* 4359 */   // MIs[0] root
     /* 4359 */   // No operand predicates
     /* 4359 */   // MIs[0] select
     /* 4359 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4363 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 4367 */   // MIs[1] cond
     /* 4367 */   // No operand predicates
     /* 4367 */   // MIs[1] true
     /* 4367 */   // No operand predicates
     /* 4367 */   // MIs[1] false
     /* 4367 */   // No operand predicates
     /* 4367 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4369 */   // Combiner Rule #54: select_of_zext
     /* 4369 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner23),
     /* 4372 */ // Label 269: @4372
     /* 4372 */ GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(4393), // Rule ID 49 //
     /* 4377 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule47Enabled),
     /* 4380 */   // MIs[0] root
     /* 4380 */   // No operand predicates
     /* 4380 */   // MIs[0] second
     /* 4380 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4384 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 4388 */   // MIs[1] src
     /* 4388 */   // No operand predicates
     /* 4388 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4390 */   // Combiner Rule #47: zext_of_anyext
     /* 4390 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 4393 */ // Label 270: @4393
     /* 4393 */ GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(4420), // Rule ID 343 //
     /* 4398 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule198Enabled),
     /* 4401 */   // MIs[0] root
     /* 4401 */   // No operand predicates
     /* 4401 */   // MIs[0] src
     /* 4401 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4405 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 4409 */   GIM_MIFlags, /*MI*/1, GIMT_Encode4(MachineInstr::NoUWrap),
     /* 4415 */   // MIs[1] x
     /* 4415 */   // No operand predicates
     /* 4415 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4417 */   // Combiner Rule #198: zext_trunc
     /* 4417 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner134),
     /* 4420 */ // Label 271: @4420
     /* 4420 */ GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(4441), // Rule ID 48 //
     /* 4425 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule46Enabled),
     /* 4428 */   // MIs[0] root
     /* 4428 */   // No operand predicates
     /* 4428 */   // MIs[0] second
     /* 4428 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4432 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 4436 */   // MIs[1] src
     /* 4436 */   // No operand predicates
     /* 4436 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4438 */   // Combiner Rule #46: zext_of_zext
     /* 4438 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 4441 */ // Label 272: @4441
     /* 4441 */ GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(4458), // Rule ID 344 //
     /* 4446 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule199Enabled),
     /* 4449 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NonNeg),
     /* 4455 */   // MIs[0] root
     /* 4455 */   // No operand predicates
     /* 4455 */   // MIs[0] x
     /* 4455 */   // No operand predicates
     /* 4455 */   // Combiner Rule #199: nneg_zext
     /* 4455 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner135),
     /* 4458 */ // Label 273: @4458
     /* 4458 */ GIM_Reject,
     /* 4459 */ // Label 32: @4459
     /* 4459 */ GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(4470), // Rule ID 80 //
     /* 4464 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 4467 */   // Combiner Rule #74: binop_left_undef_to_zero; wip_match_opcode 'G_SHL'
     /* 4467 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 4470 */ // Label 274: @4470
     /* 4470 */ GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(4481), // Rule ID 83 //
     /* 4475 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 4478 */   // Combiner Rule #75: binop_right_undef_to_undef; wip_match_opcode 'G_SHL'
     /* 4478 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 4481 */ // Label 275: @4481
     /* 4481 */ GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(4492), // Rule ID 116 //
     /* 4486 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 4489 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_SHL'
     /* 4489 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 4492 */ // Label 276: @4492
     /* 4492 */ GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(4503), // Rule ID 200 //
     /* 4497 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 4500 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_SHL'
     /* 4500 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 4503 */ // Label 277: @4503
     /* 4503 */ GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(4514), // Rule ID 205 //
     /* 4508 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 4511 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_SHL'
     /* 4511 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 4514 */ // Label 278: @4514
     /* 4514 */ GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(4525), // Rule ID 224 //
     /* 4519 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule161Enabled),
     /* 4522 */   // Combiner Rule #161: commute_shift; wip_match_opcode 'G_SHL'
     /* 4522 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner99),
     /* 4525 */ // Label 279: @4525
     /* 4525 */ GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(4536), // Rule ID 238 //
     /* 4530 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 4533 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SHL'
     /* 4533 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 4536 */ // Label 280: @4536
     /* 4536 */ GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(4547), // Rule ID 287 //
     /* 4541 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 4544 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_SHL'
     /* 4544 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 4547 */ // Label 281: @4547
     /* 4547 */ GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(4582), // Rule ID 41 //
     /* 4552 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule39Enabled),
     /* 4555 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 4561 */   // MIs[0] root
     /* 4561 */   // No operand predicates
     /* 4561 */   // MIs[0] left
     /* 4561 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4565 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 4569 */   // MIs[1] imm
     /* 4569 */   // No operand predicates
     /* 4569 */   // MIs[0] x
     /* 4569 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 4573 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 4577 */   // MIs[2] imm1
     /* 4577 */   // No operand predicates
     /* 4577 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 4579 */   // Combiner Rule #39: shl_of_vscale
     /* 4579 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner17),
     /* 4582 */ // Label 282: @4582
     /* 4582 */ GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(4605), // Rule ID 108 //
     /* 4587 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 4590 */   // MIs[0] dst
     /* 4590 */   // No operand predicates
     /* 4590 */   // MIs[0] lhs
     /* 4590 */   // No operand predicates
     /* 4590 */   // MIs[0] Operand 2
     /* 4590 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4594 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4599 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[4]]
     /* 4599 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4604 */   GIR_EraseRootFromParent_Done,
     /* 4605 */ // Label 283: @4605
     /* 4605 */ GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(4616), // Rule ID 145 //
     /* 4610 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule105Enabled),
     /* 4613 */   // MIs[0] root
     /* 4613 */   // No operand predicates
     /* 4613 */   // MIs[0] mi.shifted
     /* 4613 */   // No operand predicates
     /* 4613 */   // MIs[0] mi.amt
     /* 4613 */   // No operand predicates
     /* 4613 */   // Combiner Rule #105: shifts_too_big @ [mi[0]]
     /* 4613 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 4616 */ // Label 284: @4616
     /* 4616 */ GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(4627), // Rule ID 161 //
     /* 4621 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule119Enabled),
     /* 4624 */   // MIs[0] dst
     /* 4624 */   // No operand predicates
     /* 4624 */   // MIs[0] src0
     /* 4624 */   // No operand predicates
     /* 4624 */   // MIs[0] src1
     /* 4624 */   // No operand predicates
     /* 4624 */   // Combiner Rule #119: reduce_shl_of_extend
     /* 4624 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 4627 */ // Label 285: @4627
     /* 4627 */ GIM_Reject,
     /* 4628 */ // Label 33: @4628
     /* 4628 */ GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(4639), // Rule ID 85 //
     /* 4633 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 4636 */   // Combiner Rule #75: binop_right_undef_to_undef; wip_match_opcode 'G_LSHR'
     /* 4636 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 4639 */ // Label 286: @4639
     /* 4639 */ GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(4650), // Rule ID 117 //
     /* 4644 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 4647 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_LSHR'
     /* 4647 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 4650 */ // Label 287: @4650
     /* 4650 */ GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(4661), // Rule ID 202 //
     /* 4655 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 4658 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_LSHR'
     /* 4658 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 4661 */ // Label 288: @4661
     /* 4661 */ GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(4672), // Rule ID 207 //
     /* 4666 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 4669 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_LSHR'
     /* 4669 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 4672 */ // Label 289: @4672
     /* 4672 */ GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(4683), // Rule ID 228 //
     /* 4677 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 4680 */   // Combiner Rule #164: bitfield_extract_from_shr; wip_match_opcode 'G_LSHR'
     /* 4680 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner102),
     /* 4683 */ // Label 290: @4683
     /* 4683 */ GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(4694), // Rule ID 230 //
     /* 4688 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 4691 */   // Combiner Rule #165: bitfield_extract_from_shr_and; wip_match_opcode 'G_LSHR'
     /* 4691 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 4694 */ // Label 291: @4694
     /* 4694 */ GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(4705), // Rule ID 235 //
     /* 4699 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 4702 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_LSHR'
     /* 4702 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 4705 */ // Label 292: @4705
     /* 4705 */ GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(4716), // Rule ID 285 //
     /* 4710 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 4713 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_LSHR'
     /* 4713 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 4716 */ // Label 293: @4716
     /* 4716 */ GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(4739), // Rule ID 110 //
     /* 4721 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 4724 */   // MIs[0] dst
     /* 4724 */   // No operand predicates
     /* 4724 */   // MIs[0] lhs
     /* 4724 */   // No operand predicates
     /* 4724 */   // MIs[0] Operand 2
     /* 4724 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4728 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4733 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[6]]
     /* 4733 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4738 */   GIR_EraseRootFromParent_Done,
     /* 4739 */ // Label 294: @4739
     /* 4739 */ GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(4750), // Rule ID 147 //
     /* 4744 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule105Enabled),
     /* 4747 */   // MIs[0] root
     /* 4747 */   // No operand predicates
     /* 4747 */   // MIs[0] mi.shifted
     /* 4747 */   // No operand predicates
     /* 4747 */   // MIs[0] mi.amt
     /* 4747 */   // No operand predicates
     /* 4747 */   // Combiner Rule #105: shifts_too_big @ [mi[2]]
     /* 4747 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 4750 */ // Label 295: @4750
     /* 4750 */ GIM_Reject,
     /* 4751 */ // Label 34: @4751
     /* 4751 */ GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(4762), // Rule ID 84 //
     /* 4756 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 4759 */   // Combiner Rule #75: binop_right_undef_to_undef; wip_match_opcode 'G_ASHR'
     /* 4759 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 4762 */ // Label 296: @4762
     /* 4762 */ GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(4773), // Rule ID 118 //
     /* 4767 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 4770 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_ASHR'
     /* 4770 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 4773 */ // Label 297: @4773
     /* 4773 */ GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(4784), // Rule ID 158 //
     /* 4778 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule116Enabled),
     /* 4781 */   // Combiner Rule #116: shl_ashr_to_sext_inreg; wip_match_opcode 'G_ASHR'
     /* 4781 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner65),
     /* 4784 */ // Label 298: @4784
     /* 4784 */ GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(4795), // Rule ID 201 //
     /* 4789 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 4792 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_ASHR'
     /* 4792 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 4795 */ // Label 299: @4795
     /* 4795 */ GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(4806), // Rule ID 206 //
     /* 4800 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 4803 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_ASHR'
     /* 4803 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 4806 */ // Label 300: @4806
     /* 4806 */ GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(4817), // Rule ID 227 //
     /* 4811 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 4814 */   // Combiner Rule #164: bitfield_extract_from_shr; wip_match_opcode 'G_ASHR'
     /* 4814 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner102),
     /* 4817 */ // Label 301: @4817
     /* 4817 */ GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(4828), // Rule ID 229 //
     /* 4822 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 4825 */   // Combiner Rule #165: bitfield_extract_from_shr_and; wip_match_opcode 'G_ASHR'
     /* 4825 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 4828 */ // Label 302: @4828
     /* 4828 */ GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(4839), // Rule ID 234 //
     /* 4833 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 4836 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_ASHR'
     /* 4836 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 4839 */ // Label 303: @4839
     /* 4839 */ GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(4850), // Rule ID 286 //
     /* 4844 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 4847 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_ASHR'
     /* 4847 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 4850 */ // Label 304: @4850
     /* 4850 */ GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(4873), // Rule ID 109 //
     /* 4855 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 4858 */   // MIs[0] dst
     /* 4858 */   // No operand predicates
     /* 4858 */   // MIs[0] lhs
     /* 4858 */   // No operand predicates
     /* 4858 */   // MIs[0] Operand 2
     /* 4858 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4862 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4867 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[5]]
     /* 4867 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4872 */   GIR_EraseRootFromParent_Done,
     /* 4873 */ // Label 305: @4873
     /* 4873 */ GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(4884), // Rule ID 146 //
     /* 4878 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule105Enabled),
     /* 4881 */   // MIs[0] root
     /* 4881 */   // No operand predicates
     /* 4881 */   // MIs[0] mi.shifted
     /* 4881 */   // No operand predicates
     /* 4881 */   // MIs[0] mi.amt
     /* 4881 */   // No operand predicates
     /* 4881 */   // Combiner Rule #105: shifts_too_big @ [mi[1]]
     /* 4881 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 4884 */ // Label 306: @4884
     /* 4884 */ GIM_Reject,
     /* 4885 */ // Label 35: @4885
     /* 4885 */ GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(4896), // Rule ID 216 //
     /* 4890 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule155Enabled),
     /* 4893 */   // Combiner Rule #155: funnel_shift_to_rotate; wip_match_opcode 'G_FSHL'
     /* 4893 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner97),
     /* 4896 */ // Label 307: @4896
     /* 4896 */ GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(4907), // Rule ID 220 //
     /* 4901 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule158Enabled),
     /* 4904 */   // Combiner Rule #158: funnel_shift_overshift; wip_match_opcode 'G_FSHL'
     /* 4904 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner98),
     /* 4907 */ // Label 308: @4907
     /* 4907 */ GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(4927), // Rule ID 219 //
     /* 4912 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule157Enabled),
     /* 4915 */   // MIs[0] x
     /* 4915 */   // No operand predicates
     /* 4915 */   // MIs[0] y
     /* 4915 */   // No operand predicates
     /* 4915 */   // MIs[0] z
     /* 4915 */   // No operand predicates
     /* 4915 */   // MIs[0] Operand 3
     /* 4915 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 4919 */   // Combiner Rule #157: funnel_shift_left_zero
     /* 4919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 4922 */   GIR_RootToRootCopy, /*OpIdx*/0, // x
     /* 4924 */   GIR_RootToRootCopy, /*OpIdx*/1, // y
     /* 4926 */   GIR_EraseRootFromParent_Done,
     /* 4927 */ // Label 309: @4927
     /* 4927 */ GIM_Reject,
     /* 4928 */ // Label 36: @4928
     /* 4928 */ GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(4939), // Rule ID 217 //
     /* 4933 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule155Enabled),
     /* 4936 */   // Combiner Rule #155: funnel_shift_to_rotate; wip_match_opcode 'G_FSHR'
     /* 4936 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner97),
     /* 4939 */ // Label 310: @4939
     /* 4939 */ GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(4950), // Rule ID 221 //
     /* 4944 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule158Enabled),
     /* 4947 */   // Combiner Rule #158: funnel_shift_overshift; wip_match_opcode 'G_FSHR'
     /* 4947 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner98),
     /* 4950 */ // Label 311: @4950
     /* 4950 */ GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(4970), // Rule ID 218 //
     /* 4955 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule156Enabled),
     /* 4958 */   // MIs[0] x
     /* 4958 */   // No operand predicates
     /* 4958 */   // MIs[0] y
     /* 4958 */   // No operand predicates
     /* 4958 */   // MIs[0] z
     /* 4958 */   // No operand predicates
     /* 4958 */   // MIs[0] Operand 3
     /* 4958 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 4962 */   // Combiner Rule #156: funnel_shift_right_zero
     /* 4962 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 4965 */   GIR_RootToRootCopy, /*OpIdx*/0, // x
     /* 4967 */   GIR_RootToRootCopy, /*OpIdx*/2, // z
     /* 4969 */   GIR_EraseRootFromParent_Done,
     /* 4970 */ // Label 312: @4970
     /* 4970 */ GIM_Reject,
     /* 4971 */ // Label 37: @4971
     /* 4971 */ GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(4994), // Rule ID 113 //
     /* 4976 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 4979 */   // MIs[0] dst
     /* 4979 */   // No operand predicates
     /* 4979 */   // MIs[0] lhs
     /* 4979 */   // No operand predicates
     /* 4979 */   // MIs[0] Operand 2
     /* 4979 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4983 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4988 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[9]]
     /* 4988 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4993 */   GIR_EraseRootFromParent_Done,
     /* 4994 */ // Label 313: @4994
     /* 4994 */ GIM_Reject,
     /* 4995 */ // Label 38: @4995
     /* 4995 */ GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(5018), // Rule ID 112 //
     /* 5000 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 5003 */   // MIs[0] dst
     /* 5003 */   // No operand predicates
     /* 5003 */   // MIs[0] lhs
     /* 5003 */   // No operand predicates
     /* 5003 */   // MIs[0] Operand 2
     /* 5003 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 5007 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5012 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[8]]
     /* 5012 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5017 */   GIR_EraseRootFromParent_Done,
     /* 5018 */ // Label 314: @5018
     /* 5018 */ GIM_Reject,
     /* 5019 */ // Label 39: @5019
     /* 5019 */ GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(5030), // Rule ID 153 //
     /* 5024 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule111Enabled),
     /* 5027 */   // Combiner Rule #111: icmp_to_true_false_known_bits; wip_match_opcode 'G_ICMP'
     /* 5027 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner62),
     /* 5030 */ // Label 315: @5030
     /* 5030 */ GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(5041), // Rule ID 154 //
     /* 5035 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule112Enabled),
     /* 5038 */   // Combiner Rule #112: icmp_to_lhs_known_bits; wip_match_opcode 'G_ICMP'
     /* 5038 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner63),
     /* 5041 */ // Label 316: @5041
     /* 5041 */ GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(5052), // Rule ID 157 //
     /* 5046 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule115Enabled),
     /* 5049 */   // Combiner Rule #115: redundant_binop_in_equality; wip_match_opcode 'G_ICMP'
     /* 5049 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner64),
     /* 5052 */ // Label 317: @5052
     /* 5052 */ GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(5063), // Rule ID 151 //
     /* 5057 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule109Enabled),
     /* 5060 */   // MIs[0] root
     /* 5060 */   // No operand predicates
     /* 5060 */   // MIs[0] pred
     /* 5060 */   // No operand predicates
     /* 5060 */   // MIs[0] lhs
     /* 5060 */   // No operand predicates
     /* 5060 */   // MIs[0] rhs
     /* 5060 */   // No operand predicates
     /* 5060 */   // Combiner Rule #109: canonicalize_icmp
     /* 5060 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner60),
     /* 5063 */ // Label 318: @5063
     /* 5063 */ GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(5074), // Rule ID 363 //
     /* 5068 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule216Enabled),
     /* 5071 */   // MIs[0] dst
     /* 5071 */   // No operand predicates
     /* 5071 */   // MIs[0] tst
     /* 5071 */   // No operand predicates
     /* 5071 */   // MIs[0] src1
     /* 5071 */   // No operand predicates
     /* 5071 */   // MIs[0] src2
     /* 5071 */   // No operand predicates
     /* 5071 */   // Combiner Rule #216: icmp_redundant_trunc
     /* 5071 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner152),
     /* 5074 */ // Label 319: @5074
     /* 5074 */ GIM_Reject,
     /* 5075 */ // Label 40: @5075
     /* 5075 */ GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(5086), // Rule ID 152 //
     /* 5080 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule110Enabled),
     /* 5083 */   // MIs[0] root
     /* 5083 */   // No operand predicates
     /* 5083 */   // MIs[0] pred
     /* 5083 */   // No operand predicates
     /* 5083 */   // MIs[0] lhs
     /* 5083 */   // No operand predicates
     /* 5083 */   // MIs[0] rhs
     /* 5083 */   // No operand predicates
     /* 5083 */   // Combiner Rule #110: canonicalize_fcmp
     /* 5083 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner61),
     /* 5086 */ // Label 320: @5086
     /* 5086 */ GIM_Reject,
     /* 5087 */ // Label 41: @5087
     /* 5087 */ GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(5098), // Rule ID 103 //
     /* 5092 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 5095 */   // Combiner Rule #83: select_same_val; wip_match_opcode 'G_SELECT'
     /* 5095 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 5098 */ // Label 321: @5098
     /* 5098 */ GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(5109), // Rule ID 164 //
     /* 5103 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule122Enabled),
     /* 5106 */   // Combiner Rule #122: select_constant_cmp; wip_match_opcode 'G_SELECT'
     /* 5106 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner69),
     /* 5109 */ // Label 322: @5109
     /* 5109 */ GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(5120), // Rule ID 166 //
     /* 5114 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule124Enabled),
     /* 5117 */   // Combiner Rule #124: match_selects; wip_match_opcode 'G_SELECT'
     /* 5117 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner71),
     /* 5120 */ // Label 323: @5120
     /* 5120 */ GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(5131), // Rule ID 307 //
     /* 5125 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5128 */   // Combiner Rule #189: select_to_minmax; wip_match_opcode 'G_SELECT'
     /* 5128 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner125),
     /* 5131 */ // Label 324: @5131
     /* 5131 */ GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(5152), // Rule ID 165 //
     /* 5136 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule123Enabled),
     /* 5139 */   // MIs[0] root
     /* 5139 */   // No operand predicates
     /* 5139 */   // MIs[0] tst
     /* 5139 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5143 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 5147 */   // MIs[1] tst1
     /* 5147 */   // No operand predicates
     /* 5147 */   // MIs[1] a
     /* 5147 */   // No operand predicates
     /* 5147 */   // MIs[1] b
     /* 5147 */   // No operand predicates
     /* 5147 */   // MIs[0] x
     /* 5147 */   // No operand predicates
     /* 5147 */   // MIs[0] y
     /* 5147 */   // No operand predicates
     /* 5147 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5149 */   // Combiner Rule #123: select_to_iminmax
     /* 5149 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner70),
     /* 5152 */ // Label 325: @5152
     /* 5152 */ GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(5181), // Rule ID 163 //
     /* 5157 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule121Enabled),
     /* 5160 */   // MIs[0] dst
     /* 5160 */   // No operand predicates
     /* 5160 */   // MIs[0] undef
     /* 5160 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5164 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 5168 */   // MIs[0] x
     /* 5168 */   // No operand predicates
     /* 5168 */   // MIs[0] y
     /* 5168 */   // No operand predicates
     /* 5168 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
     /* 5173 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5175 */   // Combiner Rule #121: select_undef_cmp
     /* 5175 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
     /* 5180 */   GIR_EraseRootFromParent_Done,
     /* 5181 */ // Label 326: @5181
     /* 5181 */ GIM_Reject,
     /* 5182 */ // Label 42: @5182
     /* 5182 */ GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(5193), // Rule ID 318 //
     /* 5187 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5190 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDO'
     /* 5190 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5193 */ // Label 327: @5193
     /* 5193 */ GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(5204), // Rule ID 359 //
     /* 5198 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule213Enabled),
     /* 5201 */   // Combiner Rule #213: match_addos; wip_match_opcode 'G_UADDO'
     /* 5201 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner149),
     /* 5204 */ // Label 328: @5204
     /* 5204 */ GIM_Reject,
     /* 5205 */ // Label 43: @5205
     /* 5205 */ GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(5216), // Rule ID 189 //
     /* 5210 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 5213 */   // Combiner Rule #145: adde_to_addo; wip_match_opcode 'G_UADDE'
     /* 5213 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 5216 */ // Label 329: @5216
     /* 5216 */ GIM_Reject,
     /* 5217 */ // Label 44: @5217
     /* 5217 */ GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(5228), // Rule ID 361 //
     /* 5222 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule214Enabled),
     /* 5225 */   // Combiner Rule #214: match_subo_no_overflow; wip_match_opcode 'G_USUBO'
     /* 5225 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner150),
     /* 5228 */ // Label 330: @5228
     /* 5228 */ GIM_Reject,
     /* 5229 */ // Label 45: @5229
     /* 5229 */ GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(5240), // Rule ID 191 //
     /* 5234 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 5237 */   // Combiner Rule #145: adde_to_addo; wip_match_opcode 'G_USUBE'
     /* 5237 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 5240 */ // Label 331: @5240
     /* 5240 */ GIM_Reject,
     /* 5241 */ // Label 46: @5241
     /* 5241 */ GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(5252), // Rule ID 319 //
     /* 5246 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5249 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDO'
     /* 5249 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5252 */ // Label 332: @5252
     /* 5252 */ GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(5263), // Rule ID 358 //
     /* 5257 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule213Enabled),
     /* 5260 */   // Combiner Rule #213: match_addos; wip_match_opcode 'G_SADDO'
     /* 5260 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner149),
     /* 5263 */ // Label 333: @5263
     /* 5263 */ GIM_Reject,
     /* 5264 */ // Label 47: @5264
     /* 5264 */ GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(5275), // Rule ID 190 //
     /* 5269 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 5272 */   // Combiner Rule #145: adde_to_addo; wip_match_opcode 'G_SADDE'
     /* 5272 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 5275 */ // Label 334: @5275
     /* 5275 */ GIM_Reject,
     /* 5276 */ // Label 48: @5276
     /* 5276 */ GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(5287), // Rule ID 360 //
     /* 5281 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule214Enabled),
     /* 5284 */   // Combiner Rule #214: match_subo_no_overflow; wip_match_opcode 'G_SSUBO'
     /* 5284 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner150),
     /* 5287 */ // Label 335: @5287
     /* 5287 */ GIM_Reject,
     /* 5288 */ // Label 49: @5288
     /* 5288 */ GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(5299), // Rule ID 192 //
     /* 5293 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 5296 */   // Combiner Rule #145: adde_to_addo; wip_match_opcode 'G_SSUBE'
     /* 5296 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 5299 */ // Label 336: @5299
     /* 5299 */ GIM_Reject,
     /* 5300 */ // Label 50: @5300
     /* 5300 */ GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(5311), // Rule ID 185 //
     /* 5305 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 5308 */   // Combiner Rule #143: mulo_by_2; wip_match_opcode 'G_UMULO'
     /* 5308 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner85),
     /* 5311 */ // Label 337: @5311
     /* 5311 */ GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(5322), // Rule ID 187 //
     /* 5316 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 5319 */   // Combiner Rule #144: mulo_by_0; wip_match_opcode 'G_UMULO'
     /* 5319 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 5322 */ // Label 338: @5322
     /* 5322 */ GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(5333), // Rule ID 320 //
     /* 5327 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5330 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULO'
     /* 5330 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5333 */ // Label 339: @5333
     /* 5333 */ GIM_Reject,
     /* 5334 */ // Label 51: @5334
     /* 5334 */ GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(5345), // Rule ID 186 //
     /* 5339 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 5342 */   // Combiner Rule #143: mulo_by_2; wip_match_opcode 'G_SMULO'
     /* 5342 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner85),
     /* 5345 */ // Label 340: @5345
     /* 5345 */ GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(5356), // Rule ID 188 //
     /* 5350 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 5353 */   // Combiner Rule #144: mulo_by_0; wip_match_opcode 'G_SMULO'
     /* 5353 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 5356 */ // Label 341: @5356
     /* 5356 */ GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(5367), // Rule ID 321 //
     /* 5361 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5364 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULO'
     /* 5364 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5367 */ // Label 342: @5367
     /* 5367 */ GIM_Reject,
     /* 5368 */ // Label 52: @5368
     /* 5368 */ GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(5379), // Rule ID 259 //
     /* 5373 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule171Enabled),
     /* 5376 */   // Combiner Rule #171: mulh_to_lshr; wip_match_opcode 'G_UMULH'
     /* 5376 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner108),
     /* 5379 */ // Label 343: @5379
     /* 5379 */ GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(5390), // Rule ID 322 //
     /* 5384 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5387 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULH'
     /* 5387 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5390 */ // Label 344: @5390
     /* 5390 */ GIM_Reject,
     /* 5391 */ // Label 53: @5391
     /* 5391 */ GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(5402), // Rule ID 323 //
     /* 5396 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5399 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULH'
     /* 5399 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5402 */ // Label 345: @5402
     /* 5402 */ GIM_Reject,
     /* 5403 */ // Label 54: @5403
     /* 5403 */ GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(5414), // Rule ID 324 //
     /* 5408 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5411 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDSAT'
     /* 5411 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5414 */ // Label 346: @5414
     /* 5414 */ GIM_Reject,
     /* 5415 */ // Label 55: @5415
     /* 5415 */ GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(5426), // Rule ID 325 //
     /* 5420 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5423 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDSAT'
     /* 5423 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5426 */ // Label 347: @5426
     /* 5426 */ GIM_Reject,
     /* 5427 */ // Label 56: @5427
     /* 5427 */ GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(5438), // Rule ID 204 //
     /* 5432 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 5435 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_USHLSAT'
     /* 5435 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 5438 */ // Label 348: @5438
     /* 5438 */ GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(5449), // Rule ID 208 //
     /* 5443 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 5446 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_USHLSAT'
     /* 5446 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 5449 */ // Label 349: @5449
     /* 5449 */ GIM_Reject,
     /* 5450 */ // Label 57: @5450
     /* 5450 */ GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(5461), // Rule ID 203 //
     /* 5455 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 5458 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_SSHLSAT'
     /* 5458 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 5461 */ // Label 350: @5461
     /* 5461 */ GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(5472), // Rule ID 209 //
     /* 5466 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 5469 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_SSHLSAT'
     /* 5469 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 5472 */ // Label 351: @5472
     /* 5472 */ GIM_Reject,
     /* 5473 */ // Label 58: @5473
     /* 5473 */ GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(5484), // Rule ID 326 //
     /* 5478 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5481 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIX'
     /* 5481 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5484 */ // Label 352: @5484
     /* 5484 */ GIM_Reject,
     /* 5485 */ // Label 59: @5485
     /* 5485 */ GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(5496), // Rule ID 327 //
     /* 5490 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5493 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIX'
     /* 5493 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5496 */ // Label 353: @5496
     /* 5496 */ GIM_Reject,
     /* 5497 */ // Label 60: @5497
     /* 5497 */ GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(5508), // Rule ID 328 //
     /* 5502 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5505 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIXSAT'
     /* 5505 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5508 */ // Label 354: @5508
     /* 5508 */ GIM_Reject,
     /* 5509 */ // Label 61: @5509
     /* 5509 */ GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(5520), // Rule ID 329 //
     /* 5514 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5517 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIXSAT'
     /* 5517 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5520 */ // Label 355: @5520
     /* 5520 */ GIM_Reject,
     /* 5521 */ // Label 62: @5521
     /* 5521 */ GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(5532), // Rule ID 249 //
     /* 5526 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 5529 */   // Combiner Rule #167: constant_fold_fp_binop; wip_match_opcode 'G_FADD'
     /* 5529 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5532 */ // Label 356: @5532
     /* 5532 */ GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(5543), // Rule ID 260 //
     /* 5537 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule172Enabled),
     /* 5540 */   // Combiner Rule #172: redundant_neg_operands; wip_match_opcode 'G_FADD'
     /* 5540 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner109),
     /* 5543 */ // Label 357: @5543
     /* 5543 */ GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(5554), // Rule ID 267 //
     /* 5548 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule174Enabled),
     /* 5551 */   // Combiner Rule #174: combine_fadd_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5551 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner111),
     /* 5554 */ // Label 358: @5554
     /* 5554 */ GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(5565), // Rule ID 268 //
     /* 5559 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule175Enabled),
     /* 5562 */   // Combiner Rule #175: combine_fadd_fpext_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5562 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5565 */ // Label 359: @5565
     /* 5565 */ GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(5576), // Rule ID 269 //
     /* 5570 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5573 */   // Combiner Rule #176: combine_fadd_fma_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5573 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5576 */ // Label 360: @5576
     /* 5576 */ GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(5587), // Rule ID 270 //
     /* 5581 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule177Enabled),
     /* 5584 */   // Combiner Rule #177: combine_fadd_fpext_fma_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5584 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner114),
     /* 5587 */ // Label 361: @5587
     /* 5587 */ GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(5598), // Rule ID 293 //
     /* 5592 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 5595 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_FADD'
     /* 5595 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 5598 */ // Label 362: @5598
     /* 5598 */ GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(5609), // Rule ID 330 //
     /* 5603 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 5606 */   // Combiner Rule #192: commute_fp_constant_to_rhs; wip_match_opcode 'G_FADD'
     /* 5606 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 5609 */ // Label 363: @5609
     /* 5609 */ GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(5632), // Rule ID 138 //
     /* 5614 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule100Enabled),
     /* 5617 */   // MIs[0] dst
     /* 5617 */   // No operand predicates
     /* 5617 */   // MIs[0] x
     /* 5617 */   // No operand predicates
     /* 5617 */   // MIs[0] y
     /* 5617 */   // No operand predicates
     /* 5617 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner3),
     /* 5621 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5626 */   // Combiner Rule #100: right_identity_neg_zero_fp
     /* 5626 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5631 */   GIR_EraseRootFromParent_Done,
     /* 5632 */ // Label 364: @5632
     /* 5632 */ GIM_Reject,
     /* 5633 */ // Label 63: @5633
     /* 5633 */ GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(5644), // Rule ID 250 //
     /* 5638 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 5641 */   // Combiner Rule #167: constant_fold_fp_binop; wip_match_opcode 'G_FSUB'
     /* 5641 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5644 */ // Label 365: @5644
     /* 5644 */ GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(5655), // Rule ID 261 //
     /* 5649 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule172Enabled),
     /* 5652 */   // Combiner Rule #172: redundant_neg_operands; wip_match_opcode 'G_FSUB'
     /* 5652 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner109),
     /* 5655 */ // Label 366: @5655
     /* 5655 */ GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(5666), // Rule ID 271 //
     /* 5660 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule178Enabled),
     /* 5663 */   // Combiner Rule #178: combine_fsub_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5663 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner115),
     /* 5666 */ // Label 367: @5666
     /* 5666 */ GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(5677), // Rule ID 272 //
     /* 5671 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule179Enabled),
     /* 5674 */   // Combiner Rule #179: combine_fsub_fneg_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5674 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner116),
     /* 5677 */ // Label 368: @5677
     /* 5677 */ GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(5688), // Rule ID 273 //
     /* 5682 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule180Enabled),
     /* 5685 */   // Combiner Rule #180: combine_fsub_fpext_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5685 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner117),
     /* 5688 */ // Label 369: @5688
     /* 5688 */ GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(5699), // Rule ID 274 //
     /* 5693 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule181Enabled),
     /* 5696 */   // Combiner Rule #181: combine_fsub_fpext_fneg_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5696 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner118),
     /* 5699 */ // Label 370: @5699
     /* 5699 */ GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(5710), // Rule ID 294 //
     /* 5704 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 5707 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_FSUB'
     /* 5707 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 5710 */ // Label 371: @5710
     /* 5710 */ GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(5721), // Rule ID 308 //
     /* 5715 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5718 */   // Combiner Rule #190: fsub_to_fneg; wip_match_opcode 'G_FSUB'
     /* 5718 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5721 */ // Label 372: @5721
     /* 5721 */ GIM_Reject,
     /* 5722 */ // Label 64: @5722
     /* 5722 */ GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(5733), // Rule ID 251 //
     /* 5727 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 5730 */   // Combiner Rule #167: constant_fold_fp_binop; wip_match_opcode 'G_FMUL'
     /* 5730 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5733 */ // Label 373: @5733
     /* 5733 */ GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(5744), // Rule ID 262 //
     /* 5738 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule172Enabled),
     /* 5741 */   // Combiner Rule #172: redundant_neg_operands; wip_match_opcode 'G_FMUL'
     /* 5741 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner109),
     /* 5744 */ // Label 374: @5744
     /* 5744 */ GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(5755), // Rule ID 292 //
     /* 5749 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 5752 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_FMUL'
     /* 5752 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 5755 */ // Label 375: @5755
     /* 5755 */ GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(5766), // Rule ID 331 //
     /* 5760 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 5763 */   // Combiner Rule #192: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMUL'
     /* 5763 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 5766 */ // Label 376: @5766
     /* 5766 */ GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(5789), // Rule ID 129 //
     /* 5771 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule93Enabled),
     /* 5774 */   // MIs[0] dst
     /* 5774 */   // No operand predicates
     /* 5774 */   // MIs[0] x
     /* 5774 */   // No operand predicates
     /* 5774 */   // MIs[0] y
     /* 5774 */   // No operand predicates
     /* 5774 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner2),
     /* 5778 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5783 */   // Combiner Rule #93: right_identity_one_fp
     /* 5783 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5788 */   GIR_EraseRootFromParent_Done,
     /* 5789 */ // Label 377: @5789
     /* 5789 */ GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(5809), // Rule ID 139 //
     /* 5794 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule101Enabled),
     /* 5797 */   // MIs[0] dst
     /* 5797 */   // No operand predicates
     /* 5797 */   // MIs[0] x
     /* 5797 */   // No operand predicates
     /* 5797 */   // MIs[0] y
     /* 5797 */   // No operand predicates
     /* 5797 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner4),
     /* 5801 */   // Combiner Rule #101: right_identity_neg_one_fp
     /* 5801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 5804 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 5806 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 5808 */   GIR_EraseRootFromParent_Done,
     /* 5809 */ // Label 378: @5809
     /* 5809 */ GIM_Reject,
     /* 5810 */ // Label 65: @5810
     /* 5810 */ GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(5821), // Rule ID 254 //
     /* 5815 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule168Enabled),
     /* 5818 */   // Combiner Rule #168: constant_fold_fma; wip_match_opcode 'G_FMA'
     /* 5818 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 5821 */ // Label 379: @5821
     /* 5821 */ GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(5832), // Rule ID 265 //
     /* 5826 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule172Enabled),
     /* 5829 */   // Combiner Rule #172: redundant_neg_operands; wip_match_opcode 'G_FMA'
     /* 5829 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner109),
     /* 5832 */ // Label 380: @5832
     /* 5832 */ GIM_Reject,
     /* 5833 */ // Label 66: @5833
     /* 5833 */ GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(5844), // Rule ID 253 //
     /* 5838 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule168Enabled),
     /* 5841 */   // Combiner Rule #168: constant_fold_fma; wip_match_opcode 'G_FMAD'
     /* 5841 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 5844 */ // Label 381: @5844
     /* 5844 */ GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(5855), // Rule ID 264 //
     /* 5849 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule172Enabled),
     /* 5852 */   // Combiner Rule #172: redundant_neg_operands; wip_match_opcode 'G_FMAD'
     /* 5852 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner109),
     /* 5855 */ // Label 382: @5855
     /* 5855 */ GIM_Reject,
     /* 5856 */ // Label 67: @5856
     /* 5856 */ GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(5867), // Rule ID 252 //
     /* 5861 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 5864 */   // Combiner Rule #167: constant_fold_fp_binop; wip_match_opcode 'G_FDIV'
     /* 5864 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5867 */ // Label 383: @5867
     /* 5867 */ GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(5878), // Rule ID 263 //
     /* 5872 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule172Enabled),
     /* 5875 */   // Combiner Rule #172: redundant_neg_operands; wip_match_opcode 'G_FDIV'
     /* 5875 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner109),
     /* 5878 */ // Label 384: @5878
     /* 5878 */ GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(5889), // Rule ID 295 //
     /* 5883 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 5886 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_FDIV'
     /* 5886 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 5889 */ // Label 385: @5889
     /* 5889 */ GIM_Reject,
     /* 5890 */ // Label 68: @5890
     /* 5890 */ GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(5901), // Rule ID 296 //
     /* 5895 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 5898 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_FREM'
     /* 5898 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 5901 */ // Label 386: @5901
     /* 5901 */ GIM_Reject,
     /* 5902 */ // Label 69: @5902
     /* 5902 */ GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(5923), // Rule ID 197 //
     /* 5907 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule147Enabled),
     /* 5910 */   // MIs[0] dst
     /* 5910 */   // No operand predicates
     /* 5910 */   // MIs[0] float
     /* 5910 */   // No operand predicates
     /* 5910 */   // MIs[0] int
     /* 5910 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 5914 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 5918 */   // MIs[1] imm
     /* 5918 */   // No operand predicates
     /* 5918 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5920 */   // Combiner Rule #147: expand_const_fpowi
     /* 5920 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner89),
     /* 5923 */ // Label 387: @5923
     /* 5923 */ GIM_Reject,
     /* 5924 */ // Label 70: @5924
     /* 5924 */ GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(5945), // Rule ID 179 //
     /* 5929 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule137Enabled),
     /* 5932 */   // MIs[0] dst
     /* 5932 */   // No operand predicates
     /* 5932 */   // MIs[0] src0
     /* 5932 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5936 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5940 */   // MIs[1] cst
     /* 5940 */   // No operand predicates
     /* 5940 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5942 */   // Combiner Rule #137: constant_fold_flog2
     /* 5942 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 5945 */ // Label 388: @5945
     /* 5945 */ GIM_Reject,
     /* 5946 */ // Label 71: @5946
     /* 5946 */ GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(5967), // Rule ID 176 //
     /* 5951 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule134Enabled),
     /* 5954 */   // MIs[0] dst
     /* 5954 */   // No operand predicates
     /* 5954 */   // MIs[0] src0
     /* 5954 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5958 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5962 */   // MIs[1] cst
     /* 5962 */   // No operand predicates
     /* 5962 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5964 */   // Combiner Rule #134: constant_fold_fneg
     /* 5964 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 5967 */ // Label 389: @5967
     /* 5967 */ GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(5996), // Rule ID 127 //
     /* 5972 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule91Enabled),
     /* 5975 */   // MIs[0] dst
     /* 5975 */   // No operand predicates
     /* 5975 */   // MIs[0] t
     /* 5975 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5979 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 5983 */   // MIs[1] src
     /* 5983 */   // No operand predicates
     /* 5983 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 5988 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5990 */   // Combiner Rule #91: fneg_fneg_fold
     /* 5990 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 5995 */   GIR_EraseRootFromParent_Done,
     /* 5996 */ // Label 390: @5996
     /* 5996 */ GIM_Reject,
     /* 5997 */ // Label 72: @5997
     /* 5997 */ GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(6018), // Rule ID 180 //
     /* 6002 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule138Enabled),
     /* 6005 */   // MIs[0] dst
     /* 6005 */   // No operand predicates
     /* 6005 */   // MIs[0] src0
     /* 6005 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6009 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 6013 */   // MIs[1] cst
     /* 6013 */   // No operand predicates
     /* 6013 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6015 */   // Combiner Rule #138: constant_fold_fptrunc
     /* 6015 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 6018 */ // Label 391: @6018
     /* 6018 */ GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(6039), // Rule ID 137 //
     /* 6023 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule99Enabled),
     /* 6026 */   // MIs[0] dst
     /* 6026 */   // No operand predicates
     /* 6026 */   // MIs[0] src1
     /* 6026 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6030 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPEXT),
     /* 6034 */   // MIs[1] src0
     /* 6034 */   // No operand predicates
     /* 6034 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6036 */   // Combiner Rule #99: fptrunc_fpext_fold
     /* 6036 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner52),
     /* 6039 */ // Label 392: @6039
     /* 6039 */ GIM_Reject,
     /* 6040 */ // Label 73: @6040
     /* 6040 */ GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(6061), // Rule ID 92 //
     /* 6045 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 6048 */   // MIs[0] dst
     /* 6048 */   // No operand predicates
     /* 6048 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 6048 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6052 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6056 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6058 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[5]]
     /* 6058 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 6061 */ // Label 393: @6061
     /* 6061 */ GIM_Reject,
     /* 6062 */ // Label 74: @6062
     /* 6062 */ GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(6083), // Rule ID 93 //
     /* 6067 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 6070 */   // MIs[0] dst
     /* 6070 */   // No operand predicates
     /* 6070 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 6070 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6074 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6078 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6080 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[6]]
     /* 6080 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 6083 */ // Label 394: @6083
     /* 6083 */ GIM_Reject,
     /* 6084 */ // Label 75: @6084
     /* 6084 */ GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(6095), // Rule ID 76 //
     /* 6089 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule71Enabled),
     /* 6092 */   // Combiner Rule #71: undef_to_fp_zero; wip_match_opcode 'G_SITOFP'
     /* 6092 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner33),
     /* 6095 */ // Label 395: @6095
     /* 6095 */ GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(6110), // Rule ID 181 //
     /* 6100 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule139Enabled),
     /* 6103 */   // MIs[0] dst
     /* 6103 */   // No operand predicates
     /* 6103 */   // MIs[0] Operand 1
     /* 6103 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 6107 */   // Combiner Rule #139: itof_const_zero_fold_si
     /* 6107 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner82),
     /* 6110 */ // Label 396: @6110
     /* 6110 */ GIM_Reject,
     /* 6111 */ // Label 76: @6111
     /* 6111 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(6122), // Rule ID 75 //
     /* 6116 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule71Enabled),
     /* 6119 */   // Combiner Rule #71: undef_to_fp_zero; wip_match_opcode 'G_UITOFP'
     /* 6119 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner33),
     /* 6122 */ // Label 397: @6122
     /* 6122 */ GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(6137), // Rule ID 182 //
     /* 6127 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule140Enabled),
     /* 6130 */   // MIs[0] dst
     /* 6130 */   // No operand predicates
     /* 6130 */   // MIs[0] Operand 1
     /* 6130 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 6134 */   // Combiner Rule #140: itof_const_zero_fold_ui
     /* 6134 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner82),
     /* 6137 */ // Label 398: @6137
     /* 6137 */ GIM_Reject,
     /* 6138 */ // Label 77: @6138
     /* 6138 */ GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(6167), // Rule ID 19 //
     /* 6143 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 6146 */   // MIs[0] dst
     /* 6146 */   // No operand predicates
     /* 6146 */   // MIs[0] src
     /* 6146 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6150 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 6154 */   // MIs[1] __idempotent_prop_match_0.x
     /* 6154 */   // No operand predicates
     /* 6154 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6159 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6161 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[1]]
     /* 6161 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6166 */   GIR_EraseRootFromParent_Done,
     /* 6167 */ // Label 399: @6167
     /* 6167 */ GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(6188), // Rule ID 177 //
     /* 6172 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule135Enabled),
     /* 6175 */   // MIs[0] dst
     /* 6175 */   // No operand predicates
     /* 6175 */   // MIs[0] src0
     /* 6175 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6179 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 6183 */   // MIs[1] cst
     /* 6183 */   // No operand predicates
     /* 6183 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6185 */   // Combiner Rule #135: constant_fold_fabs
     /* 6185 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 6188 */ // Label 400: @6188
     /* 6188 */ GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(6216), // Rule ID 258 //
     /* 6193 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule170Enabled),
     /* 6196 */   // MIs[0] dst
     /* 6196 */   // No operand predicates
     /* 6196 */   // MIs[0] tmp
     /* 6196 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6200 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 6204 */   // MIs[1] x
     /* 6204 */   // No operand predicates
     /* 6204 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6206 */   // Combiner Rule #170: fabs_fneg_fold
     /* 6206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FABS),
     /* 6209 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 6211 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // x
     /* 6215 */   GIR_EraseRootFromParent_Done,
     /* 6216 */ // Label 401: @6216
     /* 6216 */ GIM_Reject,
     /* 6217 */ // Label 78: @6217
     /* 6217 */ GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(6246), // Rule ID 20 //
     /* 6222 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 6225 */   // MIs[0] dst
     /* 6225 */   // No operand predicates
     /* 6225 */   // MIs[0] src
     /* 6225 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6229 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 6233 */   // MIs[1] __idempotent_prop_match_0.x
     /* 6233 */   // No operand predicates
     /* 6233 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6238 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6240 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[2]]
     /* 6240 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6245 */   GIR_EraseRootFromParent_Done,
     /* 6246 */ // Label 402: @6246
     /* 6246 */ GIM_Reject,
     /* 6247 */ // Label 79: @6247
     /* 6247 */ GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(6258), // Rule ID 193 //
     /* 6252 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 6255 */   // Combiner Rule #146: combine_minmax_nan; wip_match_opcode 'G_FMINNUM'
     /* 6255 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 6258 */ // Label 403: @6258
     /* 6258 */ GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(6269), // Rule ID 297 //
     /* 6263 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 6266 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_FMINNUM'
     /* 6266 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 6269 */ // Label 404: @6269
     /* 6269 */ GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(6280), // Rule ID 332 //
     /* 6274 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 6277 */   // Combiner Rule #192: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM'
     /* 6277 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6280 */ // Label 405: @6280
     /* 6280 */ GIM_Reject,
     /* 6281 */ // Label 80: @6281
     /* 6281 */ GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(6292), // Rule ID 194 //
     /* 6286 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 6289 */   // Combiner Rule #146: combine_minmax_nan; wip_match_opcode 'G_FMAXNUM'
     /* 6289 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 6292 */ // Label 406: @6292
     /* 6292 */ GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(6303), // Rule ID 298 //
     /* 6297 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 6300 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_FMAXNUM'
     /* 6300 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 6303 */ // Label 407: @6303
     /* 6303 */ GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(6314), // Rule ID 333 //
     /* 6308 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 6311 */   // Combiner Rule #192: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM'
     /* 6311 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6314 */ // Label 408: @6314
     /* 6314 */ GIM_Reject,
     /* 6315 */ // Label 81: @6315
     /* 6315 */ GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(6326), // Rule ID 334 //
     /* 6320 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 6323 */   // Combiner Rule #192: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM_IEEE'
     /* 6323 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6326 */ // Label 409: @6326
     /* 6326 */ GIM_Reject,
     /* 6327 */ // Label 82: @6327
     /* 6327 */ GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(6338), // Rule ID 335 //
     /* 6332 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 6335 */   // Combiner Rule #192: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM_IEEE'
     /* 6335 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6338 */ // Label 410: @6338
     /* 6338 */ GIM_Reject,
     /* 6339 */ // Label 83: @6339
     /* 6339 */ GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(6350), // Rule ID 195 //
     /* 6344 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 6347 */   // Combiner Rule #146: combine_minmax_nan; wip_match_opcode 'G_FMINIMUM'
     /* 6347 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 6350 */ // Label 411: @6350
     /* 6350 */ GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(6361), // Rule ID 299 //
     /* 6355 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 6358 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_FMINIMUM'
     /* 6358 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 6361 */ // Label 412: @6361
     /* 6361 */ GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(6372), // Rule ID 336 //
     /* 6366 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 6369 */   // Combiner Rule #192: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINIMUM'
     /* 6369 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6372 */ // Label 413: @6372
     /* 6372 */ GIM_Reject,
     /* 6373 */ // Label 84: @6373
     /* 6373 */ GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(6384), // Rule ID 196 //
     /* 6378 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 6381 */   // Combiner Rule #146: combine_minmax_nan; wip_match_opcode 'G_FMAXIMUM'
     /* 6381 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 6384 */ // Label 414: @6384
     /* 6384 */ GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(6395), // Rule ID 300 //
     /* 6389 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 6392 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_FMAXIMUM'
     /* 6392 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 6395 */ // Label 415: @6395
     /* 6395 */ GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(6406), // Rule ID 337 //
     /* 6400 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 6403 */   // Combiner Rule #192: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXIMUM'
     /* 6403 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6406 */ // Label 416: @6406
     /* 6406 */ GIM_Reject,
     /* 6407 */ // Label 85: @6407
     /* 6407 */ GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(6418), // Rule ID 148 //
     /* 6412 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule106Enabled),
     /* 6415 */   // Combiner Rule #106: reassoc_ptradd; wip_match_opcode 'G_PTR_ADD'
     /* 6415 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner57),
     /* 6418 */ // Label 417: @6418
     /* 6418 */ GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(6429), // Rule ID 150 //
     /* 6423 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule108Enabled),
     /* 6426 */   // Combiner Rule #108: ptr_add_immed_chain; wip_match_opcode 'G_PTR_ADD'
     /* 6426 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner59),
     /* 6429 */ // Label 418: @6429
     /* 6429 */ GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(6440), // Rule ID 183 //
     /* 6434 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule141Enabled),
     /* 6437 */   // Combiner Rule #141: const_ptradd_to_i2p; wip_match_opcode 'G_PTR_ADD'
     /* 6437 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner83),
     /* 6440 */ // Label 419: @6440
     /* 6440 */ GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(6451), // Rule ID 199 //
     /* 6445 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 6448 */   // Combiner Rule #149: ptr_add_with_zero; wip_match_opcode 'G_PTR_ADD'
     /* 6448 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 6451 */ // Label 420: @6451
     /* 6451 */ GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(6462), // Rule ID 232 //
     /* 6456 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 6459 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_PTR_ADD'
     /* 6459 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 6462 */ // Label 421: @6462
     /* 6462 */ GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(6473), // Rule ID 277 //
     /* 6467 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 6470 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_PTR_ADD'
     /* 6470 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 6473 */ // Label 422: @6473
     /* 6473 */ GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(6496), // Rule ID 111 //
     /* 6478 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 6481 */   // MIs[0] dst
     /* 6481 */   // No operand predicates
     /* 6481 */   // MIs[0] lhs
     /* 6481 */   // No operand predicates
     /* 6481 */   // MIs[0] Operand 2
     /* 6481 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 6485 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6490 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[7]]
     /* 6490 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6495 */   GIR_EraseRootFromParent_Done,
     /* 6496 */ // Label 423: @6496
     /* 6496 */ GIM_Reject,
     /* 6497 */ // Label 86: @6497
     /* 6497 */ GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(6508), // Rule ID 245 //
     /* 6502 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 6505 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SMIN'
     /* 6505 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 6508 */ // Label 424: @6508
     /* 6508 */ GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(6519), // Rule ID 288 //
     /* 6513 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 6516 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_SMIN'
     /* 6516 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 6519 */ // Label 425: @6519
     /* 6519 */ GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(6530), // Rule ID 314 //
     /* 6524 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 6527 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_SMIN'
     /* 6527 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6530 */ // Label 426: @6530
     /* 6530 */ GIM_Reject,
     /* 6531 */ // Label 87: @6531
     /* 6531 */ GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(6542), // Rule ID 246 //
     /* 6536 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 6539 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SMAX'
     /* 6539 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 6542 */ // Label 427: @6542
     /* 6542 */ GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(6553), // Rule ID 289 //
     /* 6547 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 6550 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_SMAX'
     /* 6550 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 6553 */ // Label 428: @6553
     /* 6553 */ GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(6564), // Rule ID 315 //
     /* 6558 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 6561 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_SMAX'
     /* 6561 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6564 */ // Label 429: @6564
     /* 6564 */ GIM_Reject,
     /* 6565 */ // Label 88: @6565
     /* 6565 */ GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(6576), // Rule ID 247 //
     /* 6570 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 6573 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_UMIN'
     /* 6573 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 6576 */ // Label 430: @6576
     /* 6576 */ GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(6587), // Rule ID 290 //
     /* 6581 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 6584 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_UMIN'
     /* 6584 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 6587 */ // Label 431: @6587
     /* 6587 */ GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(6598), // Rule ID 316 //
     /* 6592 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 6595 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_UMIN'
     /* 6595 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6598 */ // Label 432: @6598
     /* 6598 */ GIM_Reject,
     /* 6599 */ // Label 89: @6599
     /* 6599 */ GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(6610), // Rule ID 248 //
     /* 6604 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 6607 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_UMAX'
     /* 6607 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 6610 */ // Label 433: @6610
     /* 6610 */ GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(6621), // Rule ID 291 //
     /* 6615 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 6618 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_UMAX'
     /* 6618 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 6621 */ // Label 434: @6621
     /* 6621 */ GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(6632), // Rule ID 317 //
     /* 6626 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 6629 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_UMAX'
     /* 6629 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6632 */ // Label 435: @6632
     /* 6632 */ GIM_Reject,
     /* 6633 */ // Label 90: @6633
     /* 6633 */ GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(6644), // Rule ID 86 //
     /* 6638 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 6641 */   // Combiner Rule #76: unary_undef_to_zero; wip_match_opcode 'G_ABS'
     /* 6641 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 6644 */ // Label 436: @6644
     /* 6644 */ GIM_Reject,
     /* 6645 */ // Label 91: @6645
     /* 6645 */ GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(6656), // Rule ID 175 //
     /* 6650 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule133Enabled),
     /* 6653 */   // Combiner Rule #133: opt_brcond_by_inverting_cond; wip_match_opcode 'G_BR'
     /* 6653 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 6656 */ // Label 437: @6656
     /* 6656 */ GIM_Reject,
     /* 6657 */ // Label 92: @6657
     /* 6657 */ GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(6668), // Rule ID 26 //
     /* 6662 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 6665 */   // Combiner Rule #24: insert_vector_elt_oob; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 6665 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner10),
     /* 6668 */ // Label 438: @6668
     /* 6668 */ GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(6679), // Rule ID 67 //
     /* 6673 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule65Enabled),
     /* 6676 */   // Combiner Rule #65: combine_insert_vec_elts_build_vector; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 6676 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner27),
     /* 6679 */ // Label 439: @6679
     /* 6679 */ GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(6690), // Rule ID 101 //
     /* 6684 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule82Enabled),
     /* 6687 */   // Combiner Rule #82: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 6687 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner43),
     /* 6690 */ // Label 440: @6690
     /* 6690 */ GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(6729), // Rule ID 38 //
     /* 6695 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule36Enabled),
     /* 6698 */   // MIs[0] root
     /* 6698 */   // No operand predicates
     /* 6698 */   // MIs[0] src
     /* 6698 */   // No operand predicates
     /* 6698 */   // MIs[0] elt
     /* 6698 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 6702 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 6706 */   // MIs[1] src
     /* 6706 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 6711 */   // MIs[1] idx
     /* 6711 */   // No operand predicates
     /* 6711 */   // MIs[0] idx
     /* 6711 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 6716 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6721 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6723 */   // Combiner Rule #36: insert_vector_element_extract_vector_element
     /* 6723 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6728 */   GIR_EraseRootFromParent_Done,
     /* 6729 */ // Label 441: @6729
     /* 6729 */ GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(6762), // Rule ID 24 //
     /* 6734 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule22Enabled),
     /* 6737 */   // MIs[0] root
     /* 6737 */   // No operand predicates
     /* 6737 */   // MIs[0] src
     /* 6737 */   // No operand predicates
     /* 6737 */   // MIs[0] elt
     /* 6737 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 6741 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6745 */   // MIs[0] idx
     /* 6745 */   // No operand predicates
     /* 6745 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner0),
     /* 6749 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6754 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6756 */   // Combiner Rule #22: insert_vector_element_elt_undef
     /* 6756 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6761 */   GIR_EraseRootFromParent_Done,
     /* 6762 */ // Label 442: @6762
     /* 6762 */ GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(6786), // Rule ID 23 //
     /* 6767 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule21Enabled),
     /* 6770 */   // MIs[0] root
     /* 6770 */   // No operand predicates
     /* 6770 */   // MIs[0] src
     /* 6770 */   // No operand predicates
     /* 6770 */   // MIs[0] elt
     /* 6770 */   // No operand predicates
     /* 6770 */   // MIs[0] idx
     /* 6770 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 6774 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6778 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6780 */   // Combiner Rule #21: insert_vector_element_idx_undef
     /* 6780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6783 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 6785 */   GIR_EraseRootFromParent_Done,
     /* 6786 */ // Label 443: @6786
     /* 6786 */ GIM_Reject,
     /* 6787 */ // Label 93: @6787
     /* 6787 */ GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(6798), // Rule ID 25 //
     /* 6792 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 6795 */   // Combiner Rule #23: match_extract_of_element; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6795 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner9),
     /* 6798 */ // Label 444: @6798
     /* 6798 */ GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(6809), // Rule ID 68 //
     /* 6803 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule66Enabled),
     /* 6806 */   // Combiner Rule #66: extract_vec_elt_build_vec; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6806 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner28),
     /* 6809 */ // Label 445: @6809
     /* 6809 */ GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(6820), // Rule ID 74 //
     /* 6814 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule70Enabled),
     /* 6817 */   // Combiner Rule #70: combine_extracted_vector_load; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6817 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner32),
     /* 6820 */ // Label 446: @6820
     /* 6820 */ GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(6831), // Rule ID 102 //
     /* 6825 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule82Enabled),
     /* 6828 */   // Combiner Rule #82: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6828 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner43),
     /* 6831 */ // Label 447: @6831
     /* 6831 */ GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(6855), // Rule ID 36 //
     /* 6836 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule34Enabled),
     /* 6839 */   // MIs[0] root
     /* 6839 */   // No operand predicates
     /* 6839 */   // MIs[0] src
     /* 6839 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6843 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6847 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/9,
     /* 6850 */   // MIs[1] x
     /* 6850 */   // No operand predicates
     /* 6850 */   // MIs[1] y
     /* 6850 */   // No operand predicates
     /* 6850 */   // MIs[1] z
     /* 6850 */   // No operand predicates
     /* 6850 */   // MIs[1] a
     /* 6850 */   // No operand predicates
     /* 6850 */   // MIs[1] b
     /* 6850 */   // No operand predicates
     /* 6850 */   // MIs[1] c
     /* 6850 */   // No operand predicates
     /* 6850 */   // MIs[1] d
     /* 6850 */   // No operand predicates
     /* 6850 */   // MIs[1] e
     /* 6850 */   // No operand predicates
     /* 6850 */   // MIs[0] idx
     /* 6850 */   // No operand predicates
     /* 6850 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6852 */   // Combiner Rule #34: extract_vector_element_build_vector_trunc8
     /* 6852 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6855 */ // Label 448: @6855
     /* 6855 */ GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(6879), // Rule ID 35 //
     /* 6860 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule33Enabled),
     /* 6863 */   // MIs[0] root
     /* 6863 */   // No operand predicates
     /* 6863 */   // MIs[0] src
     /* 6863 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6867 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6871 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/8,
     /* 6874 */   // MIs[1] x
     /* 6874 */   // No operand predicates
     /* 6874 */   // MIs[1] y
     /* 6874 */   // No operand predicates
     /* 6874 */   // MIs[1] z
     /* 6874 */   // No operand predicates
     /* 6874 */   // MIs[1] a
     /* 6874 */   // No operand predicates
     /* 6874 */   // MIs[1] b
     /* 6874 */   // No operand predicates
     /* 6874 */   // MIs[1] c
     /* 6874 */   // No operand predicates
     /* 6874 */   // MIs[1] d
     /* 6874 */   // No operand predicates
     /* 6874 */   // MIs[0] idx
     /* 6874 */   // No operand predicates
     /* 6874 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6876 */   // Combiner Rule #33: extract_vector_element_build_vector_trunc7
     /* 6876 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6879 */ // Label 449: @6879
     /* 6879 */ GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(6903), // Rule ID 34 //
     /* 6884 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule32Enabled),
     /* 6887 */   // MIs[0] root
     /* 6887 */   // No operand predicates
     /* 6887 */   // MIs[0] src
     /* 6887 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6891 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6895 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/7,
     /* 6898 */   // MIs[1] x
     /* 6898 */   // No operand predicates
     /* 6898 */   // MIs[1] y
     /* 6898 */   // No operand predicates
     /* 6898 */   // MIs[1] z
     /* 6898 */   // No operand predicates
     /* 6898 */   // MIs[1] a
     /* 6898 */   // No operand predicates
     /* 6898 */   // MIs[1] b
     /* 6898 */   // No operand predicates
     /* 6898 */   // MIs[1] c
     /* 6898 */   // No operand predicates
     /* 6898 */   // MIs[0] idx
     /* 6898 */   // No operand predicates
     /* 6898 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6900 */   // Combiner Rule #32: extract_vector_element_build_vector_trunc6
     /* 6900 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6903 */ // Label 450: @6903
     /* 6903 */ GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(6927), // Rule ID 33 //
     /* 6908 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule31Enabled),
     /* 6911 */   // MIs[0] root
     /* 6911 */   // No operand predicates
     /* 6911 */   // MIs[0] src
     /* 6911 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6915 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6919 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/6,
     /* 6922 */   // MIs[1] x
     /* 6922 */   // No operand predicates
     /* 6922 */   // MIs[1] y
     /* 6922 */   // No operand predicates
     /* 6922 */   // MIs[1] z
     /* 6922 */   // No operand predicates
     /* 6922 */   // MIs[1] a
     /* 6922 */   // No operand predicates
     /* 6922 */   // MIs[1] b
     /* 6922 */   // No operand predicates
     /* 6922 */   // MIs[0] idx
     /* 6922 */   // No operand predicates
     /* 6922 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6924 */   // Combiner Rule #31: extract_vector_element_build_vector_trunc5
     /* 6924 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6927 */ // Label 451: @6927
     /* 6927 */ GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(6951), // Rule ID 32 //
     /* 6932 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule30Enabled),
     /* 6935 */   // MIs[0] root
     /* 6935 */   // No operand predicates
     /* 6935 */   // MIs[0] src
     /* 6935 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6939 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6943 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/5,
     /* 6946 */   // MIs[1] x
     /* 6946 */   // No operand predicates
     /* 6946 */   // MIs[1] y
     /* 6946 */   // No operand predicates
     /* 6946 */   // MIs[1] z
     /* 6946 */   // No operand predicates
     /* 6946 */   // MIs[1] a
     /* 6946 */   // No operand predicates
     /* 6946 */   // MIs[0] idx
     /* 6946 */   // No operand predicates
     /* 6946 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6948 */   // Combiner Rule #30: extract_vector_element_build_vector_trunc4
     /* 6948 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6951 */ // Label 452: @6951
     /* 6951 */ GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(6975), // Rule ID 31 //
     /* 6956 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule29Enabled),
     /* 6959 */   // MIs[0] root
     /* 6959 */   // No operand predicates
     /* 6959 */   // MIs[0] src
     /* 6959 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6963 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6967 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 6970 */   // MIs[1] x
     /* 6970 */   // No operand predicates
     /* 6970 */   // MIs[1] y
     /* 6970 */   // No operand predicates
     /* 6970 */   // MIs[1] z
     /* 6970 */   // No operand predicates
     /* 6970 */   // MIs[0] idx
     /* 6970 */   // No operand predicates
     /* 6970 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6972 */   // Combiner Rule #29: extract_vector_element_build_vector_trunc3
     /* 6972 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6975 */ // Label 453: @6975
     /* 6975 */ GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(7009), // Rule ID 27 //
     /* 6980 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 6983 */   // MIs[0] root
     /* 6983 */   // No operand predicates
     /* 6983 */   // MIs[0] src
     /* 6983 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6987 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INSERT_VECTOR_ELT),
     /* 6991 */   // MIs[1] x
     /* 6991 */   // No operand predicates
     /* 6991 */   // MIs[1] value
     /* 6991 */   // No operand predicates
     /* 6991 */   // MIs[1] idx
     /* 6991 */   // No operand predicates
     /* 6991 */   // MIs[0] idx
     /* 6991 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/3,
     /* 6996 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/2,
     /* 7001 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7003 */   // Combiner Rule #25: extract_vector_element_not_const
     /* 7003 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/2,
     /* 7008 */   GIR_EraseRootFromParent_Done,
     /* 7009 */ // Label 454: @7009
     /* 7009 */ GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(7030), // Rule ID 28 //
     /* 7014 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule26Enabled),
     /* 7017 */   // MIs[0] root
     /* 7017 */   // No operand predicates
     /* 7017 */   // MIs[0] src
     /* 7017 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7021 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INSERT_VECTOR_ELT),
     /* 7025 */   // MIs[1] x
     /* 7025 */   // No operand predicates
     /* 7025 */   // MIs[1] value
     /* 7025 */   // No operand predicates
     /* 7025 */   // MIs[1] idx2
     /* 7025 */   // No operand predicates
     /* 7025 */   // MIs[0] idx1
     /* 7025 */   // No operand predicates
     /* 7025 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7027 */   // Combiner Rule #26: extract_vector_element_different_indices
     /* 7027 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner11),
     /* 7030 */ // Label 455: @7030
     /* 7030 */ GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(7059), // Rule ID 37 //
     /* 7035 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule35Enabled),
     /* 7038 */   // MIs[0] root
     /* 7038 */   // No operand predicates
     /* 7038 */   // MIs[0] src
     /* 7038 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7042 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHUFFLE_VECTOR),
     /* 7046 */   // MIs[1] src1
     /* 7046 */   // No operand predicates
     /* 7046 */   // MIs[1] src2
     /* 7046 */   // No operand predicates
     /* 7046 */   // MIs[1] mask
     /* 7046 */   // No operand predicates
     /* 7046 */   // MIs[0] idx
     /* 7046 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 7050 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 7054 */   // MIs[2] imm
     /* 7054 */   // No operand predicates
     /* 7054 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 7056 */   // Combiner Rule #35: extract_vector_element_shuffle_vector
     /* 7056 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 7059 */ // Label 456: @7059
     /* 7059 */ GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(7083), // Rule ID 30 //
     /* 7064 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule28Enabled),
     /* 7067 */   // MIs[0] root
     /* 7067 */   // No operand predicates
     /* 7067 */   // MIs[0] src
     /* 7067 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7071 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 7075 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 7078 */   // MIs[1] x
     /* 7078 */   // No operand predicates
     /* 7078 */   // MIs[1] y
     /* 7078 */   // No operand predicates
     /* 7078 */   // MIs[0] idx
     /* 7078 */   // No operand predicates
     /* 7078 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7080 */   // Combiner Rule #28: extract_vector_element_build_vector_trunc2
     /* 7080 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 7083 */ // Label 457: @7083
     /* 7083 */ GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(7115), // Rule ID 29 //
     /* 7088 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule27Enabled),
     /* 7091 */   // MIs[0] root
     /* 7091 */   // No operand predicates
     /* 7091 */   // MIs[0] src
     /* 7091 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7095 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 7099 */   GIM_CheckNumOperandsGE, /*MI*/1, /*Expected*/2,
     /* 7102 */   // MIs[1] unused
     /* 7102 */   // No operand predicates
     /* 7102 */   // MIs[0] idx
     /* 7102 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 7106 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 7110 */   // MIs[2] imm
     /* 7110 */   // No operand predicates
     /* 7110 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 7112 */   // Combiner Rule #27: extract_vector_element_build_vector
     /* 7112 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner12),
     /* 7115 */ // Label 458: @7115
     /* 7115 */ GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(7139), // Rule ID 21 //
     /* 7120 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule19Enabled),
     /* 7123 */   // MIs[0] root
     /* 7123 */   // No operand predicates
     /* 7123 */   // MIs[0] vector
     /* 7123 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7127 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 7131 */   // MIs[0] idx
     /* 7131 */   // No operand predicates
     /* 7131 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7133 */   // Combiner Rule #19: match_extract_of_element_undef_vector
     /* 7133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 7136 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 7138 */   GIR_EraseRootFromParent_Done,
     /* 7139 */ // Label 459: @7139
     /* 7139 */ GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(7163), // Rule ID 22 //
     /* 7144 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule20Enabled),
     /* 7147 */   // MIs[0] root
     /* 7147 */   // No operand predicates
     /* 7147 */   // MIs[0] vector
     /* 7147 */   // No operand predicates
     /* 7147 */   // MIs[0] idx
     /* 7147 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 7151 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 7155 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7157 */   // Combiner Rule #20: match_extract_of_element_undef_index
     /* 7157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 7160 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 7162 */   GIR_EraseRootFromParent_Done,
     /* 7163 */ // Label 460: @7163
     /* 7163 */ GIM_Reject,
     /* 7164 */ // Label 94: @7164
     /* 7164 */ GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(7175), // Rule ID 97 //
     /* 7169 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule79Enabled),
     /* 7172 */   // Combiner Rule #79: propagate_undef_all_ops; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 7172 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner40),
     /* 7175 */ // Label 461: @7175
     /* 7175 */ GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(7186), // Rule ID 99 //
     /* 7180 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule80Enabled),
     /* 7183 */   // Combiner Rule #80: propagate_undef_shuffle_mask; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 7183 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner41),
     /* 7186 */ // Label 462: @7186
     /* 7186 */ GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(7197), // Rule ID 345 //
     /* 7191 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule200Enabled),
     /* 7194 */   // Combiner Rule #200: combine_shuffle_concat; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 7194 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner136),
     /* 7197 */ // Label 463: @7197
     /* 7197 */ GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(7208), // Rule ID 347 //
     /* 7202 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule202Enabled),
     /* 7205 */   // Combiner Rule #202: combine_shuffle_disjoint_mask; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 7205 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner138),
     /* 7208 */ // Label 464: @7208
     /* 7208 */ GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(7219), // Rule ID 365 //
     /* 7213 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule218Enabled),
     /* 7216 */   // Combiner Rule #218: shuffle_to_extract; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 7216 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner154),
     /* 7219 */ // Label 465: @7219
     /* 7219 */ GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(7240), // Rule ID 346 //
     /* 7224 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule201Enabled),
     /* 7227 */   // MIs[0] root
     /* 7227 */   // No operand predicates
     /* 7227 */   // MIs[0] src1
     /* 7227 */   // No operand predicates
     /* 7227 */   // MIs[0] undef
     /* 7227 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 7231 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 7235 */   // MIs[0] mask
     /* 7235 */   // No operand predicates
     /* 7235 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7237 */   // Combiner Rule #201: combine_shuffle_undef_rhs
     /* 7237 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner137),
     /* 7240 */ // Label 466: @7240
     /* 7240 */ GIM_Reject,
     /* 7241 */ // Label 95: @7241
     /* 7241 */ GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(7285), // Rule ID 223 //
     /* 7246 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule160Enabled),
     /* 7249 */   // MIs[0] d
     /* 7249 */   // No operand predicates
     /* 7249 */   // MIs[0] src
     /* 7249 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7253 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 7257 */   // MIs[1] rev
     /* 7257 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 7261 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITREVERSE),
     /* 7265 */   // MIs[2] val
     /* 7265 */   // No operand predicates
     /* 7265 */   // MIs[1] amt
     /* 7265 */   // No operand predicates
     /* 7265 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner9),
     /* 7269 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 7271 */   // Combiner Rule #160: bitreverse_lshr
     /* 7271 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SHL),
     /* 7274 */   GIR_RootToRootCopy, /*OpIdx*/0, // d
     /* 7276 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 7280 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // amt
     /* 7284 */   GIR_EraseRootFromParent_Done,
     /* 7285 */ // Label 467: @7285
     /* 7285 */ GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(7329), // Rule ID 222 //
     /* 7290 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule159Enabled),
     /* 7293 */   // MIs[0] d
     /* 7293 */   // No operand predicates
     /* 7293 */   // MIs[0] src
     /* 7293 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7297 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 7301 */   // MIs[1] rev
     /* 7301 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 7305 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITREVERSE),
     /* 7309 */   // MIs[2] val
     /* 7309 */   // No operand predicates
     /* 7309 */   // MIs[1] amt
     /* 7309 */   // No operand predicates
     /* 7309 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner8),
     /* 7313 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 7315 */   // Combiner Rule #159: bitreverse_shl
     /* 7315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 7318 */   GIR_RootToRootCopy, /*OpIdx*/0, // d
     /* 7320 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 7324 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // amt
     /* 7328 */   GIR_EraseRootFromParent_Done,
     /* 7329 */ // Label 468: @7329
     /* 7329 */ GIM_Reject,
     /* 7330 */ // Label 96: @7330
     /* 7330 */ GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(7351), // Rule ID 178 //
     /* 7335 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule136Enabled),
     /* 7338 */   // MIs[0] dst
     /* 7338 */   // No operand predicates
     /* 7338 */   // MIs[0] src0
     /* 7338 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7342 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 7346 */   // MIs[1] cst
     /* 7346 */   // No operand predicates
     /* 7346 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7348 */   // Combiner Rule #136: constant_fold_fsqrt
     /* 7348 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 7351 */ // Label 469: @7351
     /* 7351 */ GIM_Reject,
     /* 7352 */ // Label 97: @7352
     /* 7352 */ GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(7366), // Rule ID 366 //
     /* 7357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 7360 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule219Enabled),
     /* 7363 */   // Combiner Rule #219: ext_addv_to_udot_addv; wip_match_opcode 'G_VECREDUCE_ADD'
     /* 7363 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner155),
     /* 7366 */ // Label 470: @7366
     /* 7366 */ GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(7377), // Rule ID 367 //
     /* 7371 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule220Enabled),
     /* 7374 */   // Combiner Rule #220: ext_uaddv_to_uaddlv; wip_match_opcode 'G_VECREDUCE_ADD'
     /* 7374 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner156),
     /* 7377 */ // Label 471: @7377
     /* 7377 */ GIM_Reject,
     /* 7378 */ // Label 98: @7378
     /* 7378 */ GIM_Reject,
     /* 7379 */ }; // Size: 7379 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GICOMBINER_IMPL

#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS

